/*************************************************************************

                          st0rm SGE Source Code

                          (c)1998 David Sanchez
                           st0rm@melodysoft.com

                        Released on 17th March 1999
        

Este codigo fuente lo puedes utilizar para:

- Usarlo como fuente de informacin para tus proyectos.
- Continuar el proyecto st0rm.
- Empezar un emulador desde 0 teniendo este como base.

Lo nico que pido si te es util y lo usas, es que lo menciones en tu
proyecto.

Tendras que perdonarme la falta de comentarios y el desorden total,
aun asi puede ser util.


COMENTARIOS EN README.TXT

*************************************************************************/


#include <dos.h>
#include <stdio.h>
#include <malloc.h>
#include <conio.h>
#include <time.h>
#include <mem.h>
#include <time.h>
#include "vga.h"
#include "misc.h"
#include "header.h"
#include "st0rm.h"
#include "m68k.h"
#include "m68misc.h"
#include "vdp.h"
#include "genio.h"
#include "uclock.h"
#include "vesa20.h"
#include "sound.h"
#include "gui.h"
#include "z80.h"


struct _st0rm_cfg_      st0rm_cfg;
Mem                     mem;
GUISystem              *GUI;



void           *rom_ptr;
void           *z80ram_ptr      = (void *)mem.ram.z80_ram;
void           *ram_ptr         = (void *)mem.ram.ram_space;

char            log_flg         = 0;
char            loge_flg        = 0;
FILE           *log_file;

char            flg_stop        = 0;    // Trash
char            flg_debug       = 0;    // Trash

char            vesa_flg        = 1;
u_long          gedea_cnt       = 0;    // Trash

char           *hw_versions[]   = { "Japan", "Europe", "USA" };
extern          u_char          st0rmBackground[];


#define         ST0RM_VERSION   "v0.10 beta"

void ExitAndDump (void);
void GoodBye ();

u_long          rom_loaded      = 0;
char            emu_path[320];


FLAG LoadROM (char *path);

char GiveRomExt (char *file);
void LoadBinRom (FILE *file);
void LoadSmdRom (FILE *file);


void RunGenesisZ80 (void);

void st0rmDefaultOptions (void);
void InitGUI (void);
void StartGUI (void);
void ShutDownGUI (void);

void LoadROMDialog (GUISystem *gui_system);
void ResetConfig (GUISystem *gui_system);
void AboutDialog (GUISystem *gui_system);


void main (int argc, char *argv[]) {

  FILE                 *file;
  int                   n_argc          = 1;
  char                  pass_arg;
  char                  z80_flg         = 0;


  printf ("\nst0rm SGE (Sega Genesis Emulator) "ST0RM_VERSION" R98.05.13\n");
  printf ("\nby David Snchez Primo");
  printf ("\n(c)1998 Melody Software            melody@mx2.redestb.es\n");
  printf ("\nBeta public release. Distribute freely.\n");

  strcpy (emu_path, getcwd (NULL, 0));

  st0rmDefaultOptions ();

  if (!stricmp (argv[1], "-?") || !stricmp (argv[1], "-h")) {

        printf ("\n\nUsage: st0rm [options] [rom_name].[SMD/BIN]\n");
        printf ("\nOptions:");
        printf ("\n-? / -h      displays this help screen");
        printf ("\n-frame x     sets frame skip (0=Auto)        0-4");
        printf ("\n-nocheck     disable checksum fix");
        printf ("\n-novesa      forces mode 13h, 320x200");
        printf ("\n-nfcopy      disables fpu copy");
        printf ("\n-fast        faster sometimes");
        printf ("\n-raster      enable raster effects           F12");
        printf ("\n-z80         enables Z80 emulation");
        printf ("\n-wsync       wait v-sync");
        printf ("\n-usa         hardware version = USA");
        printf ("\n-europe      hardware version = EUROPE       (default: Auto Version)");
        printf ("\n-japan       hardware version = JAPAN\n");
        printf ("\nst0rm without params starts with the GUI\n");
        exit (255);
  }

  while (1) {

        pass_arg = 0;

        if (argv[n_argc][0] != '-') break;

        if (!stricmp (argv[n_argc], "-debug")) {
                pass_arg = 1;
        }

#ifdef ST0RM_LOG
        if (!stricmp (argv[n_argc], "-log")) {
                pass_arg = 1;
                log_flg = 1;
        }

        if (!stricmp (argv[n_argc], "-loge")) {
                pass_arg = 1;
                loge_flg = 1;
        }
#endif

        if (!stricmp (argv[n_argc], "-nocheck")) {
                pass_arg = 1;
                st0rm_cfg.checksums = 0;
        }

        if (!stricmp (argv[n_argc], "-z80")) {
                pass_arg = 1;
                z80_flg = 1;
        }

        if (!stricmp (argv[n_argc], "-wsync")) {
                pass_arg = 1;
                wait_sync = ~wait_sync;
                timing_enable = ~timing_enable;
                frame_skip = 1;
        }

        if (!stricmp (argv[n_argc], "-novesa")) {
                pass_arg = 1;
                vesa_flg = 0;
        }

        if (!stricmp (argv[n_argc], "-fast")) {
                pass_arg = 1;
                vdp_run = 70;   // 7000
        }

        if (!stricmp (argv[n_argc], "-raster")) {
                pass_arg = 1;
                st0rm_cfg.raster_effects = (u_char)~0;
        }

        if (!stricmp (argv[n_argc], "-usa")) {
                pass_arg = 1;
                st0rm_cfg.version = 2;
        }

        if (!stricmp (argv[n_argc], "-europe")) {
                pass_arg = 1;
                st0rm_cfg.version = 1;
        }

        if (!stricmp (argv[n_argc], "-japan")) {
                pass_arg = 1;
                st0rm_cfg.version = 0;
        }

        if (!stricmp (argv[n_argc], "-frame")) {
                pass_arg = 1;
                n_argc++;
                st0rm_cfg.frame_skip = atoi (argv[n_argc]);
                if (!st0rm_cfg.frame_skip) st0rm_cfg.frame_skip = 0;
        }

        if (!pass_arg) printf ("\nUnknown option: %s\n", argv[n_argc]);

        n_argc++;
  }

  MachineSetup ();

  printf ("\n%s\n", env_id);

  if (!vesa_flg)
        printf ("\nUsing mode 13h ...");

  else {

        if ((vesa_flg = Vesa20Setup ()) == 0)
                printf ("\n%s", VESA20.id);
        else
                printf ("\nVesa 2.0 not found. Using mode 13h ...");

        vesa_flg = ((vesa_flg) ? 0 : 1);
  }

  if (InitSB(22050))
        printf ("\nSoundBlaster detected at Port %X IRQ %d DMA %d\n",
                snd.sb_port, snd.sb_irq, snd.sb_dma);
  else
        printf ("\nSoundBlaster not detected, sound disabled\n");

  printf ("\nPlease Wait ... setting up ...\n");

  Init68000 (0);                                // MAME 68K

#ifdef ST0RM_LOG
  if (log_flg || loge_flg) log_file = fopen ("st0rm.log", "wb");

  PrintELog ("*** ST0RM LOG FILE ***");
#endif

  if (!vesa_flg)
        Mode13 (1);
  else {
        if (Vesa20SetVideoMode (320, 240, 8)) {
                vesa_flg = 0;
                Vesa20CloseVideoMode ();
                printf ("\nUnable to initialize VESA mode\n");
                Mode13 (1);

        } else {

                Vesa20ClearMem ();
                Vesa20ClearPage (0);
        }
  }
                     
  InstKbIntr();

  InitGUI ();

  if (argc > 1) {
        if (LoadROM (argv[n_argc])) rom_loaded = 1;
  }

  while (!rom_loaded) StartGUI ();

  rom_loaded = 0;

  if (!z80_flg)
        RunGenesis ();
  else
        RunGenesisZ80 ();
  ExitNow ();
}

void ExitNow (void) {

  ShutDownGUI ();

  if (!vesa_flg)
        Mode13 (0);
  else {
        Mode13 (0);
        Vesa20CloseVideoMode ();
  }

  RemoveKbIntr();

  PrintRegsStdio ();

  free (mem.rom_space);

#ifdef ST0RM_LOG
  PrintELog ("*** END OF LOG FILE ***");
  if (log_flg || loge_flg) fclose (log_file);
#endif

  ShutDownSB ();

  exit (0);
}

void GoodBye () {

  ShutDownGUI ();

  if (!vesa_flg)
        Mode13 (0);
  else {
        Mode13 (0);
        Vesa20CloseVideoMode ();
  }

  RemoveKbIntr();

  free (mem.rom_space);

#ifdef ST0RM_LOG
  PrintELog ("*** END OF LOG FILE ***");
  if (log_flg || loge_flg) fclose (log_file);
#endif

  ShutDownSB ();

  printf ("\nThanks for using st0rm SGE "ST0RM_VERSION"\n");
  printf ("\nby David Snchez Primo");
  printf ("\n(c)1998 Melody Software ELDA (Alicante, Spain)");
  printf ("\nmelody@mx2.redestb.es\n");
  printf ("\nCheck latest version at:");
  printf ("\nhttp://personal.redestb.es/melody\n\n");
  printf ("\nConfig file saved.\n");

  chdir (emu_path);

  exit (0);
}

void ExitAndDump (void) {

  printf ("\nESC pressed.\n");
  DumpMem ();
  ExitNow ();
}

char GiveRomExt (char *file) {

  char         *p;
  char         *s;

  if ((p = strchr (file, '.')) == NULL) return 0;

  while (1) {
        s = p;
        if ((p = strchr (p+1, '.')) == NULL) {
                p = s;
                break;
        }
  }

  if (!stricmp (p+1, "BIN")) return 1;
  if (!stricmp (p+1, "SMD")) return 2;

  return 3;
}

void LoadBinRom (FILE *file) {

  if (!fread ((char *) mem.rom_space, mem.rom_size, 1, file)) {
        printf ("\nUnable to load rom.\n");
        exit (255);
  }
}

void LoadSmdRom (FILE *file) {

  char         *buf1;
  char         *buf2;
  char         *p               = mem.rom_space;
  char         *b1;
  char         *b2;
  int           cnt;

  fseek (file, 0x200L, SEEK_SET);

  buf1 = (char *) malloc (0x2000);
  buf2 = (char *) malloc (0x2000);

  do {
        if (!fread ((char *) buf1, 0x2000L, 1, file)) break;
        if (!fread ((char *) buf2, 0x2000L, 1, file)) break;

        b1      = buf1;
        b2      = buf2;

        for (cnt = 0; cnt < 0x2000; cnt++) {
                *p++ = *b2++;
                *p++ = *b1++;
        }

  } while (!feof (file));

  free (buf1);
  free (buf2);

}

void st0rmDefaultOptions (void) {

  st0rm_cfg.frame_skip          = 0;
  st0rm_cfg.raster_effects      = 0;
  st0rm_cfg.h_scrl              = (u_char)~0;
  st0rm_cfg.window              = (u_char)~0;
  st0rm_cfg.scrl_a              = (u_char)~0;
  st0rm_cfg.scrl_b              = (u_char)~0;
  st0rm_cfg.sprs                = (u_char)~0;

  st0rm_cfg.z80                 = (u_char)~0;
  st0rm_cfg.dac                 = (u_char)~0;

  st0rm_cfg.checksums           = (u_char)~0;
  st0rm_cfg.wait_sync           = 0;
  st0rm_cfg.fpu_copy            = (u_char)~0;

  st0rm_cfg.version             = 3;

  strcpy (st0rm_cfg.rom_path, getcwd (NULL, 0));
}

void InitGUI (void) {

  MenuGUI      *menu_vdp;
  MenuGUI      *menu_io;
  MenuGUI      *menu_fskip;
  MenuGUI      *menu_misc;
  MenuGUI      *menu_sound;
  MenuGUI      *menu_control;
  MenuGUI      *menu_version;


  GUI = InitGUISystem (336, 240, vid_buffer, ShowVGAFull, 320, 224);

  menu_vdp = MakeMenuGUI (GUI, 120, 92);
  AddMarkMenuGUI  (menu_vdp, "Raster Effects", &st0rm_cfg.raster_effects);
  AddMarkMenuGUI  (menu_vdp, "H-Line Scroll", &st0rm_cfg.h_scrl);
  AddSepMenuGUI   (menu_vdp);
  AddMarkMenuGUI  (menu_vdp, "Window Plane", &st0rm_cfg.window);
  AddMarkMenuGUI  (menu_vdp, "Scroll A Plane", &st0rm_cfg.scrl_a);
  AddMarkMenuGUI  (menu_vdp, "Scroll B Plane", &st0rm_cfg.scrl_b);
  AddMarkMenuGUI  (menu_vdp, "Sprites", &st0rm_cfg.sprs);

  menu_sound = MakeMenuGUI (GUI, 120, 42);
  AddMarkMenuGUI  (menu_sound, "Z80 Emulation", &st0rm_cfg.z80);
  AddSepMenuGUI   (menu_sound);
  AddMarkMenuGUI  (menu_sound, "DAC output", &st0rm_cfg.dac);

  menu_fskip = MakeMenuGUI (GUI, 60, 92);
  AddSelMenuGUI   (menu_fskip, "Auto", &st0rm_cfg.frame_skip, 0);
  AddSepMenuGUI   (menu_fskip);
  AddSelMenuGUI   (menu_fskip, "None", &st0rm_cfg.frame_skip, 1);
  AddSelMenuGUI   (menu_fskip, "2", &st0rm_cfg.frame_skip, 2);
  AddSelMenuGUI   (menu_fskip, "3", &st0rm_cfg.frame_skip, 3);
  AddSelMenuGUI   (menu_fskip, "4", &st0rm_cfg.frame_skip, 4);
  AddSelMenuGUI   (menu_fskip, "5", &st0rm_cfg.frame_skip, 5);
  
  menu_misc = MakeMenuGUI (GUI, 120, 92);
  AddLinkMenuGUI  (menu_misc, "Frame Skip", menu_fskip);
  AddMarkMenuGUI  (menu_misc, "Checksum fixer", &st0rm_cfg.checksums);
  AddSepMenuGUI   (menu_misc);
  AddMarkMenuGUI  (menu_misc, "Wait Sync", &st0rm_cfg.wait_sync);
  AddMarkMenuGUI  (menu_misc, "FPU Copy", &st0rm_cfg.fpu_copy);
  AddSepMenuGUI   (menu_misc);
  AddPlainMenuGUI (menu_misc, "Reset Config", ResetConfig);

  menu_control = MakeMenuGUI (GUI, 90, 32);
  AddPlainMenuGUI (menu_control, "Player 1", NULL);
  AddPlainMenuGUI (menu_control, "Player 2", NULL);

  menu_version = MakeMenuGUI (GUI, 90, 68);
  AddSelMenuGUI (menu_version, "Japan", &st0rm_cfg.version, 0);
  AddSelMenuGUI (menu_version, "Europe", &st0rm_cfg.version, 1);
  AddSelMenuGUI (menu_version, "USA", &st0rm_cfg.version, 2);
  AddSepMenuGUI (menu_version);
  AddSelMenuGUI (menu_version, "Auto", &st0rm_cfg.version, 3);

  menu_io = MakeMenuGUI (GUI, 110, 56);
  AddLinkMenuGUI  (menu_io, "Control", menu_control);
  AddLinkMenuGUI  (menu_io, "Version", menu_version);
  AddSepMenuGUI   (menu_io);
  AddPlainMenuGUI (menu_io, "Reset Genesis", NULL);

  GUI->menu_gui = MakeMenuGUI (GUI, 94, 140);
  AddPlainMenuGUI (GUI->menu_gui, "Load ROM", LoadROMDialog);
  AddPlainMenuGUI (GUI->menu_gui, "Load State", NULL);
  AddPlainMenuGUI (GUI->menu_gui, "Save State", NULL);
  AddSepMenuGUI   (GUI->menu_gui);
  AddLinkMenuGUI  (GUI->menu_gui, "I/O", menu_io);
  AddLinkMenuGUI  (GUI->menu_gui, "VDP", menu_vdp);
  AddLinkMenuGUI  (GUI->menu_gui, "Sound", menu_sound);
  AddLinkMenuGUI  (GUI->menu_gui, "Misc", menu_misc);
  AddSepMenuGUI   (GUI->menu_gui);
  AddPlainMenuGUI (GUI->menu_gui, "About...", AboutDialog);
  AddPlainMenuGUI (GUI->menu_gui, "Exit", GoodBye);
}

void StartGUI (void) {

  PutPCXBackgGUI (GUI, st0rmBackground);
  DrawTextGUI (GUI, 100, 205, "st0rm SGE "ST0RM_VERSION);
  SetBackgGUI (GUI);

  RunMenuGUI (GUI->menu_gui, 20, 48, MAIN_MENU);

  FreeBackgGUI (GUI);
  memset (vid_buffer, 0, 0x15000);
  ShowVGAFull ();
  DoCRAM ();
}


void ShutDownGUI (void) {

  FreeMenuGUI (GUI->menu_gui);
  FreeGUISystem (GUI);
}

void LoadROMDialog (GUISystem *gui_system) {

  DialogGUI    *lrom_dlg;
  SelFileDlg   *sel_file;
  char          rom_path[360];

  lrom_dlg      = MakeDialogGUI (gui_system, "Load ROM", 140, 160);

  sel_file      = CSelFileDlg (15, 10, 98, 125, st0rm_cfg.rom_path,
                               "*.smd,*.bin");

  AddDialogGUI (lrom_dlg, D_SELFILE, sel_file);
  AddDialogGUI (lrom_dlg, D_BUTTON,
        CButtonDlg (14, 142, 50, "Ok", DB_OK, NULL));
  AddDialogGUI (lrom_dlg, D_BUTTON,
        CButtonDlg (75, 142, 50, "Cancel", DB_CANCEL, NULL));

  DrawDialogGUI (lrom_dlg, 0, 0);

  if (RunDialogGUI (lrom_dlg)) {

        sprintf (rom_path, "%s\\%s", sel_file->path,
                            sel_file->file_info.name);
        strcpy (st0rm_cfg.rom_path, sel_file->path);

        gui_system->menu_gui->exit              = 1;
        if (LoadROM (rom_path)) rom_loaded      = 1;
  }

  FreeDialogGUI (lrom_dlg);
}

void ResetConfig (GUISystem *gui_system) {

  st0rmDefaultOptions();

  MessageBox (gui_system, "st0rm SGE config resetted", DB_OK);
}

void AboutDialog (GUISystem *gui_system) {

  DialogGUI    *about_dlg;

  about_dlg     = MakeDialogGUI (gui_system, "About", 200, 50);

  AddDialogGUI (about_dlg, D_TEXT,
        CTextDlg (5, 5, FONTHCOLOR, "st0rm SGE "ST0RM_VERSION));
  AddDialogGUI (about_dlg, D_TEXT,
        CTextDlg (5, 22, 15, "By David Sanchez Primo"));
  AddDialogGUI (about_dlg, D_TEXT,
        CTextDlg (5, 32, 15, "(c)1998 Melody Software"));

  DrawDialogGUI (about_dlg, 0, 0);
  RunDialogGUI (about_dlg);
  FreeDialogGUI (about_dlg);
}

FLAG LoadROM (char *path) {

  RomHeader     rom_header;
  FILE         *file;
  char          t_rom;
  u_long        pos_tmp;
  u_char       *tmp_ptr;
  s_short      *ptr_check;
  s_short       check                   = 0;
  long          cnt;

  switch ((t_rom = GiveRomExt (path))) {

        case 0 :
                 PrintELog ("Failed to load ROM: No Ext Given.");
                 return 0;
        case 3 :
                 PrintELog ("Failed to load ROM: Invalid Ext Given.");
                 return 0;
  }

  if ((file = fopen (path, "rb")) == NULL) {
        PrintELog ("Failed to load ROM.");
        return 0;
  }

  fseek (file, 0L, SEEK_END);
  pos_tmp = ftell (file);
  fseek (file, 0L, SEEK_SET);

  mem.rom_size = pos_tmp - ((t_rom == 2) ? 0x200 : 0);

  if (mem.rom_space) free (mem.rom_space);

  if ((mem.rom_space = (char *) malloc (mem.rom_size)) == NULL) {
        PrintELog ("No enough memory to load ROM.");
        fclose (file);
        return 0;
  }

  memset ((char *) mem.rom_space, 0xff, mem.rom_size);
  memset ((char *) &mem.ram, 0, sizeof (struct static_ram));

  switch (t_rom) {
        case 1 :
                 LoadBinRom (file);
                 break;
        case 2 :
                 LoadSmdRom (file);
                 break;
  }

  memcpy ((char *) &rom_header, mem.rom_space, sizeof (RomHeader));

  fclose (file);

  memset (&regs, 0, sizeof (regs));
  memset (&vdp, 0, sizeof (vdp));
  memset (&io, 0, sizeof (io));
  memset (&gen_snd, 0, sizeof (gen_snd));

  Init68000 (0);
  Z80_Reset ();

  PrintELog ("Rom Name       : %-.48s", rom_header.name_dom);
  PrintELog ("               : %-.48s", rom_header.name_over);
  PrintELog ("Rom Version    : %-.14s", rom_header.version);
  PrintELog ("Checksum       : %04XH", (u_short)RorShort (rom_header.checksum));
  PrintELog ("Country        : %-.3s", rom_header.country);
  PrintELog ("Rom size       : %lu %lXH", mem.rom_size, mem.rom_size);

  if (mem.rom_size < RorLong (rom_header.rom_end_addr)) {

        mem.rom_space = realloc (mem.rom_space, (u_long)RorLong (rom_header.rom_end_addr));
        for (tmp_ptr = (mem.rom_space + mem.rom_size); \
                tmp_ptr < (mem.rom_space + RorLong (rom_header.rom_end_addr));)
                        *tmp_ptr++ = 0xff;

        mem.rom_size = RorLong (rom_header.rom_end_addr);
  }

  RAM           = mem.rom_space;
  rom_ptr       = mem.rom_space;
  ptr_check     = (s_short *)(mem.rom_space + 0x200);

  for (cnt = 0x200; cnt <= RorLong (rom_header.rom_end_addr); cnt += 2) {
        if (cnt > mem.rom_size) break;
        check += RorShort (*ptr_check++);
  }

  PrintELog ("Ver. Checksum  : %04lXH", (u_short)check);

  if (st0rm_cfg.checksums) {

        if (check != RorShort (rom_header.checksum)) {
                (*(s_short *)(mem.rom_space + 0x18e)) = RorShort (check);
                PrintELog ("Checksum fixed ...");
        }
  }

  if (st0rm_cfg.version == 3) {
        switch (rom_header.country[0]) {
                case 'U' :
                case 'u' :
                           io.hw_version = 2;
                           break;
                case 'E' :
                case 'e' :
                           io.hw_version = 1;
                           break;
                case 'J' :
                case 'j' :
                           io.hw_version = 0;
                           break;
        }

        if (rom_header.country[1] == 'U')
                io.hw_version = 2;

  } else
        io.hw_version = st0rm_cfg.version;

  PrintELog ("Hardware version set to %s", hw_versions[io.hw_version]);

  regs.pc       = RorLong (rom_header.program_counter);
  regs.a[7]     = RorLong (rom_header.stack_pointer);
  regs.vbr      = 0;

  vdp.vert_intr = RorLong (rom_header.vert_intr);
  vdp.horz_intr = RorLong (rom_header.horz_intr);

  ResetIO ();
  ResetVDP ();

  return 1;
}


void OpDebug (void) {

  u_long        pc = (regs.pc-2);
  u_long        cnt;

  PrintELog ("Opcode %lx %s at PC %lx", (u_short)LoadWMem (pc),
             GiveOpCodeName (LoadWMem (pc)), pc);
  for (cnt = pc-10; cnt < pc+11; cnt+=2) {
        PrintELog ("addr %lx: %lx %s", cnt, (u_short)LoadWMem (cnt),
                GiveOpCodeName (LoadWMem (cnt)));
  }
}

extern u_char z80_stop;

void RunGenesisZ80 (void) {

  u_long        cnt;

  Z80_Reset ();

  while (1) {

        cnt = 55;

        while (cnt--) {
                Execute_CPU ();
                Execute_CPU ();
                if (!z80_stop) Execute_Z80 ();
        }

        if (cnt_dma_busy) {
                if (!--cnt_dma_busy)
                        vdp.vdp_sr.dma_busy = 0;
        }

        if (cnt_vert_intr) {
                if (!--cnt_vert_intr)
                        vdp.vdp_sr.vert_intr = 0;
        }

        if (cnt_vert_blkf) {
                if (!--cnt_vert_blkf)
                        vdp.vdp_sr.vert_blk = 0;
        }

        if (cnt_vert_blk) {
                if (!--cnt_vert_blk) {
                        vdp.vdp_sr.vert_blk = 0;
                        GoVDP ();
                }
        }

  }
}

void ProfileOps (void) {

/*regs.d[0] = 0x123;
  regs.d[1] = 0x456;
  regs.a[0] = 0xff0000;
  regs.a[1] = 0xffffe0;
  ExtOpCode = 0x5050;

  tmp_clock = usec_clock (NULL);
  tmp2_clock = tmp_clock;
  tmp_cnt = 0;

  while ((tmp2_clock - tmp_clock) < UCLK_TCK) {
        for (tmp_icnt = 0; tmp_icnt < 5000; tmp_icnt++) {
                opp_5050();
                regs.a[0] = 0xff0000;
        }
        regs.a[0] = 0xff0000;
        tmp_cnt += tmp_icnt;
        tmp2_clock = usec_clock(NULL);
  }

  printf ("\nopp_5050() = %f\n", tmp_cnt);

  tmp_clock = usec_clock (NULL);
  tmp2_clock = tmp_clock;
  tmp_cnt = 0;

  regs.a[0] = 0xff0000;

  while ((tmp2_clock - tmp_clock) < UCLK_TCK) {
        for (tmp_icnt = 0; tmp_icnt < 5000; tmp_icnt++) {
                op_5050();
                regs.a[0] = 0xff0000;
        }
        regs.a[0] = 0xff0000;
        tmp_cnt += tmp_icnt;
        tmp2_clock = usec_clock(NULL);
  }

  printf ("\nop_5050() = %f\n", tmp_cnt);

  getch ();*/

}
