;*************************************************************************
;
;                          st0rm SGE Source Code
;
;                          (c)1998 David Sanchez
;                           st0rm@melodysoft.com
;
;                        Released on 17th March 1999
;        
;
;       Este codigo fuente lo puedes utilizar para:
;
;       - Usarlo como fuente de informacin para tus proyectos.
;       - Continuar el proyecto st0rm.
;       - Empezar un emulador desde 0 teniendo este como base.
;
;       Lo nico que pido si te es util y lo usas, es que lo menciones en tu
;       proyecto.
;
;       Tendras que perdonarme la falta de comentarios y el desorden total,
;       aun asi puede ser util.
;
;
;       COMENTARIOS EN README.TXT
;
;*************************************************************************

.486P
.MODEL FLAT

MAKE_SR_J       MACRO
        LOCAL   @s1, @s2, @s3, @s4

        mov     dword ptr[regs+v], 0
        jnc     @s1
        mov     byte ptr[regs+c], 1
@s1:
        jns     @s2
        mov     byte ptr[regs+n], 1
@s2:
        jnz     @s3
        mov     byte ptr[regs+z], 1
@s3:
        jno     @s4
        mov     byte ptr[regs+v], 1
@s4:
ENDM    MAKE_SR_J


MAKE_SR_JR       MACRO
        LOCAL   @s1, @s2, @s3, @s4

;        mov     dword ptr[regs+v], 0
        jnc     @s1
        mov     byte ptr[regs+c], 1
@s1:
        jns     @s2
        mov     byte ptr[regs+n], 1
@s2:
        jnz     @s3
        mov     byte ptr[regs+z], 1
@s3:
        jno     @s4
        mov     byte ptr[regs+v], 1
@s4:
ENDM    MAKE_SR_JR


MAKE_SR_JX      MACRO
        LOCAL   @s1, @s2, @s3, @s4

        mov     dword ptr[regs+v], 0
        jnc     short @s1
        mov     byte ptr[regs+c], 1
@s1:
        jns     short @s2
        mov     byte ptr[regs+n], 1
@s2:
        jnz     short @s3
        mov     byte ptr[regs+z], 1
@s3:
        jno     short @s4
        mov     byte ptr[regs+v], 1
@s4:
        push    eax
        mov     al, byte ptr[regs+c]
        mov     byte ptr[regs+f_x], al
        pop     eax
ENDM    MAKE_SR_JX


MAKE_SR_Z       MACRO
        LOCAL   @s1, @s2

        jne     short @s1
        mov     byte ptr[regs+z], 1
@s1:
        jge     short @s2
        mov     byte ptr[regs+n], 1
@s2:
ENDM    MAKE_SR_Z


MAKE_SR_ZS      MACRO
        LOCAL   @s1, @s2

        jnz     short @s1
        mov     byte ptr[regs+z], 1
@s1:
        jns     short @s2
        mov     byte ptr[regs+n], 1
@s2:
ENDM    MAKE_SR_ZS



MAKE_SR         MACRO

        mov     dx, word ptr[regs+sr]
        mov     ebx, eax
        and     dx, 0fff0h
        and     bx, 1
        shr     eax, 4
        or      dx, bx
        shr     ebx, 10
        and     eax, 0ch
        and     ebx, 2
        or      dx, ax
        or      dx, bx
        mov     word ptr[regs+sr], dx

        call    MakeFSRA

ENDM    MAKE_SR


MAKE_SR_F       MACRO

        mov     ebx, eax
        mov     dword ptr[regs+v], 0
        shl     bx, 1
        shr     al, 6
        shr     bl, 1
        and     al, 1
        and     bl, 1
        shr     ah, 3
        or      byte ptr[regs+c], bl
        and     bh, 1
        or      byte ptr[regs+z], al
        and     ah, 1
        or      byte ptr[regs+n], bh
        or      byte ptr[regs+v], ah

ENDM    MAKE_SR_F

MAKE_SR_FX      MACRO

        mov     ebx, eax
        mov     dword ptr[regs+v], 0
        shl     bx, 1
        shr     al, 6
        shr     bl, 1
        and     al, 1
        and     bl, 1
        shr     ah, 3
        or      byte ptr[regs+c], bl
        mov     byte ptr[regs+f_x], bl
        and     bh, 1
        or      byte ptr[regs+z], al
        and     ah, 1
        or      byte ptr[regs+n], bh
        or      byte ptr[regs+v], ah

ENDM    MAKE_SR_FX



LOAD_B_MEM      MACRO
        LOCAL   @no_rom, @no_ram, @is_hw, @error, @done

        and     eax, 0ffffffh
        cmp     eax, 3fffffh
        jg      @no_rom
        mov     al, byte ptr[esi+eax]
        jmp     short @done
@no_rom:
        cmp     eax, 0ff0000h
        jl      short @no_ram
        mov     al, byte ptr[mem+ram_space+[eax-0ff0000h]]
        jmp     short @done
@no_ram:
        cmp     eax, 0a04000h
        jge     short @is_hw
        cmp     eax, 0a00000h
        jl      short @error
        mov     al, byte ptr[mem+z80_ram+[eax-0a00000h]]
        jmp     short @done
@is_hw:
        push    0
        push    eax
        call    ReadGenHw
        add     esp, 8
        jmp     short @done
@error:
        push    eax
        call    ErrorMem
        add     esp, 4
@done:
ENDM    LOAD_B_MEM

LOAD_B_MEDI     MACRO
        LOCAL   @no_rom, @no_ram, @is_hw, @error, @done

        and     eax, 0ffffffh
        cmp     eax, 3fffffh
        jg      @no_rom
        mov     edi, esi
        add     edi, eax
        mov     al, byte ptr[edi]
        jmp     short @done
@no_rom:
        cmp     eax, 0ff0000h
        jl      short @no_ram
        lea     edi, mem+ram_space+[eax-0ff0000h]
        mov     al, byte ptr[edi]
        jmp     short @done
@no_ram:
        cmp     eax, 0a04000h
        jge     short @is_hw
        cmp     eax, 0a00000h
        jl      short @error
        lea     edi, mem+z80_ram+[eax-0a00000h]
        mov     al, byte ptr[edi]
        jmp     short @done
@is_hw:
        push    0
        push    eax
        call    ReadGenHw
        add     esp, 8
        jmp     short @done
@error:
        push    eax
        call    ErrorMem
        add     esp, 4
@done:
ENDM    LOAD_B_MEDI

SAVE_B_MEM      MACRO
        LOCAL   @no_rom, @no_ram, @is_hw, @error, @done

        and     eax, 0ffffffh
        cmp     eax, 3fffffh
        jg      @no_rom
        mov     byte ptr[esi+eax], dl
        jmp     short @done
@no_rom:
        cmp     eax, 0ff0000h
        jl      short @no_ram
        mov     byte ptr[mem+ram_space+[eax-0ff0000h]], dl
        jmp     short @done
@no_ram:
        cmp     eax, 0a04000h
        jge     short @is_hw
        cmp     eax, 0a00000h
        jl      short @error
        mov     byte ptr[mem+z80_ram+[eax-0a00000h]], dl
        jmp     short @done
@is_hw:
        and     edx, 0ffh
        push    edx
        push    0
        push    eax
        call    WriteGenHw
        add     esp, 12
        jmp     short @done
@error:
        push    eax
        call    ErrorMem
        add     esp, 4
@done:
ENDM    SAVE_B_MEM


LOAD_W_MEM      MACRO
        LOCAL   @no_rom, @no_ram, @is_hw, @error, @done

        and     eax, 0ffffffh
        cmp     eax, 3fffffh
        jg      @no_rom
        mov     ax, word ptr[esi+eax]
        xchg    ah, al
        jmp     short @done
@no_rom:
        cmp     eax, 0ff0000h
        jl      short @no_ram
        mov     ax, word ptr[mem+ram_space+[eax-0ff0000h]]
        xchg    ah, al
        jmp     short @done
@no_ram:
        cmp     eax, 0a04000h
        jge     short @is_hw
        cmp     eax, 0a00000h
        jl      short @error
        mov     ax, word ptr[mem+z80_ram+[eax-0a00000h]]
        xchg    ah, al
        jmp     short @done
@is_hw:
        push    1
        push    eax
        call    ReadGenHw
        add     esp, 8
        jmp     short @done
@error:
        push    eax
        call    ErrorMem
        add     esp, 4
@done:
ENDM    LOAD_W_MEM

LOAD_W_MEDI     MACRO
        LOCAL   @no_rom, @no_ram, @is_hw, @error, @done

        and     eax, 0ffffffh
        cmp     eax, 3fffffh
        jg      @no_rom
        mov     edi, esi
        add     edi, eax
        mov     ax, word ptr[edi]
        xchg    ah, al
        jmp     short @done
@no_rom:
        cmp     eax, 0ff0000h
        jl      short @no_ram
        lea     edi, mem+ram_space+[eax-0ff0000h]
        mov     ax, word ptr[edi]
        xchg    ah, al
        jmp     short @done
@no_ram:
        cmp     eax, 0a04000h
        jge     short @is_hw
        cmp     eax, 0a00000h
        jl      short @error
        lea     edi, mem+z80_ram+[eax-0a00000h]
        mov     ax, word ptr[edi]
        xchg    ah, al
        jmp     short @done
@is_hw:
        push    1
        push    eax
        call    ReadGenHw
        add     esp, 8
        jmp     short @done
@error:
        push    eax
        call    ErrorMem
        add     esp, 4
@done:
ENDM    LOAD_W_MEDI

SAVE_W_MEM      MACRO
        LOCAL   @no_rom, @no_ram, @is_hw, @error, @done

        and     eax, 0ffffffh
        push    edx
        cmp     eax, 3fffffh
        jg      short @no_rom
        xchg    dh, dl
        mov     word ptr[esi+eax], dx
        jmp     short @done
@no_rom:
        cmp     eax, 0ff0000h
        jl      short @no_ram
        xchg    dh, dl
        mov     word ptr[mem+ram_space+[eax-0ff0000h]], dx
        jmp     short @done
@no_ram:
        cmp     eax, 0a04000h
        jge     short @is_hw
        cmp     eax, 0a00000h
        jl      short @error
        xchg    dh, dl
        mov     word ptr[mem+z80_ram+[eax-0a00000h]], dx
        jmp     short @done
@is_hw:
        and     edx, 0ffffh
        push    edx
        push    1
        push    eax
        call    WriteGenHw
        add     esp, 12
        jmp     short @done
@error:
        push    eax
        call    ErrorMem
        add     esp, 4
@done:
        pop     edx
ENDM    SAVE_W_MEM


LOAD_L_MEM      MACRO
        LOCAL   @no_rom, @no_ram, @is_hw, @error, @done

        and     eax, 0ffffffh
        cmp     eax, 3fffffh
        jg      @no_rom
        mov     eax, dword ptr[esi+eax]
        bswap   eax
        jmp     short @done
@no_rom:
        cmp     eax, 0ff0000h
        jl      short @no_ram
        mov     eax, dword ptr[mem+ram_space+[eax-0ff0000h]]
        bswap   eax
        jmp     short @done
@no_ram:
        cmp     eax, 0a04000h
        jge     short @is_hw
        cmp     eax, 0a00000h
        jl      short @error
        mov     eax, dword ptr[mem+z80_ram+[eax-0a00000h]]
        bswap   eax
        jmp     short @done
@is_hw:
        push    2
        push    eax
        call    ReadGenHw
        add     esp, 8
        jmp     short @done
@error:
        push    eax
        call    ErrorMem
        add     esp, 4
@done:
ENDM    LOAD_L_MEM

LOAD_L_MEDI     MACRO
        LOCAL   @no_rom, @no_ram, @is_hw, @error, @done

        and     eax, 0ffffffh
        cmp     eax, 3fffffh
        jg      @no_rom
        mov     edi, esi
        add     edi, eax
        mov     eax, dword ptr[edi]
        bswap   eax
        jmp     short @done
@no_rom:
        cmp     eax, 0ff0000h
        jl      short @no_ram
        lea     edi, mem+ram_space+[eax-0ff0000h]
        mov     eax, dword ptr[edi]
        bswap   eax
        jmp     short @done
@no_ram:
        cmp     eax, 0a04000h
        jge     short @is_hw
        cmp     eax, 0a00000h
        jl      short @error
        lea     edi, mem+z80_ram+[eax-0a00000h]
        mov     eax, dword ptr[edi]
        bswap   eax
        jmp     short @done
@is_hw:
        push    2
        push    eax
        call    ReadGenHw
        add     esp, 8
        jmp     short @done
@error:
        push    eax
        call    ErrorMem
        add     esp, 4
@done:
ENDM    LOAD_L_MEDI

SAVE_L_MEM      MACRO
        LOCAL   @no_rom, @no_ram, @is_hw, @error, @done

        and     eax, 0ffffffh
        push    edx
        cmp     eax, 3fffffh
        jg      @no_rom
        bswap   edx
        mov     dword ptr[esi+eax], edx
        jmp     short @done
@no_rom:
        cmp     eax, 0ff0000h
        jl      short @no_ram
        bswap   edx
        mov     dword ptr[mem+ram_space+[eax-0ff0000h]], edx
        jmp     short @done
@no_ram:
        cmp     eax, 0a04000h
        jge     short @is_hw
        cmp     eax, 0a00000h
        jl      short @error
        bswap   edx
        mov     dword ptr[mem+z80_ram+[eax-0a00000h]], edx
        jmp     short @done
@is_hw:
        push    edx
        push    2
        push    eax
        call    WriteGenHw
        add     esp, 12
        jmp     short @done
@error:
        push    eax
        call    ErrorMem
        add     esp, 4
@done:
        pop     edx
ENDM    SAVE_L_MEM


GET_DISP_EA     MACRO
        LOCAL   @gd_is_d, @gd_ok, @gd_is_long

        push    ebx
        mov     bx, ax
        shr     ax, 10
        and     eax, 1ch
        test    bx, 8000h
        jz      short @gd_is_d
        mov     eax, dword ptr[regs+a[eax]]
        jmp     short @gd_ok
@gd_is_d:
        mov     eax, dword ptr[regs+d[eax]]
@gd_ok:
        test    bx, 800h
        jnz     short @gd_is_long
        cwde
@gd_is_long:
        push    eax
        mov     ax, bx
        cbw
        cwde
        add     eax, dword ptr[esp]
        add     eax, dword ptr[esp+8]
        add     esp, 4
        pop     ebx
        add     esp, 4
;        inc     [gedea_cnt]

ENDM    GET_DISP_EA


_TEXT SEGMENT DWORD PUBLIC 'CODE'
	ASSUME	cs:_TEXT, ds:_DATA


REGST   STRUC
        d       dd      8 dup(?)
        a       dd      8 dup(?)
        usp     dd      ?
        isp     dd      ?
        msp     dd      ?
        sr      dw      ?
        f_t1    db      ?
        f_t0    db      ?
        f_s     db      ?
        f_m     db      ?
        f_x     db      ?
        f_stop  db      ?
        intmask dd      ?
        pc      dd      ?

        v       db      ?
        c       db      ?
        n       db      ?
        z       db      ?
REGST   ENDS

MEMST   STRUC
        rom_space       dd      ?
        rom_size        dd      ?
        z80_ram         db      2000h dup(?)
        io_port         db      5000h dup(?)
        ram_space       db      10000h dup(?)
MEMST   ENDS


EXTRN   ExtOpCode:DWORD
EXTRN   regs_ptr:DWORD
EXTRN   flags_ptr:DWORD
EXTRN   regs:DWORD
EXTRN   mem:DWORD

EXTRN   rom_ptr:DWORD
EXTRN   z80ram_ptr:DWORD
EXTRN   ram_ptr:DWORD

EXTRN   GoVDP:PROC
EXTRN   MakeFSRA:PROC

EXTRN   LoadBMem:PROC
EXTRN   LoadWMem:PROC
EXTRN   LoadLMem:PROC
EXTRN   SaveWMem:PROC

;EXTRN   ReadGenHw:PROC
;EXTRN   WriteGenHw:PROC
EXTRN   ReadVDPPort:PROC
EXTRN   ReadIOPort:PROC
EXTRN   WriteVDPPort:PROC
EXTRN   WriteIOPort:PROC
EXTRN   ErrorMem:PROC
EXTRN   Exception:PROC
EXTRN   OpDebug:PROC

EXTRN   cpufunctbl:DWORD
EXTRN   functbl_ptr:DWORD

EXTRN   vdp_sr_ptr:DWORD
EXTRN   cnt_dma_busy:DWORD
EXTRN   cnt_vert_blkf:DWORD
EXTRN   cnt_vert_blk:DWORD
EXTRN   cnt_vert_intr:DWORD
EXTRN   vdp_run:DWORD
EXTRN   vdp_write:BYTE

EXTRN   gedea_cnt:DWORD

EXTRN   profile_op:DWORD


ReadGenHw       PROC
        ARG     addr:DWORD, sized:DWORD

        push    ebp
        mov     ebp, esp

        push    ebx
        push    ecx
        push    edx
        push    esi
        push    edi

        cmp     [addr], 0c00000h
        jl      short rg_no_vdp
        cmp     [addr], 0cfffffh
        jg      short rg_error_mem
        push    [sized]
        push    [addr]
        call    ReadVDPPort
        add     esp, 8
        jmp     short rg_done
rg_no_vdp:
        cmp     [addr], 0a04000h
        jl      short rg_error_mem
        cmp     [addr], 0afffffh
        jg      short rg_error_mem
        push    [sized]
        push    [addr]
        call    ReadIOPort
        add     esp, 8
        jmp     short rg_done
rg_error_mem:
        push    [addr]
        call    ErrorMem
        add     esp, 4
rg_done:
        pop     edi
        pop     esi
        pop     edx
        pop     ecx
        pop     ebx

        mov     esp, ebp
        pop     ebp
        ret
ReadGenHw       ENDP

WriteGenHw       PROC
        ARG     addr:DWORD, sized:DWORD, to_write:DWORD

        push    ebp
        mov     ebp, esp

        pushad

        cmp     [addr], 0c00000h
        jl      short wg_no_vdp
        cmp     [addr], 0cfffffh
        jg      short wg_error_mem
        push    [to_write]
        push    [sized]
        push    [addr]
        call    WriteVDPPort
        add     esp, 12
        jmp     short wg_done
wg_no_vdp:
        cmp     [addr], 0a04000h
        jl      short wg_error_mem
        cmp     [addr], 0afffffh
        jg      short wg_error_mem
        push    [to_write]
        push    [sized]
        push    [addr]
        call    WriteIOPort
        add     esp, 12
        jmp     short wg_done
wg_error_mem:
        push    [addr]
        call    ErrorMem
        add     esp, 4
wg_done:
        popad

        mov     esp, ebp
        pop     ebp
        ret
WriteGenHw       ENDP
 

public  Execute_CPU
public  Executen_CPU
public  RunGenesis

public  op_0                            ; OR
public  op_10                           ; OR
public  op_18                           ; OR
public  op_20                           ; OR
public  op_28                           ; OR
public  op_30                           ; OR
public  op_38                           ; OR
public  op_39                           ; OR
public  op_40                           ; OR
public  op_50                           ; OR
public  op_58                           ; OR
public  op_60                           ; OR
public  op_68                           ; OR
public  op_70                           ; OR
public  op_78                           ; OR
public  op_79                           ; OR
public  op_80                           ; OR
public  op_90                           ; OR
public  op_98                           ; OR
public  op_a0                           ; OR
public  op_a8                           ; OR
public  op_b0                           ; OR
public  op_b8                           ; OR
public  op_b9                           ; OR
public  op_200                          ; AND
public  op_210                          ; AND
public  op_218                          ; AND
public  op_220                          ; AND
public  op_228                          ; AND
public  op_238                          ; AND
public  op_239                          ; AND
public  op_240                          ; AND
public  op_250                          ; AND
public  op_258                          ; AND
public  op_260                          ; AND
public  op_268                          ; AND
public  op_278                          ; AND
public  op_279                          ; AND
public  op_280                          ; AND
public  op_290                          ; AND
public  op_298                          ; AND
public  op_2a0                          ; AND
public  op_2a8                          ; AND
public  op_2b8                          ; AND
public  op_2b9                          ; AND
public  op_400                          ; SUB
public  op_410                          ; SUB
public  op_418                          ; SUB
public  op_420                          ; SUB
public  op_428                          ; SUB
public  op_438                          ; SUB
public  op_439                          ; SUB
public  op_440                          ; SUB
public  op_450                          ; SUB
public  op_458                          ; SUB
public  op_460                          ; SUB
public  op_468                          ; SUB
public  op_478                          ; SUB
public  op_479                          ; SUB
public  op_480                          ; SUB
public  op_490                          ; SUB
public  op_498                          ; SUB
public  op_4a0                          ; SUB
public  op_4a8                          ; SUB
public  op_4b8                          ; SUB
public  op_4b9                          ; SUB
public  op_600                          ; ADD
public  op_610                          ; ADD
public  op_618                          ; ADD
public  op_620                          ; ADD
public  op_628                          ; ADD
public  op_638                          ; ADD
public  op_639                          ; ADD
public  op_640                          ; ADD
public  op_650                          ; ADD
public  op_658                          ; ADD
public  op_660                          ; ADD
public  op_668                          ; ADD
public  op_678                          ; ADD
public  op_679                          ; ADD
public  op_680                          ; ADD
public  op_690                          ; ADD
public  op_698                          ; ADD
public  op_6a0                          ; ADD
public  op_6a8                          ; ADD
public  op_6b8                          ; ADD
public  op_6b9                          ; ADD
public  op_800                          ; BTST
public  op_810                          ; BTST
public  op_a00                          ; EOR
public  op_a10                          ; EOR
public  op_a18                          ; EOR
public  op_a20                          ; EOR
public  op_a28                          ; EOR
public  op_a30                          ; EOR
public  op_a38                          ; EOR
public  op_a39                          ; EOR
public  op_a40                          ; EOR
public  op_a50                          ; EOR
public  op_a58                          ; EOR
public  op_a60                          ; EOR
public  op_a68                          ; EOR
public  op_a70                          ; EOR
public  op_a78                          ; EOR
public  op_a79                          ; EOR
public  op_a80                          ; EOR
public  op_a90                          ; EOR
public  op_a98                          ; EOR
public  op_aa0                          ; EOR
public  op_aa8                          ; EOR
public  op_ab0                          ; EOR
public  op_ab8                          ; EOR
public  op_ab9                          ; EOR
public  op_c00                          ; CMP
public  op_c10                          ; CMP
public  op_c18                          ; CMP
public  op_c20                          ; CMP
public  op_c28                          ; CMP
public  op_c38                          ; CMP
public  op_c39                          ; CMP
public  op_c40                          ; CMP
public  op_c50                          ; CMP
public  op_c58                          ; CMP
public  op_c60                          ; CMP
public  op_c68                          ; CMP
public  op_c78                          ; CMP
public  op_c79                          ; CMP
public  op_c80                          ; CMP
public  op_c90                          ; CMP
public  op_c98                          ; CMP
public  op_ca0                          ; CMP
public  op_ca8                          ; CMP
public  op_cb8                          ; CMP
public  op_cb9                          ; CMP
public  op_1000                         ; MOVE
public  op_1010                         ; MOVE
public  op_1018                         ; MOVE
public  op_1020                         ; MOVE
public  op_1028                         ; MOVE
public  op_1030                         ; MOVE
public  op_1038                         ; MOVE
public  op_1039                         ; MOVE
public  op_103a                         ; MOVE
public  op_103b                         ; MOVE
public  op_103c                         ; MOVE
public  op_1080                         ; MOVE
public  op_1090                         ; MOVE
public  op_1098                         ; MOVE
public  op_10a0                         ; MOVE
public  op_10a8                         ; MOVE
public  op_10b0                         ; MOVE
public  op_10b8                         ; MOVE
public  op_10b9                         ; MOVE
public  op_10ba                         ; MOVE
public  op_10bb                         ; MOVE
public  op_10bc                         ; MOVE
public  op_10c0                         ; MOVE
public  op_10d0                         ; MOVE
public  op_10d8                         ; MOVE
public  op_10e0                         ; MOVE
public  op_10e8                         ; MOVE
public  op_10f0                         ; MOVE
public  op_10f8                         ; MOVE
public  op_10f9                         ; MOVE
public  op_10fa                         ; MOVE
public  op_10fb                         ; MOVE
public  op_10fc                         ; MOVE
public  op_1100                         ; MOVE
public  op_1110                         ; MOVE
public  op_1118                         ; MOVE
public  op_1120                         ; MOVE
public  op_1128                         ; MOVE
public  op_1130                         ; MOVE
public  op_1138                         ; MOVE
public  op_1139                         ; MOVE
public  op_113a                         ; MOVE
public  op_113b                         ; MOVE
public  op_113c                         ; MOVE
public  op_1140                         ; MOVE
public  op_1150                         ; MOVE
public  op_1158                         ; MOVE
public  op_1160                         ; MOVE
public  op_1168                         ; MOVE
public  op_1170                         ; MOVE
public  op_1178                         ; MOVE
public  op_1179                         ; MOVE
public  op_117a                         ; MOVE
public  op_117b                         ; MOVE
public  op_117c                         ; MOVE
public  op_11c0                         ; MOVE
public  op_11d0                         ; MOVE
public  op_11d8                         ; MOVE
public  op_11e0                         ; MOVE
public  op_11e8                         ; MOVE
public  op_11f0                         ; MOVE
public  op_11f8                         ; MOVE
public  op_11f9                         ; MOVE
public  op_11fa                         ; MOVE
public  op_11fb                         ; MOVE
public  op_11fc                         ; MOVE
public  op_13c0                         ; MOVE
public  op_13d0                         ; MOVE
public  op_13d8                         ; MOVE
public  op_13e0                         ; MOVE
public  op_13e8                         ; MOVE
public  op_13f0                         ; MOVE
public  op_13f8                         ; MOVE
public  op_13f9                         ; MOVE
public  op_13fa                         ; MOVE
public  op_13fb                         ; MOVE
public  op_13fc                         ; MOVE
public  op_2000                         ; MOVE
public  op_2008                         ; MOVE
public  op_2010                         ; MOVE
public  op_2018                         ; MOVE
public  op_2020                         ; MOVE
public  op_2028                         ; MOVE
public  op_2030                         ; MOVE
public  op_2038                         ; MOVE
public  op_2039                         ; MOVE
public  op_203a                         ; MOVE
public  op_203b                         ; MOVE
public  op_203c                         ; MOVE
public  op_2040                         ; MOVEA
public  op_2048                         ; MOVEA
public  op_2050                         ; MOVEA
public  op_2058                         ; MOVEA
public  op_2060                         ; MOVEA
public  op_2068                         ; MOVEA
public  op_2070                         ; MOVEA
public  op_2078                         ; MOVEA
public  op_2079                         ; MOVEA
public  op_207a                         ; MOVEA
public  op_207b                         ; MOVEA
public  op_207c                         ; MOVEA
public  op_2080                         ; MOVE
public  op_2088                         ; MOVE
public  op_2090                         ; MOVE
public  op_2098                         ; MOVE
public  op_20a0                         ; MOVE
public  op_20a8                         ; MOVE
public  op_20b0                         ; MOVE
public  op_20b8                         ; MOVE
public  op_20b9                         ; MOVE
public  op_20ba                         ; MOVE
public  op_20bb                         ; MOVE
public  op_20bc                         ; MOVE
public  op_20c0                         ; MOVE
public  op_20c8                         ; MOVE
public  op_20d0                         ; MOVE
public  op_20d8                         ; MOVE
public  op_20e0                         ; MOVE
public  op_20e8                         ; MOVE
public  op_20f0                         ; MOVE
public  op_20f8                         ; MOVE
public  op_20f9                         ; MOVE
public  op_20fa                         ; MOVE
public  op_20fb                         ; MOVE
public  op_20fc                         ; MOVE
public  op_2100                         ; MOVE
public  op_2108                         ; MOVE
public  op_2110                         ; MOVE
public  op_2118                         ; MOVE
public  op_2120                         ; MOVE
public  op_2128                         ; MOVE
public  op_2130                         ; MOVE
public  op_2138                         ; MOVE
public  op_2139                         ; MOVE
public  op_213a                         ; MOVE
public  op_213b                         ; MOVE
public  op_213c                         ; MOVE
public  op_2140                         ; MOVE
public  op_2148                         ; MOVE
public  op_2150                         ; MOVE
public  op_2158                         ; MOVE
public  op_2160                         ; MOVE
public  op_2168                         ; MOVE
public  op_2170                         ; MOVE
public  op_2178                         ; MOVE
public  op_2179                         ; MOVE
public  op_217a                         ; MOVE
public  op_217b                         ; MOVE
public  op_217c                         ; MOVE
public  op_21c0                         ; MOVE
public  op_21c8                         ; MOVE
public  op_21d0                         ; MOVE
public  op_21d8                         ; MOVE
public  op_21e0                         ; MOVE
public  op_21e8                         ; MOVE
public  op_21f0                         ; MOVE
public  op_21f8                         ; MOVE
public  op_21f9                         ; MOVE
public  op_21fa                         ; MOVE
public  op_21fb                         ; MOVE
public  op_21fc                         ; MOVE
public  op_23c0                         ; MOVE
public  op_23c8                         ; MOVE
public  op_23d0                         ; MOVE
public  op_23d8                         ; MOVE
public  op_23e0                         ; MOVE
public  op_23e8                         ; MOVE
public  op_23f0                         ; MOVE
public  op_23f8                         ; MOVE
public  op_23f9                         ; MOVE
public  op_23fa                         ; MOVE
public  op_23fb                         ; MOVE
public  op_23fc                         ; MOVE
public  op_3000                         ; MOVE
public  op_3008                         ; MOVE
public  op_3010                         ; MOVE
public  op_3018                         ; MOVE
public  op_3020                         ; MOVE
public  op_3028                         ; MOVE
public  op_3030                         ; MOVE
public  op_3038                         ; MOVE
public  op_3039                         ; MOVE
public  op_303a                         ; MOVE
public  op_303b                         ; MOVE
public  op_303c                         ; MOVE
public  op_3040                         ; MOVEA
public  op_3048                         ; MOVEA
public  op_3050                         ; MOVEA
public  op_3058                         ; MOVEA
public  op_3060                         ; MOVEA
public  op_3068                         ; MOVEA
public  op_3070                         ; MOVEA
public  op_3078                         ; MOVEA
public  op_3079                         ; MOVEA
public  op_307a                         ; MOVEA
public  op_307b                         ; MOVEA
public  op_307c                         ; MOVEA
public  op_3080                         ; MOVE
public  op_3088                         ; MOVE
public  op_3090                         ; MOVE
public  op_3098                         ; MOVE
public  op_30a0                         ; MOVE
public  op_30a8                         ; MOVE
public  op_30b0                         ; MOVE
public  op_30b8                         ; MOVE
public  op_30b9                         ; MOVE
public  op_30ba                         ; MOVE
public  op_30bb                         ; MOVE
public  op_30bc                         ; MOVE
public  op_30c0                         ; MOVE
public  op_30c8                         ; MOVE
public  op_30d0                         ; MOVE
public  op_30d8                         ; MOVE
public  op_30e0                         ; MOVE
public  op_30e8                         ; MOVE
public  op_30f0                         ; MOVE
public  op_30f8                         ; MOVE
public  op_30f9                         ; MOVE
public  op_30fa                         ; MOVE
public  op_30fb                         ; MOVE
public  op_30fc                         ; MOVE
public  op_3100                         ; MOVE
public  op_3108                         ; MOVE
public  op_3110                         ; MOVE
public  op_3118                         ; MOVE
public  op_3120                         ; MOVE
public  op_3128                         ; MOVE
public  op_3130                         ; MOVE
public  op_3138                         ; MOVE
public  op_3139                         ; MOVE
public  op_313a                         ; MOVE
public  op_313b                         ; MOVE
public  op_313c                         ; MOVE
public  op_3140                         ; MOVE
public  op_3148                         ; MOVE
public  op_3150                         ; MOVE
public  op_3158                         ; MOVE
public  op_3160                         ; MOVE
public  op_3168                         ; MOVE
public  op_3170                         ; MOVE
public  op_3178                         ; MOVE
public  op_3179                         ; MOVE
public  op_317a                         ; MOVE
public  op_317b                         ; MOVE
public  op_317c                         ; MOVE
public  op_31c0                         ; MOVE
public  op_31c8                         ; MOVE
public  op_31d0                         ; MOVE
public  op_31d8                         ; MOVE
public  op_31e0                         ; MOVE
public  op_31e8                         ; MOVE
public  op_31f0                         ; MOVE
public  op_31f8                         ; MOVE
public  op_31f9                         ; MOVE
public  op_31fa                         ; MOVE
public  op_31fb                         ; MOVE
public  op_31fc                         ; MOVE
public  op_33c0                         ; MOVE
public  op_33c8                         ; MOVE
public  op_33d0                         ; MOVE
public  op_33d8                         ; MOVE
public  op_33e0                         ; MOVE
public  op_33e8                         ; MOVE
public  op_33f0                         ; MOVE
public  op_33f8                         ; MOVE
public  op_33f9                         ; MOVE
public  op_33fa                         ; MOVE
public  op_33fb                         ; MOVE
public  op_33fc                         ; MOVE
public  op_41d0                         ; LEA
public  op_41e8                         ; LEA
public  op_41f0                         ; LEA
public  op_41f8                         ; LEA
public  op_41f9                         ; LEA
public  op_41fa                         ; LEA
public  op_41fb                         ; LEA
public  op_42b9                         ; CLR
public  op_4840                         ; SWAP
public  op_4880                         ; EXT
public  op_48c0                         ; EXT
public  op_49c0                         ; EXT
public  op_4a00                         ; TST
public  op_4a10                         ; TST
public  op_4a18                         ; TST
public  op_4a20                         ; TST
public  op_4a28                         ; TST
public  op_4a38                         ; TST
public  op_4e71                         ; NOP
public  op_4e75                         ; RTS
public  op_4e90                         ; JSR
public  op_4eb9                         ; JSR
public  op_4eba                         ; JSR
public  op_4ed0                         ; JMP
public  op_4efb                         ; JMP
public  op_5000                         ; ADDQ
public  op_5010                         ; ADDQ
public  op_5018                         ; ADDQ
public  op_5020                         ; ADDQ
public  op_5028                         ; ADDQ
public  op_5038                         ; ADDQ
public  op_5039                         ; ADDQ
public  op_5040                         ; ADDQ
public  op_5050                         ; ADDQ
public  op_5058                         ; ADDQ
public  op_5060                         ; ADDQ
public  op_5068                         ; ADDQ
public  op_5078                         ; ADDQ
public  op_5079                         ; ADDQ
public  op_5080                         ; ADDQ
public  op_5090                         ; ADDQ
public  op_5098                         ; ADDQ
public  op_50a0                         ; ADDQ
public  op_50a8                         ; ADDQ
public  op_50b8                         ; ADDQ
public  op_50b9                         ; ADDQ
public  op_5100                         ; SUBQ
public  op_5110                         ; SUBQ
public  op_5118                         ; SUBQ
public  op_5120                         ; SUBQ
public  op_5128                         ; SUBQ
public  op_5138                         ; SUBQ
public  op_5139                         ; SUBQ
public  op_5140                         ; SUBQ
public  op_5150                         ; SUBQ
public  op_5158                         ; SUBQ
public  op_5160                         ; SUBQ
public  op_5168                         ; SUBQ
public  op_5178                         ; SUBQ
public  op_5179                         ; SUBQ
public  op_5180                         ; SUBQ
public  op_5190                         ; SUBQ
public  op_5198                         ; SUBQ
public  op_51a0                         ; SUBQ
public  op_51a8                         ; SUBQ
public  op_51b8                         ; SUBQ
public  op_51b9                         ; SUBQ
public  op_51c8                         ; DBcc
public  op_51f9                         ; Scc
public  op_52f9                         ; Scc
public  op_6000                         ; Bcc
public  op_6001                         ; Bcc
public  op_6100                         ; BSR
public  op_6101                         ; BSR
public  op_6200                         ; Bcc
public  op_6201                         ; Bcc
public  op_6300                         ; Bcc
public  op_6301                         ; Bcc
public  op_6400                         ; Bcc
public  op_6401                         ; Bcc
public  op_6500                         ; Bcc
public  op_6501                         ; Bcc
public  op_6600                         ; Bcc
public  op_6601                         ; Bcc
public  op_6701                         ; Bcc
public  op_6801                         ; Bcc
public  op_6901                         ; Bcc
public  op_6a01                         ; Bcc
public  op_6b01                         ; Bcc
public  op_6c01                         ; Bcc
public  op_6d01                         ; Bcc
public  op_6e01                         ; Bcc
public  op_6f01                         ; Bcc
public  op_7000                         ; MOVE
public  op_81fc                         ; DIVS
public  op_91fc                         ; SUBA
public  op_b000                         ; CMP
public  op_b010                         ; CMP
public  op_b018                         ; CMP
public  op_b020                         ; CMP
public  op_b028                         ; CMP
public  op_b038                         ; CMP
public  op_b039                         ; CMP
public  op_b03a                         ; CMP
public  op_b03c                         ; CMP
public  op_b040                         ; CMP
public  op_b048                         ; CMP
public  op_b050                         ; CMP
public  op_b058                         ; CMP
public  op_b060                         ; CMP
public  op_b068                         ; CMP
public  op_b078                         ; CMP
public  op_b079                         ; CMP
public  op_b07a                         ; CMP
public  op_b07c                         ; CMP
public  op_b080                         ; CMP
public  op_b088                         ; CMP
public  op_b090                         ; CMP
public  op_b098                         ; CMP
public  op_b0a0                         ; CMP
public  op_b0a8                         ; CMP
public  op_b0b8                         ; CMP
public  op_b0b9                         ; CMP
public  op_b0ba                         ; CMP
public  op_b0bc                         ; CMP
public  op_b1fc                         ; CMPA
public  op_c000                         ; AND
public  op_c010                         ; AND
public  op_c018                         ; AND
public  op_c020                         ; AND
public  op_c028                         ; AND
public  op_c030                         ; AND
public  op_c038                         ; AND
public  op_c039                         ; AND
public  op_c03a                         ; AND
public  op_c03c                         ; AND
public  op_c040                         ; AND
public  op_c050                         ; AND
public  op_c058                         ; AND
public  op_c060                         ; AND
public  op_c068                         ; AND
public  op_c078                         ; AND
public  op_c079                         ; AND
public  op_c07a                         ; AND
public  op_c07c                         ; AND
public  op_c080                         ; AND
public  op_c090                         ; AND
public  op_c098                         ; AND
public  op_c0a0                         ; AND
public  op_c0a8                         ; AND
public  op_c0b8                         ; AND
public  op_c0b9                         ; AND
public  op_c0ba                         ; AND
public  op_c0bc                         ; AND
public  op_d000                         ; ADD
public  op_d010                         ; ADD
public  op_d018                         ; ADD
public  op_d020                         ; ADD
public  op_d028                         ; ADD
public  op_d038                         ; ADD
public  op_d039                         ; ADD
public  op_d03a                         ; ADD
public  op_d03c                         ; ADD
public  op_d040                         ; ADD
public  op_d048                         ; ADD
public  op_d050                         ; ADD
public  op_d058                         ; ADD
public  op_d060                         ; ADD
public  op_d068                         ; ADD
public  op_d078                         ; ADD
public  op_d079                         ; ADD
public  op_d07a                         ; ADD
public  op_d07c                         ; ADD
public  op_d080                         ; ADD
public  op_d088                         ; ADD
public  op_d090                         ; ADD
public  op_d098                         ; ADD
public  op_d0a0                         ; ADD
public  op_d0a8                         ; ADD
public  op_d0b8                         ; ADD
public  op_d0b9                         ; ADD
public  op_d0ba                         ; ADD
public  op_d0bc                         ; ADD
public  op_d1fc                         ; ADDA
public  op_e000                         ; ASR
public  op_e008                         ; LSR
public  op_e018                         ; ROR
public  op_e020                         ; ASR
public  op_e028                         ; LSR
public  op_e038                         ; ROR
public  op_e040                         ; ASR
public  op_e058                         ; ROR
public  op_e048                         ; LSR
public  op_e060                         ; ASR
public  op_e068                         ; LSR
public  op_e078                         ; ROR
public  op_e080                         ; ASR
public  op_e088                         ; LSR
public  op_e098                         ; ROR
public  op_e0a0                         ; ASR
public  op_e0a8                         ; LSR
public  op_e0b8                         ; ROR
public  op_e0d0                         ; ASRW
public  op_e0d8                         ; ASRW
public  op_e0e0                         ; ASRW
public  op_e0e8                         ; ASRW
public  op_e0f0                         ; ASRW
public  op_e0f8                         ; ASRW
public  op_e0f9                         ; ASRW
public  op_e100                         ; ASL
public  op_e108                         ; LSL
public  op_e118                         ; ROL
public  op_e120                         ; ASL
public  op_e128                         ; LSL
public  op_e138                         ; ROL
public  op_e140                         ; ASL
public  op_e148                         ; LSL
public  op_e158                         ; ROL
public  op_e160                         ; ASL
public  op_e168                         ; LSL
public  op_e178                         ; ROL
public  op_e180                         ; ASL
public  op_e188                         ; LSL
public  op_e198                         ; ROL
public  op_e1a0                         ; ASL
public  op_e1a8                         ; LSL
public  op_e1b8                         ; ROL
public  op_e1d0                         ; ASLW
public  op_e1d8                         ; ASLW
public  op_e1e0                         ; ASLW
public  op_e1e8                         ; ASLW
public  op_e1f0                         ; ASLW
public  op_e1f8                         ; ASLW
public  op_e1f9                         ; ASLW
public  op_e2d0                         ; LSRW
public  op_e2d8                         ; LSRW
public  op_e2e0                         ; LSRW
public  op_e2e8                         ; LSRW
public  op_e2f0                         ; LSRW
public  op_e2f8                         ; LSRW
public  op_e2f9                         ; LSRW
public  op_e3d0                         ; LSLW
public  op_e3d8                         ; LSLW
public  op_e3e0                         ; LSLW
public  op_e3e8                         ; LSLW
public  op_e3f0                         ; LSLW
public  op_e3f8                         ; LSLW
public  op_e3f9                         ; LSLW
public  op_e6d0                         ; RORW
public  op_e6d8                         ; RORW
public  op_e6e0                         ; RORW
public  op_e6e8                         ; RORW
public  op_e6f0                         ; RORW
public  op_e6f8                         ; RORW
public  op_e6f9                         ; RORW
public  op_e7d0                         ; ROLW
public  op_e7d8                         ; ROLW
public  op_e7e0                         ; ROLW
public  op_e7e8                         ; ROLW
public  op_e7f0                         ; ROLW
public  op_e7f8                         ; ROLW
public  op_e7f9                         ; ROLW

Execute_CPU     PROC

        pushad

        mov     esi, [rom_ptr]
        mov     eax, dword ptr[regs+pc]
        and     eax, 0ffffffh
        add     dword ptr[regs+pc], 2
        cmp     eax, 3fffffh
        jle     execpu_isrom

        lea     edi, mem+ram_space-0ff0000h
        jmp     short execpu_isram

execpu_isrom:
        mov     edi, [rom_ptr]
execpu_isram:
        add     edi, eax
        mov     ebx, dword ptr[edi]
        and     ebx, 0ffffh
        xchg    bh, bl
        mov     [ExtOpCode], ebx

        call    cpufunctbl[ebx*4]

        popad

        ret

Execute_CPU     ENDP

Executen_CPU    PROC

        ARG     cnt:DWORD

        push    ebp
        mov     ebp, esp

        pushad

        mov     esi, [rom_ptr]
        mov     ecx, [cnt]

exe_next:

        mov     eax, dword ptr[regs+pc]
        mov     edx, [functbl_ptr]
        and     eax, 0ffffffh
        add     dword ptr[regs+pc], 2
        cmp     eax, 3fffffh
        jle     short exencpu_isrom

        mov     edi, [ram_ptr]
        sub     eax, 0ff0000h
        jmp     short exencpu_isram

exencpu_isrom:
        mov     edi, [rom_ptr]
exencpu_isram:
        xor     ebx, ebx
        add     edi, eax
        mov     bx, word ptr[edi]
        xchg    bh, bl
        mov     eax, ebx
        mov     [ExtOpCode], ebx
        shl     eax, 2
        push    ecx

        call    [edx+eax]
        pop     ecx

        dec     ecx
        jnz     exe_next

        popad

        mov     esp, ebp
        pop     ebp

        ret

Executen_CPU    ENDP


RunGenesis      PROC
        LOCAL   cnt:DWORD=AUTO_SIZE

        push    ebp
        mov     ebp, esp

        sub     esp, AUTO_SIZE

        pushad

gen_cont:
        mov     esi, [rom_ptr]
        mov     [cnt], 110

g_exe_next:

        mov     eax, dword ptr[regs+pc]
        and     eax, 0ffffffh
        add     dword ptr[regs+pc], 2
        cmp     eax, 3fffffh
        jle     short rungen_isrom

        lea     edi, mem+ram_space-0ff0000h
        jmp     short rungen_isram

rungen_isrom:
        mov     edi, [rom_ptr]
rungen_isram:
        xor     ebx, ebx
        add     edi, eax
        mov     bx, word ptr[edi]
        xchg    bh, bl
        mov     [ExtOpCode], ebx

        ;inc     [profile_op+ebx*4]
        call    cpufunctbl[ebx*4]

        dec     [cnt]
        jnz     g_exe_next

        mov     ebx, [vdp_sr_ptr]
        mov     ax, word ptr[ebx]

        cmp     [cnt_dma_busy], 0
        je      short no_dma_busy
        dec     [cnt_dma_busy]
        jnz     short no_dma_busy
        and     ax, 0fffdh

no_dma_busy:
        cmp     [cnt_vert_intr], 0
        je      short no_vert_intr
        dec     [cnt_vert_intr]
        jnz     short no_vert_intr
        and     ax, 0ff7fh

no_vert_intr:
        cmp     [cnt_vert_blkf], 0
        je      short no_vert_blkf
        dec     [cnt_vert_blkf]
        jnz     short no_vert_blkf
        and     ax, 0fff7h

no_vert_blkf:
        cmp     [cnt_vert_blk], 0
        je      short no_vert_blk
        dec     [cnt_vert_blk]
        jnz     short no_vert_blk
        and     ax, 0fff7h
        pushad
        mov     word ptr[ebx], ax
        call    GoVDP
        popad
        mov     ax, word ptr[ebx]
;        jmp     short no_vert_blk

no_vert_blk:
        mov     word ptr[ebx], ax

        jmp     gen_cont

        popad

        mov     esp, ebp
        pop     ebp

        ret

RunGenesis      ENDP


op_0            PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        mov     dl, byte ptr[regs+d[ebx*4]]
        xchg    ah, al
        mov     dword ptr[regs+v], 0
        or      al, dl
        MAKE_SR_ZS
        mov     byte ptr[regs+d[ebx*4]], al
        ret
op_0            ENDP

op_10           PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        mov     dl, ah
        mov     eax, dword ptr[regs+a[ebx*4]]
        mov     dword ptr[regs+v], 0
        LOAD_B_MEDI
        or      dl, al
        MAKE_SR_ZS
        mov     byte ptr[edi], dl
        ret
op_10           ENDP

op_18           PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        mov     dl, ah
        mov     eax, dword ptr[regs+a[ebx*4]]
        mov     dword ptr[regs+v], 0
        LOAD_B_MEDI
        inc     dword ptr[regs+a[ebx*4]]
        or      dl, al
        MAKE_SR_ZS
        cmp     ebx, 7
        jne     short op18_noa7
        inc     dword ptr[regs+a[ebx*4]]
op18_noa7:
        mov     byte ptr[edi], dl
        ret
op_18           ENDP

op_20           PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        dec     dword ptr[regs+a[ebx*4]]
        cmp     ebx, 7
        jne     short op20_noa7
        dec     dword ptr[regs+a[ebx*4]]
op20_noa7:
        mov     dl, ah
        mov     eax, dword ptr[regs+a[ebx*4]]
        mov     dword ptr[regs+v], 0
        LOAD_B_MEDI
        or      dl, al
        MAKE_SR_ZS
        mov     byte ptr[edi], dl
        ret
op_20           ENDP

op_28           PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 4
        mov     dl, ah
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx*4]]
        mov     dword ptr[regs+v], 0
        LOAD_B_MEDI
        or      dl, al
        MAKE_SR_ZS
        mov     byte ptr[edi], dl
        ret
op_28           ENDP

op_30           PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 4
        mov     dl, ah
        mov     ax, word ptr[edi+4]
        push    dword ptr[regs+a[ebx*4]]
        xchg    ah, al
        GET_DISP_EA
        mov     dword ptr[regs+v], 0
        LOAD_B_MEDI
        or      dl, al
        MAKE_SR_ZS
        mov     byte ptr[edi], dl
        ret
op_30           ENDP

op_38           PROC
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 4
        mov     dl, ah
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        mov     dword ptr[regs+v], 0
        LOAD_B_MEDI
        or      dl, al
        MAKE_SR_ZS
        mov     byte ptr[edi], dl
        ret
op_38           ENDP

op_39           PROC
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 6
        mov     dl, ah
        mov     eax, dword ptr[edi+4]
        bswap   eax
        mov     dword ptr[regs+v], 0
        LOAD_B_MEDI
        or      dl, al
        MAKE_SR_ZS
        mov     byte ptr[edi], dl
        ret
op_39           ENDP

op_40           PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        mov     dx, word ptr[regs+d[ebx*4]]
        xchg    ah, al
        mov     dword ptr[regs+v], 0
        or      ax, dx
        MAKE_SR_ZS
        mov     word ptr[regs+d[ebx*4]], ax
        ret
op_40           ENDP

op_50           PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    dh, dl
        mov     eax, dword ptr[regs+a[ebx*4]]
        mov     dword ptr[regs+v], 0
        LOAD_W_MEDI
        or      dx, ax
        MAKE_SR_ZS
        xchg    dh, dl
        mov     word ptr[edi], dx
        ret
op_50           ENDP

op_58           PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ebx*4]]
        xchg    dh, dl
        LOAD_W_MEDI
        or      dx, ax
        MAKE_SR_ZS
        add     dword ptr[regs+a[ebx*4]], 2
        xchg    dh, dl
        mov     word ptr[edi], dx
        ret
op_58           ENDP

op_60           PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        sub     dword ptr[regs+a[ebx*4]], 2
        xchg    dh, dl
        mov     eax, dword ptr[regs+a[ebx*4]]
        mov     dword ptr[regs+v], 0
        LOAD_W_MEDI
        or      dx, ax
        MAKE_SR_ZS
        xchg    dh, dl
        mov     word ptr[edi], dx
        ret
op_60           ENDP

op_68           PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 4
        mov     ax, word ptr[edi+4]
        xchg    dh, dl
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx*4]]
        mov     dword ptr[regs+v], 0
        LOAD_W_MEDI
        or      dx, ax
        MAKE_SR_ZS
        xchg    dh, dl
        mov     word ptr[edi], dx
        ret
op_68           ENDP

op_70           PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 4
        mov     ax, word ptr[edi+4]
        push    dword ptr[regs+a[ebx*4]]
        mov     dword ptr[regs+v], 0
        xchg    dh, dl
        xchg    ah, al
        GET_DISP_EA
        LOAD_W_MEDI
        or      dx, ax
        MAKE_SR_ZS
        xchg    dh, dl
        mov     word ptr[edi], dx
        ret
op_70           ENDP

op_78           PROC
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 4
        mov     ax, word ptr[edi+4]
        xchg    dh, dl
        xchg    ah, al
        cwde
        mov     dword ptr[regs+v], 0
        LOAD_W_MEDI
        or      dx, ax
        MAKE_SR_ZS
        xchg    dh, dl
        mov     word ptr[edi], dx
        ret
op_78           ENDP

op_79           PROC
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 6
        mov     eax, dword ptr[edi+4]
        xchg    dh, dl
        bswap   eax
        mov     dword ptr[regs+v], 0
        LOAD_W_MEDI
        or      dx, ax
        MAKE_SR_ZS
        xchg    dh, dl
        mov     word ptr[edi], dx
        ret
op_79           ENDP

op_80           PROC
        and     ebx, 7
        mov     eax, dword ptr[edi+2]
        add     dword ptr[regs+pc], 4
        mov     edx, dword ptr[regs+d[ebx*4]]
        mov     dword ptr[regs+v], 0
        bswap   eax
        or      eax, edx
        MAKE_SR_ZS
        mov     dword ptr[regs+d[ebx*4]], eax
        ret
op_80           ENDP

op_90           PROC
        and     ebx, 7
        mov     edx, dword ptr[edi+2]
        add     dword ptr[regs+pc], 4
        mov     eax, dword ptr[regs+a[ebx*4]]
        mov     dword ptr[regs+v], 0
        bswap   edx
        LOAD_L_MEDI
        or      edx, eax
        MAKE_SR_ZS
        bswap   edx
        mov     dword ptr[edi], edx
        ret
op_90           ENDP

op_98           PROC
        and     ebx, 7
        mov     edx, dword ptr[edi+2]
        add     dword ptr[regs+pc], 4
        mov     eax, dword ptr[regs+a[ebx*4]]
        mov     dword ptr[regs+v], 0
        bswap   edx
        LOAD_L_MEDI
        or      edx, eax
        MAKE_SR_ZS
        add     dword ptr[regs+a[ebx*4]], 4
        bswap   edx
        mov     dword ptr[edi], edx
        ret
op_98           ENDP

op_a0           PROC
        and     ebx, 7
        mov     edx, dword ptr[edi+2]
        add     dword ptr[regs+pc], 4
        sub     dword ptr[regs+a[ebx*4]], 4
        bswap   edx
        mov     eax, dword ptr[regs+a[ebx*4]]
        mov     dword ptr[regs+v], 0
        LOAD_L_MEDI
        or      edx, eax
        MAKE_SR_ZS
        bswap   edx
        mov     dword ptr[edi], edx
        ret
op_a0           ENDP

op_a8           PROC
        and     ebx, 7
        mov     edx, dword ptr[edi+2]
        add     dword ptr[regs+pc], 6
        mov     ax, word ptr[edi+6]
        bswap   edx
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx*4]]
        mov     dword ptr[regs+v], 0
        LOAD_L_MEDI
        or      edx, eax
        MAKE_SR_ZS
        bswap   edx
        mov     dword ptr[edi], edx
        ret
op_a8           ENDP

op_b0           PROC
        and     ebx, 7
        mov     edx, dword ptr[edi+2]
        add     dword ptr[regs+pc], 6
        mov     ax, word ptr[edi+6]
        bswap   edx
        xchg    ah, al
        push    dword ptr[regs+a[ebx*4]]
        GET_DISP_EA
        mov     dword ptr[regs+v], 0
        LOAD_L_MEDI
        or      edx, eax
        MAKE_SR_ZS
        bswap   edx
        mov     dword ptr[edi], edx
        ret
op_b0           ENDP

op_b8           PROC
        mov     edx, dword ptr[edi+2]
        add     dword ptr[regs+pc], 6
        bswap   edx
        mov     ax, word ptr[edi+6]
        xchg    ah, al
        cwde
        mov     dword ptr[regs+v], 0
        LOAD_L_MEDI
        or      edx, eax
        MAKE_SR_ZS
        bswap   edx
        mov     dword ptr[edi], edx
        ret
op_b8           ENDP

op_b9           PROC
        mov     edx, dword ptr[edi+2]
        add     dword ptr[regs+pc], 8
        bswap   edx
        mov     eax, dword ptr[edi+6]
        mov     dword ptr[regs+v], 0
        bswap   eax
        LOAD_L_MEDI
        or      edx, eax
        MAKE_SR_ZS
        bswap   edx
        mov     dword ptr[edi], edx
        ret
op_b9           ENDP

op_200          PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        mov     dl, byte ptr[regs+d[ebx]]
        xchg    ah, al
        and     al, dl
        mov     dword ptr[regs+v], 0
        cmp     al, 0
        jne     short op200_next
        mov     byte ptr[regs+z], 1
op200_next:
        jge     short op200_next2
        mov     byte ptr[regs+n], 1
op200_next2:
        mov     byte ptr[regs+d[ebx]], al
        ret
op_200          ENDP

op_210          PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        mov     dl, ah
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        LOAD_B_MEDI
        and     dl, al
        cmp     dl, 0
        jne     short op210_next
        mov     byte ptr[regs+z], 1
op210_next:
        jge     short op210_next2
        mov     byte ptr[regs+n], 1
op210_next2:
        mov     byte ptr[edi], dl
        ret
op_210          ENDP

op_218          PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        mov     dl, ah
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        LOAD_B_MEDI
        inc     dword ptr[regs+a[ebx]]
        and     dl, al
        cmp     ebx, 28
        jne     short op218_noa7
        inc     dword ptr[regs+a[ebx]]
op218_noa7:
        cmp     dl, 0
        jne     short op218_next
        mov     byte ptr[regs+z], 1
op218_next:
        jge     short op218_next2
        mov     byte ptr[regs+n], 1
op218_next2:
        mov     byte ptr[edi], dl
        ret
op_218          ENDP

op_220          PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        dec     dword ptr[regs+a[ebx]]
        cmp     ebx, 28
        jne     short op220_noa7
        dec     dword ptr[regs+a[ebx]]
op220_noa7:
        mov     dl, ah
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        LOAD_B_MEDI
        and     dl, al
        cmp     dl, 0
        jne     short op220_next
        mov     byte ptr[regs+z], 1
op220_next:
        jge     short op220_next2
        mov     byte ptr[regs+n], 1
op220_next2:
        mov     byte ptr[edi], dl
        ret
op_220          ENDP

op_228          PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 4
        mov     ecx, dword ptr[regs+a[ebx]]
        mov     dl, ah
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        add     eax, ecx
        LOAD_B_MEDI
        and     dl, al
        mov     dword ptr[regs+v], 0
        cmp     dl, 0
        jne     short op228_next
        mov     byte ptr[regs+z], 1
op228_next:
        jge     short op228_next2
        mov     byte ptr[regs+n], 1
op228_next2:
        mov     byte ptr[edi], dl
        ret
op_228          ENDP

op_238          PROC
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 4
        mov     dl, ah
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        LOAD_B_MEDI
        and     dl, al
        mov     dword ptr[regs+v], 0
        cmp     dl, 0
        jne     short op238_next
        mov     byte ptr[regs+z], 1
op238_next:
        jge     short op238_next2
        mov     byte ptr[regs+n], 1
op238_next2:
        mov     byte ptr[edi], dl
        ret
op_238          ENDP

op_239          PROC
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 6
        mov     dl, ah
        mov     eax, dword ptr[edi+4]
        bswap   eax
        LOAD_B_MEDI
        and     dl, al
        mov     dword ptr[regs+v], 0
        cmp     dl, 0
        jne     short op239_next
        mov     byte ptr[regs+z], 1
op239_next:
        jge     short op239_next2
        mov     byte ptr[regs+n], 1
op239_next2:
        mov     byte ptr[edi], dl
        ret
op_239          ENDP

op_240          PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        mov     dx, word ptr[regs+d[ebx]]
        xchg    ah, al
        and     ax, dx
        mov     dword ptr[regs+v], 0
        cmp     ax, 0
        jne     short op240_next
        mov     byte ptr[regs+z], 1
op240_next:
        jge     short op240_next2
        mov     byte ptr[regs+n], 1
op240_next2:
        mov     word ptr[regs+d[ebx]], ax
        ret
op_240          ENDP

op_250          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        xchg    dh, dl
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        LOAD_W_MEDI
        and     dx, ax
        cmp     dx, 0
        jne     short op250_next
        mov     byte ptr[regs+z], 1
op250_next:
        jge     short op250_next2
        mov     byte ptr[regs+n], 1
op250_next2:
        xchg    dh, dl
        mov     word ptr[edi], dx
        ret
op_250          ENDP

op_258          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        xchg    dh, dl
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        LOAD_W_MEDI
        and     dx, ax
        add     dword ptr[regs+a[ebx]], 2
        cmp     dx, 0
        jne     short op258_next
        mov     byte ptr[regs+z], 1
op258_next:
        jge     short op258_next2
        mov     byte ptr[regs+n], 1
op258_next2:
        xchg    dh, dl
        mov     word ptr[edi], dx
        ret
op_258          ENDP

op_260          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        sub     dword ptr[regs+a[ebx]], 2
        xchg    dh, dl
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        LOAD_W_MEDI
        and     dx, ax
        cmp     dx, 0
        jne     short op260_next
        mov     byte ptr[regs+z], 1
op260_next:
        jge     short op260_next2
        mov     byte ptr[regs+n], 1
op260_next2:
        xchg    dh, dl
        mov     word ptr[edi], dx
        ret
op_260          ENDP

op_268          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 4
        mov     ecx, dword ptr[regs+a[ebx]]
        mov     ax, word ptr[edi+4]
        xchg    dh, dl
        xchg    ah, al
        cwde
        add     eax, ecx
        LOAD_W_MEDI
        and     dx, ax
        mov     dword ptr[regs+v], 0
        cmp     dx, 0
        jne     short op268_next
        mov     byte ptr[regs+z], 1
op268_next:
        jge     short op268_next2
        mov     byte ptr[regs+n], 1
op268_next2:
        xchg    dh, dl
        mov     word ptr[edi], dx
        ret
op_268          ENDP

op_278          PROC
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 4
        mov     ax, word ptr[edi+4]
        xchg    dh, dl
        xchg    ah, al
        cwde
        LOAD_W_MEDI
        and     dx, ax
        mov     dword ptr[regs+v], 0
        cmp     dx, 0
        jne     short op278_next
        mov     byte ptr[regs+z], 1
op278_next:
        jge     short op278_next2
        mov     byte ptr[regs+n], 1
op278_next2:
        xchg    dh, dl
        mov     word ptr[edi], dx
        ret
op_278          ENDP

op_279          PROC
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 6
        mov     eax, dword ptr[edi+4]
        xchg    dh, dl
        bswap   eax
        LOAD_W_MEDI
        and     dx, ax
        mov     dword ptr[regs+v], 0
        cmp     dx, 0
        jne     short op279_next
        mov     byte ptr[regs+z], 1
op279_next:
        jge     short op279_next2
        mov     byte ptr[regs+n], 1
op279_next2:
        xchg    dh, dl
        mov     word ptr[edi], dx
        ret
op_279          ENDP

op_280          PROC
        and     ebx, 7
        mov     eax, dword ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 4
        mov     edx, dword ptr[regs+d[ebx]]
        bswap   eax
        and     eax, edx
        mov     dword ptr[regs+v], 0
        cmp     eax, 0
        jne     short op280_next
        mov     byte ptr[regs+z], 1
op280_next:
        jge     short op280_next2
        mov     byte ptr[regs+n], 1
op280_next2:
        mov     dword ptr[regs+d[ebx]], eax
        ret
op_280          ENDP

op_290          PROC
        and     ebx, 7
        mov     edx, dword ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 4
        bswap   edx
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        LOAD_L_MEDI
        and     edx, eax
        cmp     edx, 0
        jne     short op290_next
        mov     byte ptr[regs+z], 1
op290_next:
        jge     short op290_next2
        mov     byte ptr[regs+n], 1
op290_next2:
        bswap   edx
        mov     dword ptr[edi], edx
        ret
op_290          ENDP

op_298          PROC
        and     ebx, 7
        mov     edx, dword ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 4
        bswap   edx
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        LOAD_L_MEDI
        and     edx, eax
        add     dword ptr[regs+a[ebx]], 4
        cmp     edx, 0
        jne     short op298_next
        mov     byte ptr[regs+z], 1
op298_next:
        jge     short op298_next2
        mov     byte ptr[regs+n], 1
op298_next2:
        bswap   edx
        mov     dword ptr[edi], edx
        ret
op_298          ENDP

op_2a0          PROC
        and     ebx, 7
        mov     edx, dword ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 4
        sub     dword ptr[regs+a[ebx]], 4
        bswap   edx
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        LOAD_L_MEDI
        and     edx, eax
        cmp     edx, 0
        jne     short op2a0_next
        mov     byte ptr[regs+z], 1
op2a0_next:
        jge     short op2a0_next2
        mov     byte ptr[regs+n], 1
op2a0_next2:
        bswap   edx
        mov     dword ptr[edi], edx
        ret
op_2a0          ENDP

op_2a8          PROC
        and     ebx, 7
        mov     edx, dword ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 6
        mov     ecx, dword ptr[regs+a[ebx]]
        mov     ax, word ptr[edi+6]
        bswap   edx
        xchg    ah, al
        cwde
        add     eax, ecx
        LOAD_L_MEDI
        and     edx, eax
        mov     dword ptr[regs+v], 0
        cmp     edx, 0
        jne     short op2a8_next
        mov     byte ptr[regs+z], 1
op2a8_next:
        jge     short op2a8_next2
        mov     byte ptr[regs+n], 1
op2a8_next2:
        bswap   edx
        mov     dword ptr[edi], edx
        ret
op_2a8          ENDP

op_2b8          PROC
        mov     edx, dword ptr[edi+2]
        add     dword ptr[regs+pc], 6
        bswap   edx
        mov     ax, word ptr[edi+6]
        xchg    ah, al
        cwde
        LOAD_L_MEDI
        and     edx, eax
        mov     dword ptr[regs+v], 0
        cmp     edx, 0
        jne     short op2b8_next
        mov     byte ptr[regs+z], 1
op2b8_next:
        jge     short op2b8_next2
        mov     byte ptr[regs+n], 1
op2b8_next2:
        bswap   edx
        mov     dword ptr[edi], edx
        ret
op_2b8          ENDP

op_2b9          PROC
        mov     edx, dword ptr[edi+2]
        add     dword ptr[regs+pc], 8
        bswap   edx
        mov     eax, dword ptr[edi+6]
        bswap   eax
        LOAD_L_MEDI
        and     edx, eax
        mov     dword ptr[regs+v], 0
        cmp     edx, 0
        jne     short op2b9_next
        mov     byte ptr[regs+z], 1
op2b9_next:
        jge     short op2b9_next2
        mov     byte ptr[regs+n], 1
op2b9_next2:
        bswap   edx
        mov     dword ptr[edi], edx
        ret
op_2b9          ENDP

op_400        PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        mov     dl, byte ptr[regs+d[ebx]]
        sub     dl, ah
        MAKE_SR_JX
        mov     byte ptr[regs+d[ebx]], dl
        ret
op_400           ENDP

op_410          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_B_MEDI
        sub     al, dh
        MAKE_SR_JX
        mov     byte ptr[edi], al
        ret
op_410          ENDP

op_418          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_B_MEDI
        inc     dword ptr[regs+a[ebx]]
        sub     al, dh
        MAKE_SR_JX
        cmp     ebx, 28
        jne     short op418_noa7
        inc     dword ptr[regs+a[ebx]]
op418_noa7:
        mov     byte ptr[edi], al
        ret
op_418          ENDP

op_420          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        dec     dword ptr[regs+a[ebx]]
        cmp     ebx, 28
        jne     short op420_noa7
        dec     dword ptr[regs+a[ebx]]
op420_noa7:
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_B_MEDI
        sub     al, dh
        MAKE_SR_JX
        mov     byte ptr[edi], al
        ret
op_420          ENDP

op_428          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 4
        mov     ecx, dword ptr[regs+a[ebx]]
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        add     eax, ecx
        LOAD_B_MEDI
        sub     al, dh
        MAKE_SR_JX
        mov     byte ptr[edi], al
        ret
op_428          ENDP

op_438          PROC
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 4
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        LOAD_B_MEDI
        sub     al, dh
        MAKE_SR_JX
        mov     byte ptr[edi], al
        ret
op_438          ENDP

op_439          PROC
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 6
        mov     eax, dword ptr[edi+4]
        bswap   eax
        LOAD_B_MEDI
        sub     al, dh
        MAKE_SR_JX
        mov     byte ptr[edi], al
        ret
op_439          ENDP

op_440          PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        mov     dx, word ptr[regs+d[ebx]]
        xchg    ah, al
        sub     dx, ax
        MAKE_SR_JX
        mov     word ptr[regs+d[ebx]], dx
        ret
op_440          ENDP

op_450          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        mov     eax, dword ptr[regs+a[ebx]]
        xchg    dh, dl
        LOAD_W_MEDI
        sub     ax, dx
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_450          ENDP

op_458          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_W_MEDI
        xchg    dh, dl
        add     dword ptr[regs+a[ebx]], 2
        sub     ax, dx
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_458          ENDP

op_460          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        shl     ebx, 2
        sub     dword ptr[regs+a[ebx]], 2
        add     dword ptr[regs+pc], 2
        mov     eax, dword ptr[regs+a[ebx]]
        xchg    dh, dl
        LOAD_W_MEDI
        sub     ax, dx
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_460          ENDP

op_468          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 4
        mov     ecx, dword ptr[regs+a[ebx]]
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        xchg    dh, dl
        cwde
        add     eax, ecx
        LOAD_W_MEDI
        sub     ax, dx
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_468          ENDP

op_478          PROC
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 4
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        xchg    dh, dl
        cwde
        LOAD_W_MEDI
        sub     ax, dx
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_478          ENDP

op_479          PROC
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 6
        mov     eax, dword ptr[edi+4]
        bswap   eax
        xchg    dh, dl
        LOAD_W_MEDI
        sub     ax, dx
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_479          ENDP

op_480          PROC
        and     ebx, 7
        mov     eax, dword ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 4
        mov     edx, dword ptr[regs+d[ebx]]
        bswap   eax
        sub     edx, eax
        MAKE_SR_JX
        mov     dword ptr[regs+d[ebx]], edx
        ret
op_480          ENDP

op_490          PROC
        and     ebx, 7
        mov     edx, dword ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 4
        mov     eax, dword ptr[regs+a[ebx]]
        bswap   edx
        LOAD_L_MEDI
        sub     eax, edx
        MAKE_SR_JX
        bswap   eax
        mov     dword ptr[edi], eax
        ret
op_490          ENDP

op_498          PROC
        and     ebx, 7
        mov     edx, dword ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 4
        mov     eax, dword ptr[regs+a[ebx]]
        bswap   edx
        LOAD_L_MEDI
        add     dword ptr[regs+a[ebx]], 4
        sub     eax, edx
        MAKE_SR_JX
        bswap   eax
        mov     dword ptr[edi], eax
        ret
op_498          ENDP

op_4a0          PROC
        and     ebx, 7
        mov     edx, dword ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 4
        sub     dword ptr[regs+a[ebx]], 4
        mov     eax, dword ptr[regs+a[ebx]]
        bswap   edx
        LOAD_L_MEDI
        sub     eax, edx
        MAKE_SR_JX
        bswap   eax
        mov     dword ptr[edi], eax
        ret
op_4a0          ENDP

op_4a8          PROC
        and     ebx, 7
        mov     edx, dword ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 6
        mov     ax, word ptr[edi+6]
        mov     ecx, dword ptr[regs+a[ebx]]
        bswap   edx
        xchg    ah, al
        cwde
        sub     eax, ecx
        LOAD_L_MEDI
        add     eax, edx
        MAKE_SR_JX
        bswap   eax
        mov     dword ptr[edi], eax
        ret
op_4a8          ENDP

op_4b8          PROC
        mov     edx, dword ptr[edi+2]
        add     dword ptr[regs+pc], 6
        mov     ax, word ptr[edi+6]
        bswap   edx
        xchg    ah, al
        cwde
        LOAD_L_MEDI
        sub     eax, edx
        MAKE_SR_JX
        bswap   eax
        mov     dword ptr[edi], eax
        ret
op_4b8          ENDP

op_4b9          PROC
        mov     edx, dword ptr[edi+2]
        add     dword ptr[regs+pc], 8
        mov     eax, dword ptr[edi+6]
        bswap   edx
        bswap   eax
        LOAD_L_MEDI
        sub     eax, edx
        MAKE_SR_JX
        bswap   eax
        mov     dword ptr[edi], eax
        ret
op_4b9          ENDP

op_600        PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        mov     dl, byte ptr[regs+d[ebx]]
        add     dl, ah
        MAKE_SR_JX
        mov     byte ptr[regs+d[ebx]], dl
        ret
op_600           ENDP

op_610          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_B_MEDI
        add     al, dh
        MAKE_SR_JX
        mov     byte ptr[edi], al
        ret
op_610          ENDP

op_618          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_B_MEDI
        inc     dword ptr[regs+a[ebx]]
        add     al, dh
        MAKE_SR_JX
        cmp     ebx, 28
        jne     short op618_noa7
        inc     dword ptr[regs+a[ebx]]
op618_noa7:
        mov     byte ptr[edi], al
        ret
op_618          ENDP

op_620          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        dec     dword ptr[regs+a[ebx]]
        cmp     ebx, 28
        jne     short op620_noa7
        dec     dword ptr[regs+a[ebx]]
op620_noa7:
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_B_MEDI
        add     al, dh
        MAKE_SR_JX
        mov     byte ptr[edi], al
        ret
op_620          ENDP

op_628          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 4
        mov     ecx, dword ptr[regs+a[ebx]]
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        add     eax, ecx
        LOAD_B_MEDI
        add     al, dh
        MAKE_SR_JX
        mov     byte ptr[edi], al
        ret
op_628          ENDP

op_638          PROC
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 4
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        LOAD_B_MEDI
        add     al, dh
        MAKE_SR_JX
        mov     byte ptr[edi], al
        ret
op_638          ENDP

op_639          PROC
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 6
        mov     eax, dword ptr[edi+4]
        bswap   eax
        LOAD_B_MEDI
        add     al, dh
        MAKE_SR_JX
        mov     byte ptr[edi], al
        ret
op_639          ENDP

op_640          PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        mov     dx, word ptr[regs+d[ebx]]
        xchg    ah, al
        add     dx, ax
        MAKE_SR_JX
        mov     word ptr[regs+d[ebx]], dx
        ret
op_640          ENDP

op_650          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        mov     eax, dword ptr[regs+a[ebx]]
        xchg    dh, dl
        LOAD_W_MEDI
        add     ax, dx
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_650          ENDP

op_658          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_W_MEDI
        xchg    dh, dl
        add     dword ptr[regs+a[ebx]], 2
        add     ax, dx
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_658          ENDP

op_660          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        shl     ebx, 2
        sub     dword ptr[regs+a[ebx]], 2
        add     dword ptr[regs+pc], 2
        mov     eax, dword ptr[regs+a[ebx]]
        xchg    dh, dl
        LOAD_W_MEDI
        add     ax, dx
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_660          ENDP

op_668          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 4
        mov     ecx, dword ptr[regs+a[ebx]]
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        xchg    dh, dl
        cwde
        add     eax, ecx
        LOAD_W_MEDI
        add     ax, dx
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_668          ENDP

op_678          PROC
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 4
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        xchg    dh, dl
        cwde
        LOAD_W_MEDI
        add     ax, dx
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_678          ENDP

op_679          PROC
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 6
        mov     eax, dword ptr[edi+4]
        bswap   eax
        xchg    dh, dl
        LOAD_W_MEDI
        add     ax, dx
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_679          ENDP

op_680          PROC
        and     ebx, 7
        mov     eax, dword ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 4
        mov     edx, dword ptr[regs+d[ebx]]
        bswap   eax
        add     edx, eax
        MAKE_SR_JX
        mov     dword ptr[regs+d[ebx]], edx
        ret
op_680          ENDP

op_690          PROC
        and     ebx, 7
        mov     edx, dword ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 4
        mov     eax, dword ptr[regs+a[ebx]]
        bswap   edx
        LOAD_L_MEDI
        add     eax, edx
        MAKE_SR_JX
        bswap   eax
        mov     dword ptr[edi], eax
        ret
op_690          ENDP

op_698          PROC
        and     ebx, 7
        mov     edx, dword ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 4
        mov     eax, dword ptr[regs+a[ebx]]
        bswap   edx
        LOAD_L_MEDI
        add     dword ptr[regs+a[ebx]], 4
        add     eax, edx
        MAKE_SR_JX
        bswap   eax
        mov     dword ptr[edi], eax
        ret
op_698          ENDP

op_6a0          PROC
        and     ebx, 7
        mov     edx, dword ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 4
        sub     dword ptr[regs+a[ebx]], 4
        mov     eax, dword ptr[regs+a[ebx]]
        bswap   edx
        LOAD_L_MEDI
        add     eax, edx
        MAKE_SR_JX
        bswap   eax
        mov     dword ptr[edi], eax
        ret
op_6a0          ENDP

op_6a8          PROC
        and     ebx, 7
        mov     edx, dword ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 6
        mov     ax, word ptr[edi+6]
        mov     ecx, dword ptr[regs+a[ebx]]
        bswap   edx
        xchg    ah, al
        cwde
        add     eax, ecx
        LOAD_L_MEDI
        add     eax, edx
        MAKE_SR_JX
        bswap   eax
        mov     dword ptr[edi], eax
        ret
op_6a8          ENDP

op_6b8          PROC
        mov     edx, dword ptr[edi+2]
        add     dword ptr[regs+pc], 6
        mov     ax, word ptr[edi+6]
        bswap   edx
        xchg    ah, al
        cwde
        LOAD_L_MEDI
        add     eax, edx
        MAKE_SR_JX
        bswap   eax
        mov     dword ptr[edi], eax
        ret
op_6b8          ENDP

op_6b9          PROC
        mov     edx, dword ptr[edi+2]
        add     dword ptr[regs+pc], 8
        mov     eax, dword ptr[edi+6]
        bswap   edx
        bswap   eax
        LOAD_L_MEDI
        add     eax, edx
        MAKE_SR_JX
        bswap   eax
        mov     dword ptr[edi], eax
        ret
op_6b9          ENDP

op_800          PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        mov     edx, dword ptr[regs+d[ebx]]
        xchg    ah, al
;       and     eax, 1fh
;       bt      edx, eax
        mov     ebx, 1
        and     eax, 1fh
        mov     cl, al
        shl     ebx, cl
        test    edx, ebx
;       jnc     op800_isz
        jz      op800_isz
        mov     byte ptr[regs+z], 0
        ret
op800_isz:
        mov     byte ptr[regs+z], 1
        ret
op_800          ENDP

op_810          PROC
        and     ebx, 7
        mov     cx, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        xchg    ch, cl
        mov     eax, dword ptr[regs+a[ebx]]
        mov     ebx, 1
        and     cl, 7
        LOAD_B_MEM
        shl     ebx, cl
        test    eax, ebx
        jz      op810_isz
        mov     byte ptr[regs+z], 0
        ret
op810_isz:
        mov     byte ptr[regs+z], 1
        ret
op_810          ENDP

op_a00          PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        mov     dl, byte ptr[regs+d[ebx*4]]
        xchg    ah, al
        mov     dword ptr[regs+v], 0
        xor     al, dl
        MAKE_SR_ZS
        mov     byte ptr[regs+d[ebx*4]], al
        ret
op_a00          ENDP

op_a10          PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        mov     dl, ah
        mov     eax, dword ptr[regs+a[ebx*4]]
        mov     dword ptr[regs+v], 0
        LOAD_B_MEDI
        xor     dl, al
        MAKE_SR_ZS
        mov     byte ptr[edi], dl
        ret
op_a10          ENDP

op_a18          PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        mov     dl, ah
        mov     eax, dword ptr[regs+a[ebx*4]]
        mov     dword ptr[regs+v], 0
        LOAD_B_MEDI
        inc     dword ptr[regs+a[ebx*4]]
        xor     dl, al
        MAKE_SR_ZS
        cmp     ebx, 7
        jne     short opa18_noa7
        inc     dword ptr[regs+a[ebx*4]]
opa18_noa7:
        mov     byte ptr[edi], dl
        ret
op_a18           ENDP

op_a20          PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        dec     dword ptr[regs+a[ebx*4]]
        cmp     ebx, 7
        jne     short opa20_noa7
        dec     dword ptr[regs+a[ebx*4]]
opa20_noa7:
        mov     dl, ah
        mov     eax, dword ptr[regs+a[ebx*4]]
        mov     dword ptr[regs+v], 0
        LOAD_B_MEDI
        xor     dl, al
        MAKE_SR_ZS
        mov     byte ptr[edi], dl
        ret
op_a20          ENDP

op_a28          PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 4
        mov     dl, ah
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx*4]]
        mov     dword ptr[regs+v], 0
        LOAD_B_MEDI
        xor     dl, al
        MAKE_SR_ZS
        mov     byte ptr[edi], dl
        ret
op_a28          ENDP

op_a30          PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 4
        mov     dl, ah
        mov     ax, word ptr[edi+4]
        push    dword ptr[regs+a[ebx*4]]
        xchg    ah, al
        GET_DISP_EA
        mov     dword ptr[regs+v], 0
        LOAD_B_MEDI
        xor     dl, al
        MAKE_SR_ZS
        mov     byte ptr[edi], dl
        ret
op_a30          ENDP

op_a38          PROC
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 4
        mov     dl, ah
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        mov     dword ptr[regs+v], 0
        LOAD_B_MEDI
        xor     dl, al
        MAKE_SR_ZS
        mov     byte ptr[edi], dl
        ret
op_a38          ENDP

op_a39          PROC
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 6
        mov     dl, ah
        mov     eax, dword ptr[edi+4]
        bswap   eax
        mov     dword ptr[regs+v], 0
        LOAD_B_MEDI
        xor     dl, al
        MAKE_SR_ZS
        mov     byte ptr[edi], dl
        ret
op_a39          ENDP

op_a40          PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        mov     dx, word ptr[regs+d[ebx*4]]
        xchg    ah, al
        mov     dword ptr[regs+v], 0
        xor     ax, dx
        MAKE_SR_ZS
        mov     word ptr[regs+d[ebx*4]], ax
        ret
op_a40          ENDP

op_a50          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    dh, dl
        mov     eax, dword ptr[regs+a[ebx*4]]
        mov     dword ptr[regs+v], 0
        LOAD_W_MEDI
        xor     dx, ax
        MAKE_SR_ZS
        xchg    dh, dl
        mov     word ptr[edi], dx
        ret
op_a50          ENDP

op_a58          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ebx*4]]
        xchg    dh, dl
        LOAD_W_MEDI
        xor     dx, ax
        MAKE_SR_ZS
        add     dword ptr[regs+a[ebx*4]], 2
        xchg    dh, dl
        mov     word ptr[edi], dx
        ret
op_a58          ENDP

op_a60          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        sub     dword ptr[regs+a[ebx*4]], 2
        xchg    dh, dl
        mov     eax, dword ptr[regs+a[ebx*4]]
        mov     dword ptr[regs+v], 0
        LOAD_W_MEDI
        xor     dx, ax
        MAKE_SR_ZS
        xchg    dh, dl
        mov     word ptr[edi], dx
        ret
op_a60          ENDP

op_a68          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 4
        mov     ax, word ptr[edi+4]
        xchg    dh, dl
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx*4]]
        mov     dword ptr[regs+v], 0
        LOAD_W_MEDI
        xor     dx, ax
        MAKE_SR_ZS
        xchg    dh, dl
        mov     word ptr[edi], dx
        ret
op_a68          ENDP

op_a70          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 4
        mov     ax, word ptr[edi+4]
        push    dword ptr[regs+a[ebx*4]]
        mov     dword ptr[regs+v], 0
        xchg    dh, dl
        xchg    ah, al
        GET_DISP_EA
        LOAD_W_MEDI
        xor     dx, ax
        MAKE_SR_ZS
        xchg    dh, dl
        mov     word ptr[edi], dx
        ret
op_a70          ENDP

op_a78          PROC
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 4
        mov     ax, word ptr[edi+4]
        xchg    dh, dl
        xchg    ah, al
        cwde
        mov     dword ptr[regs+v], 0
        LOAD_W_MEDI
        xor     dx, ax
        MAKE_SR_ZS
        xchg    dh, dl
        mov     word ptr[edi], dx
        ret
op_a78          ENDP

op_a79          PROC
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 6
        mov     eax, dword ptr[edi+4]
        xchg    dh, dl
        bswap   eax
        mov     dword ptr[regs+v], 0
        LOAD_W_MEDI
        xor     dx, ax
        MAKE_SR_ZS
        xchg    dh, dl
        mov     word ptr[edi], dx
        ret
op_a79          ENDP

op_a80          PROC
        and     ebx, 7
        mov     eax, dword ptr[edi+2]
        add     dword ptr[regs+pc], 4
        mov     edx, dword ptr[regs+d[ebx*4]]
        mov     dword ptr[regs+v], 0
        bswap   eax
        xor     eax, edx
        MAKE_SR_ZS
        mov     dword ptr[regs+d[ebx*4]], eax
        ret
op_a80          ENDP

op_a90          PROC
        and     ebx, 7
        mov     edx, dword ptr[edi+2]
        add     dword ptr[regs+pc], 4
        mov     eax, dword ptr[regs+a[ebx*4]]
        mov     dword ptr[regs+v], 0
        bswap   edx
        LOAD_L_MEDI
        xor     edx, eax
        MAKE_SR_ZS
        bswap   edx
        mov     dword ptr[edi], edx
        ret
op_a90          ENDP

op_a98          PROC
        and     ebx, 7
        mov     edx, dword ptr[edi+2]
        add     dword ptr[regs+pc], 4
        mov     eax, dword ptr[regs+a[ebx*4]]
        mov     dword ptr[regs+v], 0
        bswap   edx
        LOAD_L_MEDI
        xor     edx, eax
        MAKE_SR_ZS
        add     dword ptr[regs+a[ebx*4]], 4
        bswap   edx
        mov     dword ptr[edi], edx
        ret
op_a98          ENDP

op_aa0          PROC
        and     ebx, 7
        mov     edx, dword ptr[edi+2]
        add     dword ptr[regs+pc], 4
        sub     dword ptr[regs+a[ebx*4]], 4
        bswap   edx
        mov     eax, dword ptr[regs+a[ebx*4]]
        mov     dword ptr[regs+v], 0
        LOAD_L_MEDI
        xor     edx, eax
        MAKE_SR_ZS
        bswap   edx
        mov     dword ptr[edi], edx
        ret
op_aa0          ENDP

op_aa8          PROC
        and     ebx, 7
        mov     edx, dword ptr[edi+2]
        add     dword ptr[regs+pc], 6
        mov     ax, word ptr[edi+6]
        bswap   edx
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx*4]]
        mov     dword ptr[regs+v], 0
        LOAD_L_MEDI
        xor     edx, eax
        MAKE_SR_ZS
        bswap   edx
        mov     dword ptr[edi], edx
        ret
op_aa8          ENDP

op_ab0          PROC
        and     ebx, 7
        mov     edx, dword ptr[edi+2]
        add     dword ptr[regs+pc], 6
        mov     ax, word ptr[edi+6]
        bswap   edx
        xchg    ah, al
        push    dword ptr[regs+a[ebx*4]]
        GET_DISP_EA
        mov     dword ptr[regs+v], 0
        LOAD_L_MEDI
        xor     edx, eax
        MAKE_SR_ZS
        bswap   edx
        mov     dword ptr[edi], edx
        ret
op_ab0          ENDP

op_ab8          PROC
        mov     edx, dword ptr[edi+2]
        add     dword ptr[regs+pc], 6
        bswap   edx
        mov     ax, word ptr[edi+6]
        xchg    ah, al
        cwde
        mov     dword ptr[regs+v], 0
        LOAD_L_MEDI
        xor     edx, eax
        MAKE_SR_ZS
        bswap   edx
        mov     dword ptr[edi], edx
        ret
op_ab8          ENDP

op_ab9          PROC
        mov     edx, dword ptr[edi+2]
        add     dword ptr[regs+pc], 8
        bswap   edx
        mov     eax, dword ptr[edi+6]
        mov     dword ptr[regs+v], 0
        bswap   eax
        LOAD_L_MEDI
        xor     edx, eax
        MAKE_SR_ZS
        bswap   edx
        mov     dword ptr[edi], edx
        ret
op_ab9          ENDP

op_c00          PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        mov     dl, byte ptr[regs+d[ebx]]
        cmp     dl, ah
        MAKE_SR_J
        ret
op_c00           ENDP

op_c10          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_B_MEM
        cmp     al, dh
        MAKE_SR_J
        ret
op_c10          ENDP

op_c18          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_B_MEM
        inc     dword ptr[regs+a[ebx]]
        cmp     al, dh
        MAKE_SR_J
        cmp     ebx, 28
        jne     short opc18_noa7
        inc     dword ptr[regs+a[ebx]]
opc18_noa7:
        ret
op_c18          ENDP

op_c20          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        dec     dword ptr[regs+a[ebx]]
        cmp     ebx, 28
        jne     short opc20_noa7
        dec     dword ptr[regs+a[ebx]]
opc20_noa7:
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_B_MEM
        cmp     al, dh
        MAKE_SR_J
        ret
op_c20          ENDP

op_c28          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 4
        mov     ecx, dword ptr[regs+a[ebx]]
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        add     eax, ecx
        LOAD_B_MEM
        cmp     al, dh
        MAKE_SR_J
        ret
op_c28          ENDP

op_c38          PROC
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 4
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        LOAD_B_MEM
        cmp     al, dh
        MAKE_SR_J
        ret
op_c38          ENDP

op_c39          PROC
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 6
        mov     eax, dword ptr[edi+4]
        bswap   eax
        LOAD_B_MEM
        cmp     al, dh
        MAKE_SR_J
        ret
op_c39          ENDP

op_c40          PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        mov     dx, word ptr[regs+d[ebx]]
        xchg    ah, al
        cmp     dx, ax
        MAKE_SR_J
        ret
op_c40          ENDP

op_c50          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        mov     eax, dword ptr[regs+a[ebx]]
        xchg    dh, dl
        LOAD_W_MEM
        cmp     ax, dx
        MAKE_SR_J
        ret
op_c50          ENDP

op_c58          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_W_MEM
        xchg    dh, dl
        add     dword ptr[regs+a[ebx]], 2
        cmp     ax, dx
        MAKE_SR_J
        ret
op_c58          ENDP

op_c60          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        shl     ebx, 2
        sub     dword ptr[regs+a[ebx]], 2
        add     dword ptr[regs+pc], 2
        mov     eax, dword ptr[regs+a[ebx]]
        xchg    dh, dl
        LOAD_W_MEM
        cmp     ax, dx
        MAKE_SR_J
        ret
op_c60          ENDP

op_c68          PROC
        and     ebx, 7
        mov     dx, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 4
        mov     ecx, dword ptr[regs+a[ebx]]
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        xchg    dh, dl
        cwde
        add     eax, ecx
        LOAD_W_MEM
        cmp     ax, dx
        MAKE_SR_J
        ret
op_c68          ENDP

op_c78          PROC
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 4
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        xchg    dh, dl
        cwde
        LOAD_W_MEM
        cmp     ax, dx
        MAKE_SR_J
        ret
op_c78          ENDP

op_c79          PROC
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 6
        mov     eax, dword ptr[edi+4]
        bswap   eax
        xchg    dh, dl
        LOAD_W_MEM
        cmp     ax, dx
        MAKE_SR_J
        ret
op_c79          ENDP

op_c80          PROC
        and     ebx, 7
        mov     eax, dword ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 4
        mov     edx, dword ptr[regs+d[ebx]]
        bswap   eax
        cmp     edx, eax
        MAKE_SR_J
        ret
op_c80          ENDP

op_c90          PROC
        and     ebx, 7
        mov     edx, dword ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 4
        mov     eax, dword ptr[regs+a[ebx]]
        bswap   edx
        LOAD_L_MEM
        cmp     eax, edx
        MAKE_SR_J
        ret
op_c90          ENDP

op_c98          PROC
        and     ebx, 7
        mov     edx, dword ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 4
        mov     eax, dword ptr[regs+a[ebx]]
        bswap   edx
        LOAD_L_MEM
        add     dword ptr[regs+a[ebx]], 4
        cmp     eax, edx
        MAKE_SR_J
        ret
op_c98          ENDP

op_ca0          PROC
        and     ebx, 7
        mov     edx, dword ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 4
        sub     dword ptr[regs+a[ebx]], 4
        mov     eax, dword ptr[regs+a[ebx]]
        bswap   edx
        LOAD_L_MEM
        cmp     eax, edx
        MAKE_SR_J
        ret
op_ca0          ENDP

op_ca8          PROC
        and     ebx, 7
        mov     edx, dword ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 6
        mov     ax, word ptr[edi+6]
        mov     ecx, dword ptr[regs+a[ebx]]
        bswap   edx
        xchg    ah, al
        cwde
        add     eax, ecx
        LOAD_L_MEM
        cmp     eax, edx
        MAKE_SR_J
        ret
op_ca8          ENDP

op_cb8          PROC
        mov     edx, dword ptr[edi+2]
        add     dword ptr[regs+pc], 6
        mov     ax, word ptr[edi+6]
        bswap   edx
        xchg    ah, al
        cwde
        LOAD_L_MEM
        cmp     eax, edx
        MAKE_SR_J
        ret
op_cb8          ENDP

op_cb9          PROC
        mov     edx, dword ptr[edi+2]
        add     dword ptr[regs+pc], 8
        mov     eax, dword ptr[edi+6]
        bswap   edx
        bswap   eax
        LOAD_L_MEM
        cmp     eax, edx
        MAKE_SR_J
        ret
op_cb9          ENDP

op_1000         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     dl, byte ptr[regs+d[ebx*4]]
        and     ecx, 1ch
        mov     dword ptr[regs+v], 0
        cmp     dl, 0
        MAKE_SR_Z
        mov     byte ptr[regs+d[ecx]], dl
        ret
op_1000         ENDP

op_1010         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     dword ptr[regs+v], 0
        LOAD_B_MEM
        cmp     al, 0
        MAKE_SR_Z
        mov     byte ptr[regs+d[ecx]], al
        ret
op_1010         ENDP

op_1018         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        inc     dword ptr[regs+a[ebx*4]]
        cmp     ebx, 7
        jne     short op1018_noa7
        inc     dword ptr[regs+a[ebx*4]]
op1018_noa7:
        mov     dword ptr[regs+v], 0
        LOAD_B_MEM
        cmp     al, 0
        MAKE_SR_Z
        mov     byte ptr[regs+d[ecx]], al
        ret
op_1018          ENDP

op_1020         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        dec     dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        cmp     ebx, 7
        jne     op1020_noa7
        dec     dword ptr[regs+a[ebx*4]]
op1020_noa7:
        mov     eax, dword ptr[regs+a[ebx*4]]
        mov     dword ptr[regs+v], 0
        LOAD_B_MEM
        cmp     al, 0
        MAKE_SR_Z
        mov     byte ptr[regs+d[ecx]], al
        ret
op_1020         ENDP

op_1028         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     ebx, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ebx
        mov     dword ptr[regs+v], 0
        LOAD_B_MEM
        cmp     al, 0
        MAKE_SR_Z
        mov     byte ptr[regs+d[ecx]], al
        ret
op_1028         ENDP

op_1030         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        push    dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        mov     dword ptr[regs+v], 0
        GET_DISP_EA
        LOAD_B_MEM
        cmp     al, 0
        MAKE_SR_Z
        mov     byte ptr[regs+d[ecx]], al
        ret
op_1030         ENDP

op_1038         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        mov     dword ptr[regs+v], 0
        LOAD_B_MEM
        cmp     al, 0
        MAKE_SR_Z
        mov     byte ptr[regs+d[ebx]], al
        ret
op_1038         ENDP

op_1039         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        bswap   eax
        mov     dword ptr[regs+v], 0
        LOAD_B_MEM
        cmp     al, 0
        MAKE_SR_Z
        mov     byte ptr[regs+d[ebx]], al
        ret
op_1039         ENDP

op_103a         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        mov     ecx, dword ptr[regs+pc]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ecx
        mov     dword ptr[regs+v], 0
        LOAD_B_MEM
        cmp     al, 0
        MAKE_SR_Z
        mov     byte ptr[regs+d[ebx]], al
        ret
op_103a         ENDP

op_103b         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        push    dword ptr[regs+pc]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        mov     dword ptr[regs+v], 0
        mov     ecx, ebx
        GET_DISP_EA
        LOAD_B_MEM
        cmp     al, 0
        MAKE_SR_Z
        mov     byte ptr[regs+d[ecx]], al
        ret
op_103b         ENDP

op_103c         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        mov     dword ptr[regs+v], 0
        cmp     ah, 0
        MAKE_SR_Z
        mov     byte ptr[regs+d[ebx]], ah
        ret
op_103c         ENDP

op_1080         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     dl, byte ptr[regs+d[ebx*4]]
        and     ecx, 1ch
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ecx]]
        cmp     dl, 0
        MAKE_SR_Z
        SAVE_B_MEM
        ret
op_1080         ENDP

op_1090         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     dword ptr[regs+v], 0
        LOAD_B_MEM
        cmp     al, 0
        MAKE_SR_Z
        mov     dl, al
        mov     eax, dword ptr[regs+a[ecx]]
        SAVE_B_MEM
        ret
op_1090         ENDP

op_1098         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        inc     dword ptr[regs+a[ebx*4]]
        cmp     ebx, 7
        jne     short op1098_noa7
        inc     dword ptr[regs+a[ebx*4]]
op1098_noa7:
        mov     dword ptr[regs+v], 0
        LOAD_B_MEM
        cmp     al, 0
        MAKE_SR_Z
        mov     dl, al
        mov     eax, dword ptr[regs+a[ecx]]
        SAVE_B_MEM
        ret
op_1098          ENDP

op_10a0         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        dec     dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        cmp     ebx, 7
        jne     op10a0_noa7
        dec     dword ptr[regs+a[ebx*4]]
op10a0_noa7:
        mov     eax, dword ptr[regs+a[ebx*4]]
        mov     dword ptr[regs+v], 0
        LOAD_B_MEM
        cmp     al, 0
        MAKE_SR_Z
        mov     dl, al
        mov     eax, dword ptr[regs+a[ecx]]
        SAVE_B_MEM
        ret
op_10a0         ENDP

op_10a8         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     ebx, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ebx
        mov     dword ptr[regs+v], 0
        LOAD_B_MEM
        cmp     al, 0
        MAKE_SR_Z
        mov     dl, al
        mov     eax, dword ptr[regs+a[ecx]]
        SAVE_B_MEM
        ret
op_10a8         ENDP

op_10b0         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        push    dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        mov     dword ptr[regs+v], 0
        GET_DISP_EA
        LOAD_B_MEM
        cmp     al, 0
        MAKE_SR_Z
        mov     dl, al
        mov     eax, dword ptr[regs+a[ecx]]
        SAVE_B_MEM
        ret
op_10b0         ENDP

op_10b8         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        mov     dword ptr[regs+v], 0
        LOAD_B_MEM
        cmp     al, 0
        MAKE_SR_Z
        mov     dl, al
        mov     eax, dword ptr[regs+a[ebx]]
        SAVE_B_MEM
        ret
op_10b8         ENDP

op_10b9         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        bswap   eax
        mov     dword ptr[regs+v], 0
        LOAD_B_MEM
        cmp     al, 0
        MAKE_SR_Z
        mov     dl, al
        mov     eax, dword ptr[regs+a[ebx]]
        SAVE_B_MEM
        ret
op_10b9         ENDP

op_10ba         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        mov     ecx, dword ptr[regs+pc]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ecx
        mov     dword ptr[regs+v], 0
        LOAD_B_MEM
        cmp     al, 0
        MAKE_SR_Z
        mov     dl, al
        mov     eax, dword ptr[regs+a[ebx]]
        SAVE_B_MEM
        ret
op_10ba         ENDP

op_10bb         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        push    dword ptr[regs+pc]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        mov     dword ptr[regs+v], 0
        GET_DISP_EA
        LOAD_B_MEM
        cmp     al, 0
        MAKE_SR_Z
        mov     dl, al
        mov     eax, dword ptr[regs+a[ebx]]
        SAVE_B_MEM
        ret
op_10bb         ENDP

op_10bc         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        mov     dword ptr[regs+v], 0
        cmp     ah, 0
        MAKE_SR_Z
        mov     dl, ah
        mov     eax, dword ptr[regs+a[ebx]]
        SAVE_B_MEM
        ret
op_10bc         ENDP

op_10c0         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     dl, byte ptr[regs+d[ebx*4]]
        and     ecx, 1ch
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        inc     dword ptr[regs+a[ecx]]
        cmp     ecx, 28
        jne     short op10c0_next
        inc     dword ptr[regs+a[ecx]]
op10c0_next:
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_10c0         ENDP

op_10d0         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        LOAD_B_MEM
        mov     dl, al
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        inc     dword ptr[regs+a[ecx]]
        cmp     ecx, 28
        jne     short op10d0_next
        inc     dword ptr[regs+a[ecx]]
op10d0_next:
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_10d0         ENDP

op_10d8         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        LOAD_B_MEM
        mov     dl, al
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        inc     dword ptr[regs+a[ecx]]
        inc     dword ptr[regs+a[ebx*4]]
        cmp     ecx, 28
        jne     short op10d8_next
        inc     dword ptr[regs+a[ecx]]
op10d8_next:
        cmp     ebx, 7
        jne     short op10d8_next2
        inc     dword ptr[regs+a[ebx*4]]
op10d8_next2:
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_10d8         ENDP

op_10e0         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        dec     dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        cmp     ebx, 7
        jne     short op10e0_next
        dec     dword ptr[regs+a[ebx*4]]
op10e0_next:
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ebx*4]]
        LOAD_B_MEM
        mov     dl, al
        mov     eax, dword ptr[regs+a[ecx]]
        inc     dword ptr[regs+a[ecx]]
        cmp     ecx, 28
        jne     short op10e0_next2
        inc     dword ptr[regs+a[ecx]]
op10e0_next2:
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_10e0         ENDP

op_10e8         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     ax, word ptr[edi+2]
        and     ecx, 1ch
        mov     edx, dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, edx
        LOAD_B_MEM
        mov     dl, al
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        inc     dword ptr[regs+a[ecx]]
        cmp     ecx, 28
        jne     short op10e8_next
        inc     dword ptr[regs+a[ecx]]
op10e8_next:
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_10e8         ENDP

op_10f0         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     ax, word ptr[edi+2]
        and     ecx, 1ch
        push    dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        GET_DISP_EA
        LOAD_B_MEM
        mov     dl, al
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        inc     dword ptr[regs+a[ecx]]
        cmp     ecx, 28
        jne     short op10f0_next
        inc     dword ptr[regs+a[ecx]]
op10f0_next:
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_10f0         ENDP

op_10f8         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        LOAD_B_MEM
        mov     dl, al
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        inc     dword ptr[regs+a[ebx]]
        cmp     ebx, 28
        jne     short op10f8_next
        inc     dword ptr[regs+a[ebx]]
op10f8_next:
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_10f8         ENDP

op_10f9         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        bswap   eax
        LOAD_B_MEM
        mov     dl, al
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        inc     dword ptr[regs+a[ebx]]
        cmp     ebx, 28
        jne     short op10f9_next
        inc     dword ptr[regs+a[ebx]]
op10f9_next:
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_10f9         ENDP

op_10fa         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        mov     edx, dword ptr[regs+pc]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, edx
        LOAD_B_MEM
        mov     dl, al
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        inc     dword ptr[regs+a[ebx]]
        cmp     ebx, 28
        jne     short op10fa_next
        inc     dword ptr[regs+a[ebx]]
op10fa_next:
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_10fa         ENDP

op_10fb         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        push    dword ptr[regs+pc]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        GET_DISP_EA
        LOAD_B_MEM
        mov     dl, al
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        inc     dword ptr[regs+a[ebx]]
        cmp     ebx, 28
        jne     short op10fb_next
        inc     dword ptr[regs+a[ebx]]
op10fb_next:
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_10fb         ENDP

op_10fc         PROC
        shr     ebx, 7
        mov     dx, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    dh, dl
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        inc     dword ptr[regs+a[ebx]]
        cmp     ebx, 28
        jne     short op10fc_next
        inc     dword ptr[regs+a[ebx]]
op10fc_next:
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_10fc         ENDP

op_1100         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     dl, byte ptr[regs+d[ebx*4]]
        and     ecx, 1ch
        dec     dword ptr[regs+a[ecx]]
        cmp     ecx, 28
        jne     short op1100_next
        dec     dword ptr[regs+a[ecx]]
op1100_next:
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_1100         ENDP

op_1110         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        dec     dword ptr[regs+a[ecx]]
        cmp     ecx, 28
        jne     short op1110_next
        dec     dword ptr[regs+a[ecx]]
op1110_next:
        LOAD_B_MEM
        mov     dl, al
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_1110         ENDP

op_1118         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        dec     dword ptr[regs+a[ecx]]
        inc     dword ptr[regs+a[ebx*4]]
        cmp     ecx, 28
        jne     short op1118_next
        dec     dword ptr[regs+a[ecx]]
op1118_next:
        cmp     ebx, 7
        jne     short op1118_next2
        inc     dword ptr[regs+a[ebx*4]]
op1118_next2:
        LOAD_B_MEM
        mov     dl, al
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_1118         ENDP

op_1120         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        dec     dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        dec     dword ptr[regs+a[ecx]]
        cmp     ecx, 28
        jne     short op1120_next
        dec     dword ptr[regs+a[ecx]]
op1120_next:
        cmp     ebx, 7
        jne     short op1120_next2
        dec     dword ptr[regs+a[ebx*4]]
op1120_next2:
        mov     eax, dword ptr[regs+a[ebx*4]]
        LOAD_B_MEM
        mov     dl, al
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_1120         ENDP

op_1128         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     ax, word ptr[edi+2]
        and     ecx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx*4]]
        dec     dword ptr[regs+a[ecx]]
        cmp     ecx, 28
        jne     short op1128_next
        dec     dword ptr[regs+a[ecx]]
op1128_next:
        LOAD_B_MEM
        mov     dl, al
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_1128         ENDP

op_1130         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     ax, word ptr[edi+2]
        and     ecx, 1ch
        push    dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        GET_DISP_EA
        dec     dword ptr[regs+a[ecx]]
        cmp     ecx, 28
        jne     short op1130_next
        dec     dword ptr[regs+a[ecx]]
op1130_next:
        LOAD_B_MEM
        mov     dl, al
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_1130         ENDP

op_1138         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        dec     dword ptr[regs+a[ebx]]
        cmp     ecx, 28
        jne     short op1138_next
        dec     dword ptr[regs+a[ebx]]
op1138_next:
        LOAD_B_MEM
        mov     dl, al
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_1138         ENDP

op_1139         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        bswap   eax
        dec     dword ptr[regs+a[ebx]]
        cmp     ecx, 28
        jne     short op1139_next
        dec     dword ptr[regs+a[ebx]]
op1139_next:
        LOAD_B_MEM
        mov     dl, al
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_1139         ENDP

op_113a         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        mov     edx, dword ptr[regs+pc]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, edx
        dec     dword ptr[regs+a[ebx]]
        cmp     ecx, 28
        jne     short op113a_next
        dec     dword ptr[regs+a[ebx]]
op113a_next:
        LOAD_B_MEM
        mov     dl, al
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_113a         ENDP

op_113b         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        push    dword ptr[regs+pc]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        GET_DISP_EA
        dec     dword ptr[regs+a[ebx]]
        cmp     ebx, 28
        jne     short op113b_next
        dec     dword ptr[regs+a[ebx]]
op113b_next:
        LOAD_B_MEM
        mov     dl, al
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_113b         ENDP

op_113c         PROC
        shr     ebx, 7
        mov     dx, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    dh, dl
        dec     dword ptr[regs+a[ebx]]
        cmp     ebx, 28
        jne     short op113c_next
        dec     dword ptr[regs+a[ebx]]
op113c_next:
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_113c         ENDP

op_1140         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     dl, byte ptr[regs+d[ebx*4]]
        and     ecx, 1ch
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_1140         ENDP

op_1150         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        add     dword ptr[regs+pc], 2
        LOAD_B_MEM
        mov     dl, al
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_1150         ENDP

op_1158         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        add     dword ptr[regs+pc], 2
        inc     dword ptr[regs+a[ebx*4]]
        cmp     ebx, 7
        jne     short op1158_next
        inc     dword ptr[regs+a[ebx*4]]
op1158_next:
        LOAD_B_MEM
        mov     dl, al
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_1158         ENDP

op_1160         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        dec     dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        cmp     ebx, 7
        jne     short op1160_next
        dec     dword ptr[regs+a[ebx*4]]
op1160_next:
        mov     eax, dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 2
        LOAD_B_MEM
        mov     dl, al
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_1160         ENDP

op_1168         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     ax, word ptr[edi+2]
        and     ecx, 1ch
        add     dword ptr[regs+pc], 4
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx*4]]
        LOAD_B_MEM
        mov     dl, al
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_1168         ENDP

op_1170         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     ax, word ptr[edi+2]
        and     ecx, 1ch
        add     dword ptr[regs+pc], 4
        push    dword ptr[regs+a[ebx*4]]
        xchg    ah, al
        GET_DISP_EA
        LOAD_B_MEM
        mov     dl, al
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_1170         ENDP

op_1178         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        xchg    ah, al
        cwde
        LOAD_B_MEM
        mov     dl, al
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_1178         ENDP

op_1179         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 6
        bswap   eax
        LOAD_B_MEM
        mov     dl, al
        mov     ax, word ptr[edi+6]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_1179         ENDP

op_117a         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+pc]
        add     dword ptr[regs+pc], 4
        LOAD_B_MEM
        mov     dl, al
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_117a         ENDP

op_117b         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        push    dword ptr[regs+pc]
        xchg    ah, al
        GET_DISP_EA
        add     dword ptr[regs+pc], 4
        LOAD_B_MEM
        mov     dl, al
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_117b         ENDP

op_117c         PROC
        shr     ebx, 7
        mov     dx, word ptr[edi+2]
        and     ebx, 1ch
        mov     ax, word ptr[edi+4]
        add     dword ptr[regs+pc], 4
        xchg    dh, dl
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_117c         ENDP

op_11c0         PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        mov     dl, byte ptr[regs+d[ebx*4]]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        mov     dword ptr[regs+v], 0
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_11c0         ENDP

op_11d0         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 2
        LOAD_B_MEM
        mov     dl, al
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_11d0         ENDP

op_11d8         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 2
        inc     dword ptr[regs+a[ebx*4]]
        cmp     ebx, 7
        jne     short op11d8_next
        inc     dword ptr[regs+a[ebx*4]]
op11d8_next:
        LOAD_B_MEM
        mov     dl, al
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_11d8         ENDP

op_11e0         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        dec     dword ptr[regs+a[ebx*4]]
        cmp     ebx, 7
        jne     short op11e0_next
        dec     dword ptr[regs+a[ebx*4]]
op11e0_next:
        mov     eax, dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 2
        LOAD_B_MEM
        mov     dl, al
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_11e0         ENDP

op_11e8         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+pc], 4
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx*4]]
        LOAD_B_MEM
        mov     dl, al
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_11e8         ENDP

op_11f0         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+pc], 4
        mov     ax, word ptr[edi+2]
        push    dword ptr[regs+a[ebx*4]]
        xchg    ah, al
        GET_DISP_EA
        LOAD_B_MEM
        mov     dl, al
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_11f0         ENDP

op_11f8         PROC
        mov     dword ptr[regs+v], 0
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     dword ptr[regs+pc], 4
        LOAD_B_MEM
        mov     dl, al
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_11f8         ENDP

op_11f9         PROC
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[edi+2]
        bswap   eax
        add     dword ptr[regs+pc], 6
        LOAD_B_MEM
        mov     dl, al
        mov     ax, word ptr[edi+6]
        xchg    ah, al
        cwde
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_11f9         ENDP

op_11fa         PROC
        mov     dword ptr[regs+v], 0
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+pc]
        add     dword ptr[regs+pc], 4
        LOAD_B_MEM
        mov     dl, al
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_11fa         ENDP

op_11fb         PROC
        mov     ax, word ptr[edi+2]
        push    dword ptr[regs+pc]
        xchg    ah, al
        GET_DISP_EA
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+pc], 4
        LOAD_B_MEM
        mov     dl, al
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_11fb         ENDP

op_11fc         PROC
        mov     dword ptr[regs+v], 0
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 4
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        mov     dl, dh
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_11fc         ENDP

op_13c0         PROC
        and     ebx, 7
        mov     eax, dword ptr[edi+2]
        mov     dl, byte ptr[regs+d[ebx*4]]
        add     dword ptr[regs+pc], 4
        bswap   eax
        mov     dword ptr[regs+v], 0
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_13c0         ENDP

op_13d0         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 4
        LOAD_B_MEM
        mov     dl, al
        mov     eax, dword ptr[edi+2]
        bswap   eax
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_13d0         ENDP

op_13d8         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 4
        inc     dword ptr[regs+a[ebx*4]]
        cmp     ebx, 7
        jne     short op13d8_next
        inc     dword ptr[regs+a[ebx*4]]
op13d8_next:
        LOAD_B_MEM
        mov     dl, al
        mov     eax, dword ptr[edi+2]
        bswap   eax
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_13d8         ENDP

op_13e0         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        dec     dword ptr[regs+a[ebx*4]]
        cmp     ebx, 7
        jne     short op13e0_next
        dec     dword ptr[regs+a[ebx*4]]
op13e0_next:
        mov     eax, dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 4
        LOAD_B_MEM
        mov     dl, al
        mov     eax, dword ptr[edi+2]
        bswap   eax
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_13e0         ENDP

op_13e8         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+pc], 6
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx*4]]
        LOAD_B_MEM
        mov     dl, al
        mov     eax, dword ptr[edi+4]
        bswap   eax
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_13e8         ENDP

op_13f0         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+pc], 6
        mov     ax, word ptr[edi+2]
        push    dword ptr[regs+a[ebx*4]]
        xchg    ah, al
        GET_DISP_EA
        LOAD_B_MEM
        mov     dl, al
        mov     eax, dword ptr[edi+4]
        bswap   eax
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_13f0         ENDP

op_13f8         PROC
        mov     dword ptr[regs+v], 0
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     dword ptr[regs+pc], 6
        LOAD_B_MEM
        mov     dl, al
        mov     eax, dword ptr[edi+4]
        bswap   eax
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_13f8         ENDP

op_13f9         PROC
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[edi+2]
        bswap   eax
        add     dword ptr[regs+pc], 8
        LOAD_B_MEM
        mov     dl, al
        mov     eax, dword ptr[edi+6]
        bswap   eax
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_13f9         ENDP

op_13fa         PROC
        mov     dword ptr[regs+v], 0
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+pc]
        add     dword ptr[regs+pc], 6
        LOAD_B_MEM
        mov     dl, al
        mov     eax, dword ptr[edi+4]
        bswap   eax
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_13fa         ENDP

op_13fb         PROC
        mov     ax, word ptr[edi+2]
        push    dword ptr[regs+pc]
        xchg    ah, al
        GET_DISP_EA
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+pc], 6
        LOAD_B_MEM
        mov     dl, al
        mov     eax, dword ptr[edi+4]
        bswap   eax
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_13fb         ENDP

op_13fc         PROC
        mov     dword ptr[regs+v], 0
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 6
        mov     eax, dword ptr[edi+4]
        mov     dl, dh
        bswap   eax
        SAVE_B_MEM
        cmp     dl, 0
        MAKE_SR_Z
        ret
op_13fc         ENDP

op_2000         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     edx, dword ptr[regs+d[ebx*4]]
        and     ecx, 1ch
        mov     dword ptr[regs+v], 0
        cmp     edx, 0
        MAKE_SR_Z
        mov     dword ptr[regs+d[ecx]], edx
        ret
op_2000         ENDP

op_2008         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     edx, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     dword ptr[regs+v], 0
        cmp     edx, 0
        MAKE_SR_Z
        mov     dword ptr[regs+d[ecx]], edx
        ret
op_2008         ENDP

op_2010         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     dword ptr[regs+v], 0
        LOAD_L_MEM
        cmp     eax, 0
        MAKE_SR_Z
        mov     dword ptr[regs+d[ecx]], eax
        ret
op_2010         ENDP

op_2018         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        add     dword ptr[regs+a[ebx*4]], 4
        mov     dword ptr[regs+v], 0
        LOAD_L_MEM
        cmp     eax, 0
        MAKE_SR_Z
        mov     dword ptr[regs+d[ecx]], eax
        ret
op_2018          ENDP

op_2020         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        sub     dword ptr[regs+a[ebx*4]], 4
        and     ecx, 1ch
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ebx*4]]
        LOAD_L_MEM
        cmp     eax, 0
        MAKE_SR_Z
        mov     dword ptr[regs+d[ecx]], eax
        ret
op_2020         ENDP

op_2028         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     ebx, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ebx
        mov     dword ptr[regs+v], 0
        LOAD_L_MEM
        cmp     eax, 0
        MAKE_SR_Z
        mov     dword ptr[regs+d[ecx]], eax
        ret
op_2028         ENDP

op_2030         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        push    dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        mov     dword ptr[regs+v], 0
        GET_DISP_EA
        LOAD_L_MEM
        cmp     eax, 0
        MAKE_SR_Z
        mov     dword ptr[regs+d[ecx]], eax
        ret
op_2030         ENDP

op_2038         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        mov     dword ptr[regs+v], 0
        LOAD_L_MEM
        cmp     eax, 0
        MAKE_SR_Z
        mov     dword ptr[regs+d[ebx]], eax
        ret
op_2038         ENDP

op_2039         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        bswap   eax
        mov     dword ptr[regs+v], 0
        LOAD_L_MEM
        cmp     eax, 0
        MAKE_SR_Z
        mov     dword ptr[regs+d[ebx]], eax
        ret
op_2039         ENDP

op_203a         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        mov     ecx, dword ptr[regs+pc]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ecx
        mov     dword ptr[regs+v], 0
        LOAD_L_MEM
        cmp     eax, 0
        MAKE_SR_Z
        mov     dword ptr[regs+d[ebx]], eax
        ret
op_203a         ENDP

op_203b         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        push    dword ptr[regs+pc]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        mov     dword ptr[regs+v], 0
        mov     ecx, ebx
        GET_DISP_EA
        LOAD_L_MEM
        cmp     eax, 0
        MAKE_SR_Z
        mov     dword ptr[regs+d[ecx]], eax
        ret
op_203b         ENDP

op_203c         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        mov     dword ptr[regs+v], 0
        bswap   eax
        cmp     eax, 0
        MAKE_SR_Z
        mov     dword ptr[regs+d[ebx]], eax
        ret
op_203c         ENDP

op_2040         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+d[ebx*4]]
        and     ecx, 1ch
        mov     dword ptr[regs+a[ecx]], eax
        ret
op_2040         ENDP

op_2048         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     dword ptr[regs+a[ecx]], eax
        ret
op_2048         ENDP

op_2050         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        LOAD_L_MEM
        mov     dword ptr[regs+a[ecx]], eax
        ret
op_2050         ENDP

op_2058         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        add     dword ptr[regs+a[ebx*4]], 4
        LOAD_L_MEM
        mov     dword ptr[regs+a[ecx]], eax
        ret
op_2058         ENDP

op_2060         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        sub     dword ptr[regs+a[ebx*4]], 4
        and     ecx, 1ch
        mov     eax, dword ptr[regs+a[ebx*4]]
        LOAD_L_MEM
        mov     dword ptr[regs+a[ecx]], eax
        ret
op_2060         ENDP

op_2068         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     ax, word ptr[edi+2]
        and     ecx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx*4]]
        LOAD_L_MEM
        mov     dword ptr[regs+a[ecx]], eax
        ret
op_2068         ENDP

op_2070         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     ax, word ptr[edi+2]
        and     ecx, 1ch
        push    dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        GET_DISP_EA
        LOAD_L_MEM
        mov     dword ptr[regs+a[ecx]], eax
        ret
op_2070         ENDP

op_2078         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        LOAD_L_MEM
        mov     dword ptr[regs+a[ebx]], eax
        ret
op_2078         ENDP

op_2079         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        bswap   eax
        LOAD_L_MEM
        mov     dword ptr[regs+a[ebx]], eax
        ret
op_2079         ENDP

op_207a         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        mov     edx, dword ptr[regs+pc]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, edx
        LOAD_L_MEM
        mov     dword ptr[regs+a[ebx]], eax
        ret
op_207a         ENDP

op_207b         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        push    dword ptr[regs+pc]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        GET_DISP_EA
        LOAD_L_MEM
        mov     dword ptr[regs+a[ebx]], eax
        ret
op_207b         ENDP

op_207c         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        bswap   eax
        mov     dword ptr[regs+a[ebx]], eax
        ret
op_207c         ENDP
   
op_2080         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     edx, dword ptr[regs+d[ebx*4]]
        and     ecx, 1ch
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ecx]]
        cmp     edx, 0
        MAKE_SR_Z
        SAVE_L_MEM
        ret
op_2080         ENDP

op_2088         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     edx, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ecx]]
        cmp     edx, 0
        MAKE_SR_Z
        SAVE_L_MEM
        ret
op_2088         ENDP

op_2090         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     dword ptr[regs+v], 0
        LOAD_L_MEM
        cmp     eax, 0
        MAKE_SR_Z
        mov     edx, eax
        mov     eax, dword ptr[regs+a[ecx]]
        SAVE_L_MEM
        ret
op_2090         ENDP

op_2098         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        add     dword ptr[regs+a[ebx*4]], 4
        mov     dword ptr[regs+v], 0
        LOAD_L_MEM
        cmp     eax, 0
        MAKE_SR_Z
        mov     edx, eax
        mov     eax, dword ptr[regs+a[ecx]]
        SAVE_L_MEM
        ret
op_2098          ENDP

op_20a0         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        sub     dword ptr[regs+a[ebx*4]], 4
        and     ecx, 1ch
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ebx*4]]
        LOAD_L_MEM
        cmp     eax, 0
        MAKE_SR_Z
        mov     edx, eax
        mov     eax, dword ptr[regs+a[ecx]]
        SAVE_L_MEM
        ret
op_20a0         ENDP

op_20a8         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     ebx, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ebx
        mov     dword ptr[regs+v], 0
        LOAD_L_MEM
        cmp     eax, 0
        MAKE_SR_Z
        mov     edx, eax
        mov     eax, dword ptr[regs+a[ecx]]
        SAVE_L_MEM
        ret
op_20a8         ENDP

op_20b0         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        push    dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        mov     dword ptr[regs+v], 0
        GET_DISP_EA
        LOAD_L_MEM
        cmp     eax, 0
        MAKE_SR_Z
        mov     edx, eax
        mov     eax, dword ptr[regs+a[ecx]]
        SAVE_L_MEM
        ret
op_20b0         ENDP

op_20b8         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        mov     dword ptr[regs+v], 0
        LOAD_L_MEM
        cmp     eax, 0
        MAKE_SR_Z
        mov     edx, eax
        mov     eax, dword ptr[regs+a[ebx]]
        SAVE_L_MEM
        ret
op_20b8         ENDP

op_20b9         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        bswap   eax
        mov     dword ptr[regs+v], 0
        LOAD_L_MEM
        cmp     eax, 0
        MAKE_SR_Z
        mov     edx, eax
        mov     eax, dword ptr[regs+a[ebx]]
        SAVE_L_MEM
        ret
op_20b9         ENDP

op_20ba         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        mov     ecx, dword ptr[regs+pc]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ecx
        mov     dword ptr[regs+v], 0
        LOAD_L_MEM
        cmp     eax, 0
        MAKE_SR_Z
        mov     edx, eax
        mov     eax, dword ptr[regs+a[ebx]]
        SAVE_L_MEM
        ret
op_20ba         ENDP

op_20bb         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        push    dword ptr[regs+pc]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        mov     dword ptr[regs+v], 0
        GET_DISP_EA
        LOAD_L_MEM
        cmp     eax, 0
        MAKE_SR_Z
        mov     edx, eax
        mov     eax, dword ptr[regs+a[ebx]]
        SAVE_L_MEM
        ret
op_20bb         ENDP

op_20bc         PROC
        shr     ebx, 7
        mov     edx, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ebx]]
        bswap   edx
        cmp     edx, 0
        MAKE_SR_Z
        SAVE_L_MEM
        ret
op_20bc         ENDP

op_20c0         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     edx, dword ptr[regs+d[ebx*4]]
        and     ecx, 1ch
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+a[ecx]], 4
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_20c0         ENDP

op_20c8         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     edx, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+a[ecx]], 4
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_20c8         ENDP

op_20d0         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        LOAD_L_MEM
        mov     edx, eax
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+a[ecx]], 4
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_20d0         ENDP

op_20d8         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        LOAD_L_MEM
        mov     edx, eax
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+a[ecx]], 4
        add     dword ptr[regs+a[ebx*4]], 4
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_20d8         ENDP

op_20e0         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        sub     dword ptr[regs+a[ebx*4]], 4
        and     ecx, 1ch
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ebx*4]]
        LOAD_L_MEM
        mov     edx, eax
        mov     eax, dword ptr[regs+a[ecx]]
        add     dword ptr[regs+a[ecx]], 4
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_20e0         ENDP

op_20e8         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     ax, word ptr[edi+2]
        and     ecx, 1ch
        mov     edx, dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, edx
        LOAD_L_MEM
        mov     edx, eax
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+a[ecx]], 4
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_20e8         ENDP

op_20f0         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     ax, word ptr[edi+2]
        and     ecx, 1ch
        push    dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        GET_DISP_EA
        LOAD_L_MEM
        mov     edx, eax
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+a[ecx]], 4
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_20f0         ENDP

op_20f8         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        LOAD_L_MEM
        mov     edx, eax
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+a[ebx]], 4
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_20f8         ENDP

op_20f9         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        bswap   eax
        LOAD_L_MEM
        mov     edx, eax
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+a[ebx]], 4
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_20f9         ENDP

op_20fa         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        mov     edx, dword ptr[regs+pc]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, edx
        LOAD_L_MEM
        mov     edx, eax
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+a[ebx]], 4
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_20fa         ENDP

op_20fb         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        push    dword ptr[regs+pc]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        GET_DISP_EA
        LOAD_L_MEM
        mov     edx, eax
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+a[ebx]], 4
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_20fb         ENDP

op_20fc         PROC
        shr     ebx, 7
        mov     edx, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        bswap   edx
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+a[ebx]], 4
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_20fc         ENDP

op_2100         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     edx, dword ptr[regs+d[ebx*4]]
        and     ecx, 1ch
        sub     dword ptr[regs+a[ecx]], 4
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_2100         ENDP

op_2108         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     edx, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        sub     dword ptr[regs+a[ecx]], 4
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_2108         ENDP

op_2110         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        sub     dword ptr[regs+a[ecx]], 4
        LOAD_L_MEM
        mov     edx, eax
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_2110         ENDP

op_2118         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        sub     dword ptr[regs+a[ecx]], 4
        add     dword ptr[regs+a[ebx*4]], 4
        LOAD_L_MEM
        mov     edx, eax
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_2118         ENDP

op_2120         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        sub     dword ptr[regs+a[ebx*4]], 4
        and     ecx, 1ch
        sub     dword ptr[regs+a[ecx]], 4
        mov     eax, dword ptr[regs+a[ebx*4]]
        LOAD_L_MEM
        mov     edx, eax
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_2120         ENDP

op_2128         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     ax, word ptr[edi+2]
        and     ecx, 1ch
        mov     edx, dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, edx
        sub     dword ptr[regs+a[ecx]], 4
        LOAD_L_MEM
        mov     edx, eax
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_2128         ENDP

op_2130         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     ax, word ptr[edi+2]
        and     ecx, 1ch
        push    dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        GET_DISP_EA
        sub     dword ptr[regs+a[ecx]], 4
        LOAD_L_MEM
        mov     edx, eax
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_2130         ENDP

op_2138         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        sub     dword ptr[regs+a[ebx]], 4
        LOAD_L_MEM
        mov     edx, eax
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_2138         ENDP

op_2139         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        bswap   eax
        sub     dword ptr[regs+a[ebx]], 4
        LOAD_L_MEM
        mov     edx, eax
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_2139         ENDP

op_213a         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        mov     edx, dword ptr[regs+pc]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, edx
        sub     dword ptr[regs+a[ebx]], 4
        LOAD_L_MEM
        mov     edx, eax
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_213a         ENDP

op_213b         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        push    dword ptr[regs+pc]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        GET_DISP_EA
        sub     dword ptr[regs+a[ebx]], 4
        LOAD_L_MEM
        mov     edx, eax
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_213b         ENDP

op_213c         PROC
        shr     ebx, 7
        mov     edx, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        bswap   edx
        sub     dword ptr[regs+a[ebx]], 4
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_213c         ENDP

op_2140         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     edx, dword ptr[regs+d[ebx*4]]
        and     ecx, 1ch
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_2140         ENDP

op_2148         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     edx, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_2148         ENDP

op_2150         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        add     dword ptr[regs+pc], 2
        LOAD_L_MEM
        mov     edx, eax
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_2150         ENDP

op_2158         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        add     dword ptr[regs+pc], 2
        add     dword ptr[regs+a[ebx*4]], 4
        LOAD_L_MEM
        mov     edx, eax
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_2158         ENDP

op_2160         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        sub     dword ptr[regs+a[ebx*4]], 4
        and     ecx, 1ch
        mov     eax, dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 2
        LOAD_L_MEM
        mov     edx, eax
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_2160         ENDP

op_2168         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     ax, word ptr[edi+2]
        and     ecx, 1ch
        add     dword ptr[regs+pc], 4
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx*4]]
        LOAD_L_MEM
        mov     edx, eax
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_2168         ENDP

op_2170         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     ax, word ptr[edi+2]
        and     ecx, 1ch
        add     dword ptr[regs+pc], 4
        push    dword ptr[regs+a[ebx*4]]
        xchg    ah, al
        GET_DISP_EA
        LOAD_L_MEM
        mov     edx, eax
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_2170         ENDP

op_2178         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        xchg    ah, al
        cwde
        LOAD_L_MEM
        mov     edx, eax
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_2178         ENDP

op_2179         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 6
        bswap   eax
        LOAD_L_MEM
        mov     edx, eax
        mov     ax, word ptr[edi+6]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_2179         ENDP

op_217a         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+pc]
        add     dword ptr[regs+pc], 4
        LOAD_L_MEM
        mov     edx, eax
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_217a         ENDP

op_217b         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        push    dword ptr[regs+pc]
        xchg    ah, al
        GET_DISP_EA
        add     dword ptr[regs+pc], 4
        LOAD_L_MEM
        mov     edx, eax
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_217b         ENDP

op_217c         PROC
        shr     ebx, 7
        mov     edx, dword ptr[edi+2]
        and     ebx, 1ch
        mov     ax, word ptr[edi+6]
        add     dword ptr[regs+pc], 6
        bswap   edx
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_217c         ENDP

op_21c0         PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        mov     edx, dword ptr[regs+d[ebx*4]]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        mov     dword ptr[regs+v], 0
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_21c0         ENDP

op_21c8         PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        mov     edx, dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        mov     dword ptr[regs+v], 0
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_21c8         ENDP

op_21d0         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 2
        LOAD_L_MEM
        mov     edx, eax
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_21d0         ENDP

op_21d8         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 2
        add     dword ptr[regs+a[ebx*4]], 4
        LOAD_L_MEM
        mov     edx, eax
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_21d8         ENDP

op_21e0         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        sub     dword ptr[regs+a[ebx*4]], 4
        mov     eax, dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 2
        LOAD_L_MEM
        mov     edx, eax
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_21e0         ENDP

op_21e8         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+pc], 4
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx*4]]
        LOAD_L_MEM
        mov     edx, eax
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_21e8         ENDP

op_21f0         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+pc], 4
        mov     ax, word ptr[edi+2]
        push    dword ptr[regs+a[ebx*4]]
        xchg    ah, al
        GET_DISP_EA
        LOAD_L_MEM
        mov     edx, eax
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_21f0         ENDP

op_21f8         PROC
        mov     dword ptr[regs+v], 0
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     dword ptr[regs+pc], 4
        LOAD_L_MEM
        mov     edx, eax
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_21f8         ENDP

op_21f9         PROC
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[edi+2]
        bswap   eax
        add     dword ptr[regs+pc], 6
        LOAD_L_MEM
        mov     edx, eax
        mov     ax, word ptr[edi+6]
        xchg    ah, al
        cwde
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_21f9         ENDP

op_21fa         PROC
        mov     dword ptr[regs+v], 0
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+pc]
        add     dword ptr[regs+pc], 4
        LOAD_L_MEM
        mov     edx, eax
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_21fa         ENDP

op_21fb         PROC
        mov     ax, word ptr[edi+2]
        push    dword ptr[regs+pc]
        xchg    ah, al
        GET_DISP_EA
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+pc], 4
        LOAD_L_MEM
        mov     edx, eax
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_21fb         ENDP

op_21fc         PROC
        mov     dword ptr[regs+v], 0
        mov     edx, dword ptr[edi+2]
        add     dword ptr[regs+pc], 6
        mov     ax, word ptr[edi+6]
        xchg    ah, al
        cwde
        bswap   edx
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_21fc         ENDP

op_23c0         PROC
        and     ebx, 7
        mov     eax, dword ptr[edi+2]
        mov     edx, dword ptr[regs+d[ebx*4]]
        add     dword ptr[regs+pc], 4
        bswap   eax
        mov     dword ptr[regs+v], 0
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_23c0         ENDP

op_23c8         PROC
        and     ebx, 7
        mov     eax, dword ptr[edi+2]
        mov     edx, dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 4
        bswap   eax
        mov     dword ptr[regs+v], 0
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_23c8         ENDP

op_23d0         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 4
        LOAD_L_MEM
        mov     edx, eax
        mov     eax, dword ptr[edi+2]
        bswap   eax
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_23d0         ENDP

op_23d8         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 4
        add     dword ptr[regs+a[ebx*4]], 4
        LOAD_L_MEM
        mov     edx, eax
        mov     eax, dword ptr[edi+2]
        bswap   eax
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_23d8         ENDP

op_23e0         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        sub     dword ptr[regs+a[ebx*4]], 4
        mov     eax, dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 4
        LOAD_L_MEM
        mov     edx, eax
        mov     eax, dword ptr[edi+2]
        bswap   eax
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_23e0         ENDP

op_23e8         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+pc], 6
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx*4]]
        LOAD_L_MEM
        mov     edx, eax
        mov     eax, dword ptr[edi+4]
        bswap   eax
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_23e8         ENDP

op_23f0         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+pc], 6
        mov     ax, word ptr[edi+2]
        push    dword ptr[regs+a[ebx*4]]
        xchg    ah, al
        GET_DISP_EA
        LOAD_L_MEM
        mov     edx, eax
        mov     eax, dword ptr[edi+4]
        bswap   eax
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_23f0         ENDP

op_23f8         PROC
        mov     dword ptr[regs+v], 0
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     dword ptr[regs+pc], 6
        LOAD_L_MEM
        mov     edx, eax
        mov     eax, dword ptr[edi+4]
        bswap   eax
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_23f8         ENDP

op_23f9         PROC
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[edi+2]
        bswap   eax
        add     dword ptr[regs+pc], 8
        LOAD_L_MEM
        mov     edx, eax
        mov     eax, dword ptr[edi+6]
        bswap   eax
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_23f9         ENDP

op_23fa         PROC
        mov     dword ptr[regs+v], 0
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+pc]
        add     dword ptr[regs+pc], 6
        LOAD_L_MEM
        mov     edx, eax
        mov     eax, dword ptr[edi+4]
        bswap   eax
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_23fa         ENDP

op_23fb         PROC
        mov     ax, word ptr[edi+2]
        push    dword ptr[regs+pc]
        xchg    ah, al
        GET_DISP_EA
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+pc], 6
        LOAD_L_MEM
        mov     edx, eax
        mov     eax, dword ptr[edi+4]
        bswap   eax
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_23fb         ENDP

op_23fc         PROC
        mov     dword ptr[regs+v], 0
        mov     edx, dword ptr[edi+2]
        add     dword ptr[regs+pc], 8
        mov     eax, dword ptr[edi+6]
        bswap   edx
        bswap   eax
        SAVE_L_MEM
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_23fc         ENDP

op_3000         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     dx, word ptr[regs+d[ebx*4]]
        and     ecx, 1ch
        mov     dword ptr[regs+v], 0
        cmp     dx, 0
        MAKE_SR_Z
        mov     word ptr[regs+d[ecx]], dx
        ret
op_3000         ENDP

op_3008         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     dx, word ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     dword ptr[regs+v], 0
        cmp     dx, 0
        MAKE_SR_Z
        mov     word ptr[regs+d[ecx]], dx
        ret
op_3008         ENDP

op_3010         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     dword ptr[regs+v], 0
        LOAD_W_MEM
        cmp     ax, 0
        MAKE_SR_Z
        mov     word ptr[regs+d[ecx]], ax
        ret
op_3010         ENDP

op_3018         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+a[ebx*4]], 2
        LOAD_W_MEM
        cmp     ax, 0
        MAKE_SR_Z
        mov     word ptr[regs+d[ecx]], ax
        ret
op_3018          ENDP

op_3020         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        sub     dword ptr[regs+a[ebx*4]], 2
        and     ecx, 1ch
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ebx*4]]
        LOAD_W_MEM
        cmp     ax, 0
        MAKE_SR_Z
        mov     word ptr[regs+d[ecx]], ax
        ret
op_3020         ENDP

op_3028         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     ebx, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ebx
        mov     dword ptr[regs+v], 0
        LOAD_W_MEM
        cmp     ax, 0
        MAKE_SR_Z
        mov     word ptr[regs+d[ecx]], ax
        ret
op_3028         ENDP

op_3030         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        push    dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        mov     dword ptr[regs+v], 0
        GET_DISP_EA
        LOAD_W_MEM
        cmp     ax, 0
        MAKE_SR_Z
        mov     word ptr[regs+d[ecx]], ax
        ret
op_3030         ENDP

op_3038         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        mov     dword ptr[regs+v], 0
        LOAD_W_MEM
        cmp     ax, 0
        MAKE_SR_Z
        mov     word ptr[regs+d[ebx]], ax
        ret
op_3038         ENDP

op_3039         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        bswap   eax
        mov     dword ptr[regs+v], 0
        LOAD_W_MEM
        cmp     ax, 0
        MAKE_SR_Z
        mov     word ptr[regs+d[ebx]], ax
        ret
op_3039         ENDP

op_303a         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        mov     ecx, dword ptr[regs+pc]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ecx
        mov     dword ptr[regs+v], 0
        LOAD_W_MEM
        cmp     ax, 0
        MAKE_SR_Z
        mov     word ptr[regs+d[ebx]], ax
        ret
op_303a         ENDP

op_303b         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        push    dword ptr[regs+pc]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        mov     dword ptr[regs+v], 0
        mov     ecx, ebx
        GET_DISP_EA
        LOAD_W_MEM
        cmp     ax, 0
        MAKE_SR_Z
        mov     word ptr[regs+d[ecx]], ax
        ret
op_303b         ENDP

op_303c         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        mov     dword ptr[regs+v], 0
        xchg    ah, al
        cmp     ax, 0
        MAKE_SR_Z
        mov     word ptr[regs+d[ebx]], ax
        ret
op_303c         ENDP

op_3040         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+d[ebx*4]]
        and     ecx, 1ch
        cwde
        mov     dword ptr[regs+a[ecx]], eax
        ret
op_3040         ENDP

op_3048         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        cwde
        mov     dword ptr[regs+a[ecx]], eax
        ret
op_3048         ENDP

op_3050         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        LOAD_W_MEM
        cwde
        mov     dword ptr[regs+a[ecx]], eax
        ret
op_3050         ENDP

op_3058         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        add     dword ptr[regs+a[ebx*4]], 2
        LOAD_W_MEM
        cwde
        mov     dword ptr[regs+a[ecx]], eax
        ret
op_3058         ENDP

op_3060         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        sub     dword ptr[regs+a[ebx*4]], 2
        and     ecx, 1ch
        mov     eax, dword ptr[regs+a[ebx*4]]
        LOAD_W_MEM
        cwde
        mov     dword ptr[regs+a[ecx]], eax
        ret
op_3060         ENDP

op_3068         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     ax, word ptr[edi+2]
        and     ecx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx*4]]
        LOAD_W_MEM
        cwde
        mov     dword ptr[regs+a[ecx]], eax
        ret
op_3068         ENDP

op_3070         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     ax, word ptr[edi+2]
        and     ecx, 1ch
        push    dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        GET_DISP_EA
        LOAD_W_MEM
        cwde
        mov     dword ptr[regs+a[ecx]], eax
        ret
op_3070         ENDP

op_3078         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        LOAD_W_MEM
        cwde
        mov     dword ptr[regs+a[ebx]], eax
        ret
op_3078         ENDP

op_3079         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        bswap   eax
        LOAD_W_MEM
        cwde
        mov     dword ptr[regs+a[ebx]], eax
        ret
op_3079         ENDP

op_307a         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        mov     edx, dword ptr[regs+pc]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, edx
        LOAD_W_MEM
        cwde
        mov     dword ptr[regs+a[ebx]], eax
        ret
op_307a         ENDP

op_307b         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        push    dword ptr[regs+pc]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        GET_DISP_EA
        LOAD_W_MEM
        cwde
        mov     dword ptr[regs+a[ebx]], eax
        ret
op_307b         ENDP

op_307c         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        mov     dword ptr[regs+a[ebx]], eax
        ret
op_307c         ENDP

op_3080         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     dx, word ptr[regs+d[ebx*4]]
        and     ecx, 1ch
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ecx]]
        cmp     dx, 0
        MAKE_SR_Z
        SAVE_W_MEM
        ret
op_3080         ENDP

op_3088         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     dx, word ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ecx]]
        cmp     dx, 0
        MAKE_SR_Z
        SAVE_W_MEM
        ret
op_3088         ENDP

op_3090         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     dword ptr[regs+v], 0
        LOAD_W_MEM
        cmp     ax, 0
        MAKE_SR_Z
        mov     dx, ax
        mov     eax, dword ptr[regs+a[ecx]]
        SAVE_W_MEM
        ret
op_3090         ENDP

op_3098         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        add     dword ptr[regs+a[ebx*4]], 2
        mov     dword ptr[regs+v], 0
        LOAD_W_MEM
        cmp     ax, 0
        MAKE_SR_Z
        mov     dx, ax
        mov     eax, dword ptr[regs+a[ecx]]
        SAVE_W_MEM
        ret
op_3098          ENDP

op_30a0         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        sub     dword ptr[regs+a[ebx*4]], 2
        and     ecx, 1ch
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ebx*4]]
        LOAD_W_MEM
        cmp     ax, 0
        MAKE_SR_Z
        mov     dx, ax
        mov     eax, dword ptr[regs+a[ecx]]
        SAVE_W_MEM
        ret
op_30a0         ENDP

op_30a8         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     ebx, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ebx
        mov     dword ptr[regs+v], 0
        LOAD_W_MEM
        cmp     ax, 0
        MAKE_SR_Z
        mov     dx, ax
        mov     eax, dword ptr[regs+a[ecx]]
        SAVE_W_MEM
        ret
op_30a8         ENDP

op_30b0         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        push    dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        mov     dword ptr[regs+v], 0
        GET_DISP_EA
        LOAD_W_MEM
        cmp     ax, 0
        MAKE_SR_Z
        mov     dx, ax
        mov     eax, dword ptr[regs+a[ecx]]
        SAVE_W_MEM
        ret
op_30b0         ENDP

op_30b8         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        mov     dword ptr[regs+v], 0
        LOAD_W_MEM
        cmp     ax, 0
        MAKE_SR_Z
        mov     dx, ax
        mov     eax, dword ptr[regs+a[ebx]]
        SAVE_W_MEM
        ret
op_30b8         ENDP

op_30b9         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        bswap   eax
        mov     dword ptr[regs+v], 0
        LOAD_W_MEM
        cmp     ax, 0
        MAKE_SR_Z
        mov     dx, ax
        mov     eax, dword ptr[regs+a[ebx]]
        SAVE_W_MEM
        ret
op_30b9         ENDP

op_30ba         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        mov     ecx, dword ptr[regs+pc]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ecx
        mov     dword ptr[regs+v], 0
        LOAD_W_MEM
        cmp     ax, 0
        MAKE_SR_Z
        mov     dx, ax
        mov     eax, dword ptr[regs+a[ebx]]
        SAVE_W_MEM
        ret
op_30ba         ENDP

op_30bb         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        push    dword ptr[regs+pc]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        mov     dword ptr[regs+v], 0
        GET_DISP_EA
        LOAD_W_MEM
        cmp     ax, 0
        MAKE_SR_Z
        mov     dx, ax
        mov     eax, dword ptr[regs+a[ebx]]
        SAVE_W_MEM
        ret
op_30bb         ENDP

op_30bc         PROC
        shr     ebx, 7
        mov     dx, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ebx]]
        xchg    dh, dl
        cmp     dx, 0
        MAKE_SR_Z
        SAVE_W_MEM
        ret
op_30bc         ENDP

op_30c0         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     dx, word ptr[regs+d[ebx*4]]
        and     ecx, 1ch
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+a[ecx]], 2
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_30c0         ENDP

op_30c8         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     dx, word ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+a[ecx]], 2
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_30c8         ENDP

op_30d0         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        LOAD_W_MEM
        mov     dx, ax
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+a[ecx]], 2
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_30d0         ENDP

op_30d8         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        LOAD_W_MEM
        mov     dx, ax
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+a[ecx]], 2
        add     dword ptr[regs+a[ebx*4]], 2
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_30d8         ENDP

op_30e0         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        sub     dword ptr[regs+a[ebx*4]], 2
        and     ecx, 1ch
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ebx*4]]
        LOAD_W_MEM
        mov     dx, ax
        mov     eax, dword ptr[regs+a[ecx]]
        add     dword ptr[regs+a[ecx]], 2
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_30e0         ENDP

op_30e8         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     ax, word ptr[edi+2]
        and     ecx, 1ch
        mov     edx, dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, edx
        LOAD_W_MEM
        mov     dx, ax
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+a[ecx]], 2
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_30e8         ENDP

op_30f0         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     ax, word ptr[edi+2]
        and     ecx, 1ch
        push    dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        GET_DISP_EA
        LOAD_W_MEM
        mov     dx, ax
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+a[ecx]], 2
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_30f0         ENDP

op_30f8         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        LOAD_W_MEM
        mov     dx, ax
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+a[ebx]], 2
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_30f8         ENDP

op_30f9         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        bswap   eax
        LOAD_W_MEM
        mov     dx, ax
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+a[ebx]], 2
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_30f9         ENDP

op_30fa         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        mov     edx, dword ptr[regs+pc]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, edx
        LOAD_W_MEM
        mov     dx, ax
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+a[ebx]], 2
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_30fa         ENDP

op_30fb         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        push    dword ptr[regs+pc]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        GET_DISP_EA
        LOAD_W_MEM
        mov     dx, ax
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+a[ebx]], 2
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_30fb         ENDP

op_30fc         PROC
        shr     ebx, 7
        mov     dx, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    dh, dl
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+a[ebx]], 2
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_30fc         ENDP

op_3100         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     dx, word ptr[regs+d[ebx*4]]
        and     ecx, 1ch
        sub     dword ptr[regs+a[ecx]], 2
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_3100         ENDP

op_3108         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     dx, word ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        sub     dword ptr[regs+a[ecx]], 2
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_3108         ENDP

op_3110         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        sub     dword ptr[regs+a[ecx]], 2
        LOAD_W_MEM
        mov     dx, ax
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_3110         ENDP

op_3118         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        sub     dword ptr[regs+a[ecx]], 2
        add     dword ptr[regs+a[ebx*4]], 2
        LOAD_W_MEM
        mov     dx, ax
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_3118         ENDP

op_3120         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        sub     dword ptr[regs+a[ebx*4]], 2
        and     ecx, 1ch
        sub     dword ptr[regs+a[ecx]], 2
        mov     eax, dword ptr[regs+a[ebx*4]]
        LOAD_W_MEM
        mov     dx, ax
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_3120         ENDP

op_3128         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     ax, word ptr[edi+2]
        and     ecx, 1ch
        mov     edx, dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, edx
        sub     dword ptr[regs+a[ecx]], 2
        LOAD_W_MEM
        mov     dx, ax
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_3128         ENDP

op_3130         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     ax, word ptr[edi+2]
        and     ecx, 1ch
        push    dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        GET_DISP_EA
        sub     dword ptr[regs+a[ecx]], 2
        LOAD_W_MEM
        mov     dx, ax
        mov     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_3130         ENDP

op_3138         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        sub     dword ptr[regs+a[ebx]], 2
        LOAD_W_MEM
        mov     dx, ax
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_3138         ENDP

op_3139         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        bswap   eax
        sub     dword ptr[regs+a[ebx]], 2
        LOAD_W_MEM
        mov     dx, ax
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_3139         ENDP

op_313a         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        mov     edx, dword ptr[regs+pc]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, edx
        sub     dword ptr[regs+a[ebx]], 2
        LOAD_W_MEM
        mov     dx, ax
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_313a         ENDP

op_313b         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        push    dword ptr[regs+pc]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        GET_DISP_EA
        sub     dword ptr[regs+a[ebx]], 2
        LOAD_W_MEM
        mov     dx, ax
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_313b         ENDP

op_313c         PROC
        shr     ebx, 7
        mov     dx, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    dh, dl
        sub     dword ptr[regs+a[ebx]], 2
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_313c         ENDP

op_3140         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 9
        mov     edx, dword ptr[regs+d[ebx*4]]
        and     ecx, 7
        mov     eax, dword ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ecx*4]]
        mov     dword ptr[regs+v], 0
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_3140         ENDP

op_3148         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     dx, word ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_3148         ENDP

op_3150         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        add     dword ptr[regs+pc], 2
        LOAD_W_MEM
        mov     dx, ax
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_3150         ENDP

op_3158         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        add     dword ptr[regs+pc], 2
        add     dword ptr[regs+a[ebx*4]], 2
        LOAD_W_MEM
        mov     dx, ax
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_3158         ENDP

op_3160         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        sub     dword ptr[regs+a[ebx*4]], 2
        and     ecx, 1ch
        mov     eax, dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 2
        LOAD_W_MEM
        mov     dx, ax
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_3160         ENDP

op_3168         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     ax, word ptr[edi+2]
        and     ecx, 1ch
        add     dword ptr[regs+pc], 4
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx*4]]
        LOAD_W_MEM
        mov     dx, ax
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_3168         ENDP

op_3170         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     ax, word ptr[edi+2]
        and     ecx, 1ch
        add     dword ptr[regs+pc], 4
        push    dword ptr[regs+a[ebx*4]]
        xchg    ah, al
        GET_DISP_EA
        LOAD_W_MEM
        mov     dx, ax
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ecx]]
        mov     dword ptr[regs+v], 0
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_3170         ENDP

op_3178         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        xchg    ah, al
        cwde
        LOAD_W_MEM
        mov     dx, ax
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_3178         ENDP

op_3179         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 6
        bswap   eax
        LOAD_W_MEM
        mov     dx, ax
        mov     ax, word ptr[edi+6]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_3179         ENDP

op_317a         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+pc]
        add     dword ptr[regs+pc], 4
        LOAD_W_MEM
        mov     dx, ax
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_317a         ENDP

op_317b         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        push    dword ptr[regs+pc]
        xchg    ah, al
        GET_DISP_EA
        add     dword ptr[regs+pc], 4
        LOAD_W_MEM
        mov     dx, ax
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_317b         ENDP

op_317c         PROC
        shr     ebx, 7
        mov     dx, word ptr[edi+2]
        and     ebx, 1ch
        mov     ax, word ptr[edi+4]
        add     dword ptr[regs+pc], 4
        xchg    ah, al
        xchg    dh, dl
        cwde
        add     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_317c         ENDP

op_31c0         PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        mov     dx, word ptr[regs+d[ebx*4]]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        mov     dword ptr[regs+v], 0
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_31c0         ENDP

op_31c8         PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        mov     dx, word ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        mov     dword ptr[regs+v], 0
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_31c8         ENDP

op_31d0         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 2
        LOAD_W_MEM
        mov     dx, ax
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_31d0         ENDP

op_31d8         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 2
        add     dword ptr[regs+a[ebx*4]], 2
        LOAD_W_MEM
        mov     dx, ax
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_31d8         ENDP

op_31e0         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        sub     dword ptr[regs+a[ebx*4]], 2
        mov     eax, dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 2
        LOAD_W_MEM
        mov     dx, ax
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_31e0         ENDP

op_31e8         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+pc], 4
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx*4]]
        LOAD_W_MEM
        mov     dx, ax
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_31e8         ENDP

op_31f0         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+pc], 4
        mov     ax, word ptr[edi+2]
        push    dword ptr[regs+a[ebx*4]]
        xchg    ah, al
        GET_DISP_EA
        LOAD_W_MEM
        mov     dx, ax
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_31f0         ENDP

op_31f8         PROC
        mov     dword ptr[regs+v], 0
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     dword ptr[regs+pc], 4
        LOAD_W_MEM
        mov     dx, ax
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_31f8         ENDP

op_31f9         PROC
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[edi+2]
        bswap   eax
        add     dword ptr[regs+pc], 6
        LOAD_W_MEM
        mov     dx, ax
        mov     ax, word ptr[edi+6]
        xchg    ah, al
        cwde
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_31f9         ENDP

op_31fa         PROC
        mov     dword ptr[regs+v], 0
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+pc]
        add     dword ptr[regs+pc], 4
        LOAD_W_MEM
        mov     dx, ax
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_31fa         ENDP

op_31fb         PROC
        mov     ax, word ptr[edi+2]
        push    dword ptr[regs+pc]
        xchg    ah, al
        GET_DISP_EA
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+pc], 4
        LOAD_W_MEM
        mov     dx, ax
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        cwde
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_31fb         ENDP

op_31fc         PROC
        mov     dword ptr[regs+v], 0
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 4
        mov     ax, word ptr[edi+4]
        xchg    ah, al
        xchg    dh, dl
        cwde
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_31fc         ENDP

op_33c0         PROC
        and     ebx, 7
        mov     eax, dword ptr[edi+2]
        mov     dx, word ptr[regs+d[ebx*4]]
        add     dword ptr[regs+pc], 4
        bswap   eax
        mov     dword ptr[regs+v], 0
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_33c0         ENDP

op_33c8         PROC
        and     ebx, 7
        mov     eax, dword ptr[edi+2]
        mov     dx, word ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 4
        bswap   eax
        mov     dword ptr[regs+v], 0
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_33c8         ENDP

op_33d0         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 4
        LOAD_W_MEM
        mov     dx, ax
        mov     eax, dword ptr[edi+2]
        bswap   eax
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_33d0         ENDP

op_33d8         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 4
        add     dword ptr[regs+a[ebx*4]], 2
        LOAD_W_MEM
        mov     dx, ax
        mov     eax, dword ptr[edi+2]
        bswap   eax
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_33d8         ENDP

op_33e0         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        sub     dword ptr[regs+a[ebx*4]], 2
        mov     eax, dword ptr[regs+a[ebx*4]]
        add     dword ptr[regs+pc], 4
        LOAD_W_MEM
        mov     dx, ax
        mov     eax, dword ptr[edi+2]
        bswap   eax
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_33e0         ENDP

op_33e8         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+pc], 6
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx*4]]
        LOAD_W_MEM
        mov     dx, ax
        mov     eax, dword ptr[edi+4]
        bswap   eax
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_33e8         ENDP

op_33f0         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+pc], 6
        mov     ax, word ptr[edi+2]
        push    dword ptr[regs+a[ebx*4]]
        xchg    ah, al
        GET_DISP_EA
        LOAD_W_MEM
        mov     dx, ax
        mov     eax, dword ptr[edi+4]
        bswap   eax
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_33f0         ENDP

op_33f8         PROC
        mov     dword ptr[regs+v], 0
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     dword ptr[regs+pc], 6
        LOAD_W_MEM
        mov     dx, ax
        mov     eax, dword ptr[edi+4]
        bswap   eax
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_33f8         ENDP

op_33f9         PROC
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[edi+2]
        bswap   eax
        add     dword ptr[regs+pc], 8
        LOAD_W_MEM
        mov     dx, ax
        mov     eax, dword ptr[edi+6]
        bswap   eax
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_33f9         ENDP

op_33fa         PROC
        mov     dword ptr[regs+v], 0
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+pc]
        add     dword ptr[regs+pc], 6
        LOAD_W_MEM
        mov     dx, ax
        mov     eax, dword ptr[edi+4]
        bswap   eax
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_33fa         ENDP

op_33fb         PROC
        mov     ax, word ptr[edi+2]
        push    dword ptr[regs+pc]
        xchg    ah, al
        GET_DISP_EA
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+pc], 6
        LOAD_W_MEM
        mov     dx, ax
        mov     eax, dword ptr[edi+4]
        bswap   eax
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_33fb         ENDP

op_33fc         PROC
        mov     dword ptr[regs+v], 0
        mov     dx, word ptr[edi+2]
        add     dword ptr[regs+pc], 6
        mov     eax, dword ptr[edi+4]
        bswap   eax
        xchg    dh, dl
        SAVE_W_MEM
        cmp     dx, 0
        MAKE_SR_Z
        ret
op_33fc         ENDP

op_41d0         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     dword ptr[regs+a[ecx]], eax
        ret
op_41d0         ENDP

op_41e8         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 9
        mov     edx, dword ptr[regs+a[ebx*4]]
        and     ecx, 7
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     edx, eax
        mov     dword ptr[regs+a[ecx*4]], edx
        ret
op_41e8         ENDP

op_41f0         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        push    dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        GET_DISP_EA
        add     dword ptr[regs+pc], 2
        mov     dword ptr[regs+a[ecx]], eax
        ret
op_41f0         ENDP

op_41f8         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        mov     dword ptr[regs+a[ebx]], eax
        ret
op_41f8         ENDP

op_41f9         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        bswap   eax
        mov     dword ptr[regs+a[ebx]], eax
        ret
op_41f9         ENDP

op_41fa         PROC
        shr     ebx, 9
        mov     ax, word ptr[edi+2]
        and     ebx, 7
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+pc]
        add     dword ptr[regs+pc], 2
        mov     dword ptr[regs+a[ebx*4]], eax
        ret
op_41fa         ENDP

op_41fb         PROC
        shr     ebx, 9
        mov     ax, word ptr[edi+2]
        and     ebx, 7
        push    dword ptr[regs+pc]
        xchg    ah, al
        GET_DISP_EA
        add     dword ptr[regs+pc], 2
        mov     dword ptr[regs+a[ebx*4]], eax
        ret
op_41fb         ENDP

op_42b9         PROC
        mov     eax, dword ptr[edi+2]
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+pc], 4
        xor     edx, edx
        mov     byte ptr[regs+z], 1
        bswap   eax
        SAVE_L_MEM
        ret
op_42b9         ENDP

op_4840         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        mov     edx, dword ptr[regs+d[ebx*4]]
        mov     ecx, edx
        shl     edx, 16
        shr     ecx, 16
        or      edx, ecx
        mov     dword ptr[regs+d[ebx*4]], edx
        cmp     edx, 0
        MAKE_SR_Z
        ret
op_4840         ENDP

op_4880         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        shl     ebx, 2
        mov     al, byte ptr[regs+d[ebx]]
        cbw
        mov     word ptr[regs+d[ebx]], ax
        cmp     ax, 0
        jne     short op4880_next
        mov     byte ptr[regs+z], 1
op4880_next:
        jge     short op4880_next2
        mov     byte ptr[regs+n], 1
op4880_next2:
        ret
op_4880         ENDP

op_48c0         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        shl     ebx, 2
        mov     ax, word ptr[regs+d[ebx]]
        cwde
        mov     dword ptr[regs+d[ebx]], eax
        cmp     eax, 0
        jne     short op48c0_next
        mov     byte ptr[regs+z], 1
op48c0_next:
        jge     short op48c0_next2
        mov     byte ptr[regs+n], 1
op48c0_next2:
;        call    OpDebug
        ret
op_48c0         ENDP

op_49c0         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        shl     ebx, 2
        mov     al, byte ptr[regs+d[ebx]]
        cbw
        cwde
        mov     dword ptr[regs+d[ebx]], eax
        cmp     eax, 0
        jne     short op49c0_next
        mov     byte ptr[regs+z], 1
op49c0_next:
        jge     short op49c0_next2
        mov     byte ptr[regs+n], 1
op49c0_next2:
        ret
op_49c0         ENDP

op_4a00         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        shl     ebx, 2
        mov     al, byte ptr[regs+d[ebx]]
        cmp     al, 0
        jne     short op4a00_next
        mov     byte ptr[regs+z], 1
op4a00_next:
        jge     short op4a00_next2
        mov     byte ptr[regs+n], 1
op4a00_next2:
        ret
op_4a00         ENDP

op_4a10         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        shl     ebx, 2
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_B_MEM
        cmp     al, 0
        jne     short op4a10_next
        mov     byte ptr[regs+z], 1
op4a10_next:
        jge     short op4a10_next2
        mov     byte ptr[regs+n], 1
op4a10_next2:
        ret
op_4a10         ENDP

op_4a18         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        shl     ebx, 2
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_B_MEM
        cmp     al, 0
        jne     short op4a18_next
        mov     byte ptr[regs+z], 1
op4a18_next:
        jge     short op4a18_next2
        mov     byte ptr[regs+n], 1
op4a18_next2:
        inc     dword ptr[regs+a[ebx]]
        cmp     ebx, 28
        jne     short op4a18_next3
        inc     dword ptr[regs+a[ebx]]
op4a18_next3:
        ret
op_4a18         ENDP

op_4a20         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        shl     ebx, 2
        dec     dword ptr[regs+a[ebx]]
        cmp     ebx, 28
        jne     short op4a20_noa7
        dec     dword ptr[regs+a[ebx]]
op4a20_noa7:
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_B_MEM
        cmp     al, 0
        jne     short op4a20_next
        mov     byte ptr[regs+z], 1
op4a20_next:
        jge     short op4a20_next2
        mov     byte ptr[regs+n], 1
op4a20_next2:
        ret
op_4a20         ENDP

op_4a28         PROC
        and     ebx, 7
        mov     dword ptr[regs+v], 0
        shl     ebx, 2
        mov     ax, word ptr[edi+2]
        mov     edx, dword ptr[regs+a[ebx]]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, edx
        LOAD_B_MEM
        cmp     al, 0
        jne     short op4a28_next
        mov     byte ptr[regs+z], 1
op4a28_next:
        jge     short op4a28_next2
        mov     byte ptr[regs+n], 1
op4a28_next2:
        ret
op_4a28         ENDP

op_4a38         PROC
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        LOAD_B_MEM
        cmp     al, 0
        mov     dword ptr[regs+v], 0
        jne     short op4a38_next
        mov     byte ptr[regs+z], 1
op4a38_next:
        jge     short op4a38_next2
        mov     byte ptr[regs+n], 1
op4a38_next2:
        ret
op_4a38         ENDP

op_4e71         PROC
        ret
op_4e71         ENDP

op_4e75         PROC
        mov     eax, dword ptr[regs+a[28]]
        LOAD_L_MEM
        add     dword ptr[regs+a[28]], 4
        mov     dword ptr[regs+pc], eax
        ret
op_4e75         ENDP

op_4e90         PROC
        and     ebx, 7
        sub     dword ptr[regs+a[28]], 4
        shl     ebx, 2
        mov     eax, dword ptr[regs+a[28]]
        mov     edx, dword ptr[regs+pc]
        mov     ecx, dword ptr[regs+a[ebx]]
        SAVE_L_MEM
        mov     dword ptr[regs+pc], ecx
        ret
op_4e90         ENDP

op_4eb9         PROC
        sub     dword ptr[regs+a[28]], 4
        mov     edx, dword ptr[regs+pc]
        mov     eax, dword ptr[regs+a[28]]
        add     edx, 4
        mov     ebx, edi
        SAVE_L_MEM
        mov     eax, dword ptr[ebx+2]
        bswap   eax
        mov     dword ptr[regs+pc], eax
        ret
op_4eb9         ENDP

op_4eba         PROC
        sub     dword ptr[regs+a[28]], 4
        mov     edx, dword ptr[regs+pc]
        mov     eax, dword ptr[regs+a[28]]
        add     edx, 2
        mov     ebx, edi
        SAVE_L_MEM
        mov     edx, dword ptr[regs+pc]
        mov     ax, word ptr[ebx+2]
        xchg    ah, al
        cwde
        add     eax, edx
        mov     dword ptr[regs+pc], eax
        ret
op_4eba         ENDP

op_4ed0         PROC
        and     ebx, 7
        shl     ebx, 2
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+pc], eax
        ret
op_4ed0         ENDP

op_4efb         PROC
        mov     edx, dword ptr[regs+pc]
        mov     ax, word ptr[edi+2]
        push    edx
        xchg    ah, al
        GET_DISP_EA
        mov     dword ptr[regs+pc], eax
        ret
op_4efb         ENDP

op_5000          PROC
        mov     eax, ebx
        and     ebx, 7
        shr     eax, 9
        shl     ebx, 2
        and     eax, 7
        mov     dl, byte ptr[regs+d[ebx]]
        test    eax, eax
        jnz     short op5000_next
        mov     eax, 8
op5000_next:
        add     dl, al
        MAKE_SR_JX
        mov     byte ptr[regs+d[ebx]], dl
        ret
op_5000           ENDP

op_5010          PROC
        mov     edx, ebx
        and     ebx, 7
        shr     edx, 9
        shl     ebx, 2
        and     edx, 7
        mov     eax, dword ptr[regs+a[ebx]]
        test    edx, edx
        jnz     short op5010_next
        mov     edx, 8
op5010_next:
        LOAD_B_MEDI
        add     al, dl
        MAKE_SR_JX
        mov     byte ptr[edi], al
        ret
op_5010          ENDP

op_5018          PROC
        mov     edx, ebx
        and     ebx, 7
        shr     edx, 9
        shl     ebx, 2
        and     edx, 7
        mov     eax, dword ptr[regs+a[ebx]]
        test    edx, edx
        jnz     short op5018_next
        mov     edx, 8
op5018_next:
        LOAD_B_MEDI
        inc     dword ptr[regs+a[ebx]]
        add     al, dl
        MAKE_SR_JX
        cmp     ebx, 28
        jne     short op5018_noa7
        inc     dword ptr[regs+a[ebx]]
op5018_noa7:
        mov     byte ptr[edi], al
        ret
op_5018          ENDP

op_5020          PROC
        mov     edx, ebx
        and     ebx, 7
        shr     edx, 9
        shl     ebx, 2
        and     edx, 7
        dec     dword ptr[regs+a[ebx]]
        test    edx, edx
        jnz     short op5020_next
        mov     edx, 8
op5020_next:
        cmp     ebx, 28
        jne     short op5020_noa7
        dec     dword ptr[regs+a[ebx]]
op5020_noa7:
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_B_MEDI
        add     al, dl
        MAKE_SR_JX
        mov     byte ptr[edi], al
        ret
op_5020          ENDP

op_5028          PROC
        mov     edx, ebx
        and     ebx, 7
        shr     edx, 9
        shl     ebx, 2
        and     edx, 7
        mov     ax, word ptr[edi+2]
        mov     ecx, dword ptr[regs+a[ebx]]
        test    edx, edx
        jnz     short op5028_next
        mov     edx, 8
op5028_next:
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ecx
        LOAD_B_MEDI
        add     al, dl
        MAKE_SR_JX
        mov     byte ptr[edi], al
        ret
op_5028          ENDP

op_5038          PROC
        shr     ebx, 9
        mov     ax, word ptr[edi+2]
        and     ebx, 7
        add     dword ptr[regs+pc], 2
        test    ebx, ebx
        jnz     short op5038_next
        mov     ebx, 8
op5038_next:
        xchg    ah, al
        cwde
        LOAD_B_MEDI
        add     al, bl
        MAKE_SR_JX
        mov     byte ptr[edi], al
        ret
op_5038          ENDP

op_5039          PROC
        shr     ebx, 9
        mov     eax, dword ptr[edi+2]
        and     ebx, 7
        add     dword ptr[regs+pc], 4
        test    ebx, ebx
        jnz     short op5039_next
        mov     ebx, 8
op5039_next:
        bswap   eax
        LOAD_B_MEDI
        add     al, bl
        MAKE_SR_JX
        mov     byte ptr[edi], al
        ret
op_5039          ENDP

op_5040          PROC
        mov     eax, ebx
        and     ebx, 7
        shr     eax, 9
        shl     ebx, 2
        and     eax, 7
        mov     edx, dword ptr[regs+d[ebx]]
        test    eax, eax
        jnz     short op5040_next
        mov     eax, 8
op5040_next:
        add     dx, ax
        MAKE_SR_JX
        mov     word ptr[regs+d[ebx]], dx
        ret
op_5040           ENDP

op_5050          PROC
        mov     edx, ebx
        and     ebx, 7
        shr     edx, 9
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     edx, 7
        test    edx, edx
        jnz     short op5050_next
        mov     edx, 8
op5050_next:
        LOAD_W_MEDI
        add     ax, dx
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_5050          ENDP

op_5058          PROC
        mov     edx, ebx
        and     ebx, 7
        shr     edx, 9
        shl     ebx, 2
        and     edx, 7
        mov     eax, dword ptr[regs+a[ebx]]
        test    edx, edx
        jnz     short op5058_next
        mov     edx, 8
op5058_next:
        LOAD_W_MEDI
        add     dword ptr[regs+a[ebx]], 2
        add     ax, dx
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_5058          ENDP

op_5060          PROC
        mov     edx, ebx
        and     ebx, 7
        shr     edx, 9
        shl     ebx, 2
        and     edx, 7
        sub     dword ptr[regs+a[ebx]], 2
        test    edx, edx
        jnz     short op5060_next
        mov     edx, 8
op5060_next:
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_W_MEDI
        add     ax, dx
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_5060          ENDP

op_5068          PROC
        mov     edx, ebx
        and     ebx, 7
        shr     edx, 9
        shl     ebx, 2
        and     edx, 7
        mov     ax, word ptr[edi+2]
        mov     ecx, dword ptr[regs+a[ebx]]
        test    edx, edx
        jnz     short op5068_next
        mov     edx, 8
op5068_next:
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ecx
        LOAD_W_MEDI
        add     ax, dx
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_5068          ENDP

op_5078          PROC
        shr     ebx, 9
        mov     ax, word ptr[edi+2]
        and     ebx, 7
        add     dword ptr[regs+pc], 2
        test    ebx, ebx
        jnz     short op5078_next
        mov     ebx, 8
op5078_next:
        xchg    ah, al
        cwde
        LOAD_W_MEDI
        add     ax, bx
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_5078          ENDP

op_5079          PROC
        shr     ebx, 9
        mov     eax, dword ptr[edi+2]
        and     ebx, 7
        add     dword ptr[regs+pc], 4
        test    ebx, ebx
        jnz     short op5079_next
        mov     ebx, 8
op5079_next:
        bswap   eax
        LOAD_W_MEDI
        add     ax, bx
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_5079          ENDP

op_5080          PROC
        mov     eax, ebx
        and     ebx, 7
        shr     eax, 9
        shl     ebx, 2
        and     eax, 7
        mov     edx, dword ptr[regs+d[ebx]]
        test    eax, eax
        jnz     short op5080_next
        mov     eax, 8
op5080_next:
        add     edx, eax
        MAKE_SR_JX
        mov     dword ptr[regs+d[ebx]], edx
        ret
op_5080           ENDP

op_5090         PROC
        mov     edx, ebx
        and     ebx, 7
        shr     edx, 9
        and     edx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        test    edx, edx
        jnz     short op5090_next
        mov     edx, 8
op5090_next:
        LOAD_L_MEDI
        add     eax, edx
        MAKE_SR_JX
        bswap   eax
        mov     dword ptr[edi], eax
        ret
op_5090         ENDP

op_5098         PROC
        mov     edx, ebx
        and     ebx, 7
        shr     edx, 9
        shl     ebx, 2
        and     edx, 7
        mov     eax, dword ptr[regs+a[ebx]]
        test    edx, edx
        jnz     short op5098_next
        mov     edx, 8
op5098_next:
        LOAD_L_MEDI
        add     dword ptr[regs+a[ebx]], 4
        add     eax, edx
        MAKE_SR_JX
        bswap   eax
        mov     dword ptr[edi], eax
        ret
op_5098         ENDP

op_50a0          PROC
        mov     edx, ebx
        and     ebx, 7
        shr     edx, 9
        shl     ebx, 2
        and     edx, 7
        sub     dword ptr[regs+a[ebx]], 4
        test    edx, edx
        jnz     short op50a0_next
        mov     edx, 8
op50a0_next:
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_L_MEDI
        add     eax, edx
        MAKE_SR_JX
        bswap   eax
        mov     dword ptr[edi], eax
        ret
op_50a0          ENDP

op_50a8          PROC
        mov     edx, ebx
        and     ebx, 7
        shr     edx, 9
        shl     ebx, 2
        and     edx, 7
        mov     ax, word ptr[edi+2]
        mov     ecx, dword ptr[regs+a[ebx]]
        test    edx, edx
        jnz     short op50a8_next
        mov     edx, 8
op50a8_next:
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ecx
        LOAD_L_MEDI
        add     eax, edx
        MAKE_SR_JX
        bswap   eax
        mov     dword ptr[edi], eax
        ret
op_50a8          ENDP

op_50b8          PROC
        shr     ebx, 9
        mov     ax, word ptr[edi+2]
        and     ebx, 7
        add     dword ptr[regs+pc], 2
        test    ebx, ebx
        jnz     short op50b8_next
        mov     ebx, 8
op50b8_next:
        xchg    ah, al
        cwde
        LOAD_L_MEDI
        add     eax, ebx
        MAKE_SR_JX
        bswap   eax
        mov     dword ptr[edi], eax
        ret
op_50b8          ENDP

op_50b9          PROC
        shr     ebx, 9
        mov     eax, dword ptr[edi+2]
        and     ebx, 7
        add     dword ptr[regs+pc], 4
        test    ebx, ebx
        jnz     short op50b9_next
        mov     ebx, 8
op50b9_next:
        bswap   eax
        LOAD_L_MEDI
        add     eax, ebx
        MAKE_SR_JX
        bswap   eax
        mov     dword ptr[edi], eax
        ret
op_50b9          ENDP

op_5100          PROC
        mov     eax, ebx
        and     ebx, 7
        shr     eax, 9
        shl     ebx, 2
        and     eax, 7
        mov     dl, byte ptr[regs+d[ebx]]
        test    eax, eax
        jnz     short op5100_next
        mov     eax, 8
op5100_next:
        sub     dl, al
        MAKE_SR_JX
        mov     byte ptr[regs+d[ebx]], dl
        ret
op_5100           ENDP

op_5110          PROC
        mov     edx, ebx
        and     ebx, 7
        shr     edx, 9
        shl     ebx, 2
        and     edx, 7
        mov     eax, dword ptr[regs+a[ebx]]
        test    edx, edx
        jnz     short op5110_next
        mov     edx, 8
op5110_next:
        LOAD_B_MEDI
        sub     al, dl
        MAKE_SR_JX
        mov     byte ptr[edi], al
        ret
op_5110          ENDP

op_5118          PROC
        mov     edx, ebx
        and     ebx, 7
        shr     edx, 9
        shl     ebx, 2
        and     edx, 7
        mov     eax, dword ptr[regs+a[ebx]]
        test    edx, edx
        jnz     short op5118_next
        mov     edx, 8
op5118_next:
        LOAD_B_MEDI
        inc     dword ptr[regs+a[ebx]]
        sub     al, dl
        MAKE_SR_JX
        cmp     ebx, 28
        jne     short op5118_noa7
        inc     dword ptr[regs+a[ebx]]
op5118_noa7:
        mov     byte ptr[edi], al
        ret
op_5118          ENDP

op_5120          PROC
        mov     edx, ebx
        and     ebx, 7
        shr     edx, 9
        shl     ebx, 2
        and     edx, 7
        dec     dword ptr[regs+a[ebx]]
        test    edx, edx
        jnz     short op5120_next
        mov     edx, 8
op5120_next:
        cmp     ebx, 28
        jne     short op5120_noa7
        dec     dword ptr[regs+a[ebx]]
op5120_noa7:
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_B_MEDI
        sub     al, dl
        MAKE_SR_JX
        mov     byte ptr[edi], al
        ret
op_5120          ENDP

op_5128          PROC
        mov     edx, ebx
        and     ebx, 7
        shr     edx, 9
        shl     ebx, 2
        and     edx, 7
        mov     ax, word ptr[edi+2]
        mov     ecx, dword ptr[regs+a[ebx]]
        test    edx, edx
        jnz     short op5128_next
        mov     edx, 8
op5128_next:
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ecx
        LOAD_B_MEDI
        sub     al, dl
        MAKE_SR_JX
        mov     byte ptr[edi], al
        ret
op_5128          ENDP

op_5138          PROC
        shr     ebx, 9
        mov     ax, word ptr[edi+2]
        and     ebx, 7
        add     dword ptr[regs+pc], 2
        test    ebx, ebx
        jnz     short op5138_next
        mov     ebx, 8
op5138_next:
        xchg    ah, al
        cwde
        LOAD_B_MEDI
        sub     al, bl
        MAKE_SR_JX
        mov     byte ptr[edi], al
        ret
op_5138          ENDP

op_5139          PROC
        shr     ebx, 9
        mov     eax, dword ptr[edi+2]
        and     ebx, 7
        add     dword ptr[regs+pc], 4
        test    ebx, ebx
        jnz     short op5139_next
        mov     ebx, 8
op5139_next:
        bswap   eax
        LOAD_B_MEDI
        sub     al, bl
        MAKE_SR_JX
        mov     byte ptr[edi], al
        ret
op_5139          ENDP

op_5140          PROC
        mov     eax, ebx
        and     ebx, 7
        shr     eax, 9
        shl     ebx, 2
        and     eax, 7
        mov     dx, word ptr[regs+d[ebx]]
        test    eax, eax
        jnz     short op5140_next
        mov     eax, 8
op5140_next:
        sub     dx, ax
        MAKE_SR_JX
        mov     word ptr[regs+d[ebx]], dx
        ret
op_5140           ENDP

op_5150          PROC
        mov     edx, ebx
        and     ebx, 7
        shr     edx, 9
        shl     ebx, 2
        and     edx, 7
        mov     eax, dword ptr[regs+a[ebx]]
        test    edx, edx
        jnz     short op5150_next
        mov     edx, 8
op5150_next:
        LOAD_W_MEDI
        sub     ax, dx
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_5150          ENDP

op_5158          PROC
        mov     edx, ebx
        and     ebx, 7
        shr     edx, 9
        shl     ebx, 2
        and     edx, 7
        mov     eax, dword ptr[regs+a[ebx]]
        test    edx, edx
        jnz     short op5158_next
        mov     edx, 8
op5158_next:
        LOAD_W_MEDI
        add     dword ptr[regs+a[ebx]], 2
        sub     ax, dx
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_5158          ENDP

op_5160          PROC
        mov     edx, ebx
        and     ebx, 7
        shr     edx, 9
        shl     ebx, 2
        and     edx, 7
        sub     dword ptr[regs+a[ebx]], 2
        test    edx, edx
        jnz     short op5160_next
        mov     edx, 8
op5160_next:
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_W_MEDI
        sub     ax, dx
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_5160          ENDP

op_5168          PROC
        mov     edx, ebx
        and     ebx, 7
        shr     edx, 9
        shl     ebx, 2
        and     edx, 7
        mov     ax, word ptr[edi+2]
        mov     ecx, dword ptr[regs+a[ebx]]
        test    edx, edx
        jnz     short op5168_next
        mov     edx, 8
op5168_next:
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ecx
        LOAD_W_MEDI
        sub     ax, dx
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_5168          ENDP

op_5178          PROC
        shr     ebx, 9
        mov     ax, word ptr[edi+2]
        and     ebx, 7
        add     dword ptr[regs+pc], 2
        test    ebx, ebx
        jnz     short op5178_next
        mov     ebx, 8
op5178_next:
        xchg    ah, al
        cwde
        LOAD_W_MEDI
        sub     ax, bx
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_5178          ENDP

op_5179          PROC
        shr     ebx, 9
        mov     eax, dword ptr[edi+2]
        and     ebx, 7
        add     dword ptr[regs+pc], 4
        test    ebx, ebx
        jnz     short op5179_next
        mov     ebx, 8
op5179_next:
        bswap   eax
        LOAD_W_MEDI
        sub     ax, bx
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_5179          ENDP

op_5180          PROC
        mov     eax, ebx
        and     ebx, 7
        shr     eax, 9
        shl     ebx, 2
        and     eax, 7
        mov     edx, dword ptr[regs+d[ebx]]
        test    eax, eax
        jnz     short op5180_next
        mov     eax, 8
op5180_next:
        sub     edx, eax
        MAKE_SR_JX
        mov     dword ptr[regs+d[ebx]], edx
        ret
op_5180           ENDP

op_5190         PROC
        mov     edx, ebx
        and     ebx, 7
        shr     edx, 9
        shl     ebx, 2
        and     edx, 7
        mov     eax, dword ptr[regs+a[ebx]]
        test    edx, edx
        jnz     short op5190_next
        mov     edx, 8
op5190_next:
        LOAD_L_MEDI
        sub     eax, edx
        MAKE_SR_JX
        bswap   eax
        mov     dword ptr[edi], eax
        ret
op_5190         ENDP

op_5198         PROC
        mov     edx, ebx
        and     ebx, 7
        shr     edx, 9
        shl     ebx, 2
        and     edx, 7
        mov     eax, dword ptr[regs+a[ebx]]
        test    edx, edx
        jnz     short op5198_next
        mov     edx, 8
op5198_next:
        LOAD_L_MEDI
        add     dword ptr[regs+a[ebx]], 4
        sub     eax, edx
        MAKE_SR_JX
        bswap   eax
        mov     dword ptr[edi], eax
        ret
op_5198         ENDP

op_51a0          PROC
        mov     edx, ebx
        and     ebx, 7
        shr     edx, 9
        shl     ebx, 2
        and     edx, 7
        sub     dword ptr[regs+a[ebx]], 4
        test    edx, edx
        jnz     short op51a0_next
        mov     edx, 8
op51a0_next:
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_L_MEDI
        sub     eax, edx
        MAKE_SR_JX
        bswap   eax
        mov     dword ptr[edi], eax
        ret
op_51a0          ENDP

op_51a8          PROC
        mov     edx, ebx
        and     ebx, 7
        shr     edx, 9
        shl     ebx, 2
        and     edx, 7
        mov     ax, word ptr[edi+2]
        mov     ecx, dword ptr[regs+a[ebx]]
        test    edx, edx
        jnz     short op51a8_next
        mov     edx, 8
op51a8_next:
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ecx
        LOAD_L_MEDI
        sub     eax, edx
        MAKE_SR_JX
        bswap   eax
        mov     dword ptr[edi], eax
        ret
op_51a8          ENDP

op_51b8          PROC
        shr     ebx, 9
        mov     ax, word ptr[edi+2]
        and     ebx, 7
        add     dword ptr[regs+pc], 2
        test    ebx, ebx
        jnz     short op51b8_next
        mov     ebx, 8
op51b8_next:
        xchg    ah, al
        cwde
        LOAD_L_MEDI
        sub     eax, ebx
        MAKE_SR_JX
        bswap   eax
        mov     dword ptr[edi], eax
        ret
op_51b8          ENDP

op_51b9          PROC
        shr     ebx, 9
        mov     eax, dword ptr[edi+2]
        and     ebx, 7
        add     dword ptr[regs+pc], 4
        test    ebx, ebx
        jnz     short op51b9_next
        mov     ebx, 8
op51b9_next:
        bswap   eax
        LOAD_L_MEDI
        sub     eax, ebx
        MAKE_SR_JX
        bswap   eax
        mov     dword ptr[edi], eax
        ret
op_51b9          ENDP
      
op_51c8         PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        mov     cx, word ptr[regs+d[ebx]]
        xchg    ah, al
        cwde
        dec     cx
        sub     eax, 2
        cmp     cx, -1
        je      op51c8_z
        add     dword ptr[regs+pc], eax
op51c8_z:
        mov     word ptr[regs+d[ebx]], cx
        ret
op_51c8         ENDP

op_51f9         PROC
        mov     eax, dword ptr[edi+2]
        add     dword ptr[regs+pc], 4
        bswap   eax
        xor     dl, dl
        SAVE_B_MEM
        ret
op_51f9         ENDP

op_52f9         PROC
        mov     eax, dword ptr[edi+2]
        add     dword ptr[regs+pc], 4
        bswap   eax
        cmp     byte ptr[regs+c], 1
        je      op52f9_n2
        cmp     byte ptr[regs+z], 1
        je      op52f9_n2
        mov     dl, 0ffh
        SAVE_B_MEM
        ret
op52f9_n2:
        xor     dl, dl
        SAVE_B_MEM
        ret
op_52f9         ENDP

op_6000         PROC
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     dword ptr[regs+pc], eax
        ret
op_6000         ENDP

op_6001         PROC
        mov     eax, ebx
        cbw
        cwde
        add     dword ptr[regs+pc], eax
        ret
op_6001         ENDP

op_6100         PROC
        mov     ax, word ptr[edi+2]
        mov     ecx, dword ptr[regs+pc]
        add     dword ptr[regs+pc], 2
        sub     dword ptr[regs+a[28]], 4
        xchg    ah, al
        cwde
        add     ecx, eax
        mov     eax, dword ptr[regs+a[28]]
        mov     edx, dword ptr[regs+pc]
        SAVE_L_MEM
        mov     dword ptr[regs+pc], ecx
        ret
op_6100         ENDP

op_6101         PROC
        mov     eax, ebx
        sub     dword ptr[regs+a[28]], 4
        cbw
        cwde
        mov     ecx, eax
        mov     edx, dword ptr[regs+pc]
        mov     eax, dword ptr[regs+a[28]]
        add     ecx, edx
        SAVE_L_MEM
        mov     dword ptr[regs+pc], ecx
        ret
op_6101         ENDP

op_6200         PROC
        cmp     byte ptr[regs+c], 1
        je      op6200_done
        cmp     byte ptr[regs+z], 1
        je      op6200_done
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     dword ptr[regs+pc], eax
        ret
op6200_done:
        add     dword ptr[regs+pc], 2
        ret
op_6200         ENDP
                            
op_6201         PROC
        cmp     byte ptr[regs+c], 1
        je      short op6201_done
        cmp     byte ptr[regs+z], 1
        je      short op6201_done
        mov     eax, ebx
        cbw
        cwde
        add     dword ptr[regs+pc], eax
op6201_done:
        ret
op_6201         ENDP

op_6300         PROC
        cmp     byte ptr[regs+c], 1
        je      short op6300_ok
        cmp     byte ptr[regs+z], 1
        jne     op6300_done
op6300_ok:
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     dword ptr[regs+pc], eax
        ret
op6300_done:
        add     dword ptr[regs+pc], 2
        ret
op_6300         ENDP

op_6301         PROC
        cmp     byte ptr[regs+c], 1
        je      short op6301_ok
        cmp     byte ptr[regs+z], 1
        jne     short op6301_done
op6301_ok:
        mov     eax, ebx
        cbw
        cwde
        add     dword ptr[regs+pc], eax
op6301_done:
        ret
op_6301         ENDP

op_6400         PROC
        cmp     byte ptr[regs+c], 1
        je      op6400_done
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     dword ptr[regs+pc], eax
        ret
op6400_done:
        add     dword ptr[regs+pc], 2
        ret
op_6400         ENDP

op_6401         PROC
        cmp     byte ptr[regs+c], 1
        je      short op6401_done
        mov     eax, ebx
        cbw
        cwde
        add     dword ptr[regs+pc], eax
op6401_done:
        ret
op_6401         ENDP

op_6500         PROC
        cmp     byte ptr[regs+c], 1
        jne     op6500_done
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     dword ptr[regs+pc], eax
        ret
op6500_done:
        add     dword ptr[regs+pc], 2
        ret
op_6500         ENDP

op_6501         PROC
        cmp     byte ptr[regs+c], 1
        jne     short op6501_done
        mov     eax, ebx
        cbw
        cwde
        add     dword ptr[regs+pc], eax
op6501_done:
        ret
op_6501         ENDP

op_6600         PROC
        cmp     byte ptr[regs+z], 1
        je      op6600_done
        mov     ax, word ptr[edi+2]
        xchg    ah, al
        cwde
        add     dword ptr[regs+pc], eax
        ret
op6600_done:
        add     dword ptr[regs+pc], 2
        ret
op_6600         ENDP

op_6601         PROC
        cmp     byte ptr[regs+z], 1
        je      short op6601_done
        mov     eax, ebx
        cbw
        cwde
        add     dword ptr[regs+pc], eax
op6601_done:
        ret
op_6601         ENDP

op_6701         PROC
        cmp     byte ptr[regs+z], 1
        jne     short op6701_done
        mov     eax, ebx
        cbw
        cwde
        add     dword ptr[regs+pc], eax
op6701_done:
        ret
op_6701         ENDP

op_6801         PROC
        cmp     byte ptr[regs+v], 1
        je      short op6801_done
        mov     eax, ebx
        cbw
        cwde
        add     dword ptr[regs+pc], eax
op6801_done:
        ret
op_6801         ENDP

op_6901         PROC
        cmp     byte ptr[regs+v], 1
        jne     short op6901_done
        mov     eax, ebx
        cbw
        cwde
        add     dword ptr[regs+pc], eax
op6901_done:
        ret
op_6901         ENDP

op_6a01         PROC
        cmp     byte ptr[regs+n], 1
        je      short op6a01_done
        mov     eax, ebx
        cbw
        cwde
        add     dword ptr[regs+pc], eax
op6a01_done:
        ret
op_6a01         ENDP

op_6b01         PROC
        cmp     byte ptr[regs+n], 1
        jne     short op6b01_done
        mov     eax, ebx
        cbw
        cwde
        add     dword ptr[regs+pc], eax
op6b01_done:
        ret
op_6b01         ENDP

op_6c01         PROC
        mov     al, byte ptr[regs+v]
        cmp     byte ptr[regs+n], al
        jne     short op6c01_done
        mov     eax, ebx
        cbw
        cwde
        add     dword ptr[regs+pc], eax
op6c01_done:
        ret
op_6c01         ENDP

op_6d01         PROC
        mov     al, byte ptr[regs+v]
        cmp     byte ptr[regs+n], al
        je      short op6d01_done
        mov     eax, ebx
        cbw
        cwde
        add     dword ptr[regs+pc], eax
op6d01_done:
        ret
op_6d01         ENDP

op_6e01         PROC
        mov     al, byte ptr[regs+v]
        cmp     byte ptr[regs+n], al
        jne     short op6e01_done
        cmp     byte ptr[regs+z], 1
        je      short op6e01_done
        mov     eax, ebx
        cbw
        cwde
        add     dword ptr[regs+pc], eax
op6e01_done:
        ret
op_6e01         ENDP

op_6f01         PROC
        mov     al, byte ptr[regs+v]
        cmp     byte ptr[regs+n], al
        jne     short op6f01_ok
        cmp     byte ptr[regs+z], 1
        jne     short op6f01_done
op6f01_ok:
        mov     eax, ebx
        cbw
        cwde
        add     dword ptr[regs+pc], eax
op6f01_done:
        ret
op_6f01         ENDP

op_7000         PROC
        mov     al, bl
        shr     ebx, 7
        mov     dword ptr[regs+v], 0
        and     ebx, 1ch
        cbw
        cwde
        cmp     eax, 0
        jne     short op7000_noz
        mov     byte ptr[regs+z], 1
op7000_noz:
        jge     short op7000_non
        mov     byte ptr[regs+n], 1
op7000_non:
        mov     dword ptr[regs+d[ebx]], eax
        ret
op_7000         ENDP

op_81fc         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        mov     edx, dword ptr[regs+d[ebx]]
        xchg    ah, al
        test    ax, ax
        jnz     short op81fc_noexcep
        mov     eax, dword ptr[regs+pc]
        sub     eax, 2
        push    eax
        push    5
        call    Exception
        add     esp, 8
        jmp     short op81fc_done
op81fc_noexcep:
        cwde
        mov     ecx, eax
        mov     eax, edx
        xor     edx, edx
        idiv    ecx
        MAKE_SR_J
        shl     edx, 16
        and     eax, 0ffffh
        or      eax, edx
        mov     dword ptr[regs+d[ebx]], eax
op81fc_done:
        ret
op_81fc         ENDP

op_91fc         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        bswap   eax
        sub     dword ptr[regs+a[ebx]], eax
        ret
op_91fc         ENDP

op_b000         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     dl, byte ptr[regs+d[ebx]]
        mov     al, byte ptr[regs+d[ecx]]
        cmp     al, dl
        MAKE_SR_J
        ret
op_b000         ENDP

op_b010         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dl, byte ptr[regs+d[ecx]]
        LOAD_B_MEM
        cmp     dl, al
        MAKE_SR_J
        ret
op_b010         ENDP

op_b018         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dl, byte ptr[regs+d[ecx]]
        inc     dword ptr[regs+a[ebx]]
        cmp     ebx, 28
        jne     short opb018_noa7
        inc     dword ptr[regs+a[ebx]]
opb018_noa7:
        LOAD_B_MEM
        cmp     dl, al
        MAKE_SR_J
        ret
op_b018          ENDP

op_b020         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        dec     dword ptr[regs+a[ebx]]
        cmp     ebx, 28
        jne     opb020_noa7
        dec     dword ptr[regs+a[ebx]]
opb020_noa7:
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dl, byte ptr[regs+d[ecx]]
        LOAD_B_MEM
        cmp     dl, al
        MAKE_SR_J
        ret
op_b020         ENDP

op_b028         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     ebx, dword ptr[regs+a[ebx]]
        mov     ax, word ptr[edi+2]
        mov     dl, byte ptr[regs+d[ecx]]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ebx
        LOAD_B_MEM
        cmp     dl, al
        MAKE_SR_J
        ret
op_b028         ENDP

op_b038         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        mov     dl, byte ptr[regs+d[ebx]]
        xchg    ah, al
        cwde
        LOAD_B_MEM
        cmp     dl, al
        MAKE_SR_J
        ret
op_b038         ENDP

op_b039         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        mov     dl, byte ptr[regs+d[ebx]]
        bswap   eax
        LOAD_B_MEM
        cmp     dl, al
        MAKE_SR_J
        ret
op_b039         ENDP

op_b03a         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        mov     ecx, dword ptr[regs+pc]
        add     dword ptr[regs+pc], 2
        mov     dl, byte ptr[regs+d[ebx]]
        xchg    ah, al
        cwde
        add     eax, ecx
        LOAD_B_MEM
        cmp     dl, al
        MAKE_SR_J
        ret
op_b03a         ENDP

op_b03c         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        mov     dl, byte ptr[regs+d[ebx]]
        cmp     dl, ah
        MAKE_SR_J
        ret
op_b03c         ENDP

op_b040         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     dx, word ptr[regs+d[ebx]]
        mov     ax, word ptr[regs+d[ecx]]
        cmp     ax, dx
        MAKE_SR_J
        ret
op_b040         ENDP

op_b048         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     dx, word ptr[regs+a[ebx]]
        mov     ax, word ptr[regs+d[ecx]]
        cmp     ax, dx
        MAKE_SR_J
        ret
op_b048         ENDP

op_b050         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dx, word ptr[regs+d[ecx]]
        LOAD_W_MEM
        cmp     dx, ax
        MAKE_SR_J
        ret
op_b050         ENDP

op_b058         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dx, word ptr[regs+d[ecx]]
        add     dword ptr[regs+a[ebx]], 2
        LOAD_W_MEM
        cmp     dx, ax
        MAKE_SR_J
        ret
op_b058          ENDP

op_b060         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        sub     dword ptr[regs+a[ebx]], 2
        mov     dx, word ptr[regs+d[ecx]]
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_W_MEM
        cmp     dx, ax
        MAKE_SR_J
        ret
op_b060         ENDP

op_b068         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     ebx, dword ptr[regs+a[ebx]]
        mov     ax, word ptr[edi+2]
        mov     dx, word ptr[regs+d[ecx]]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ebx
        LOAD_W_MEM
        cmp     dx, ax
        MAKE_SR_J
        ret
op_b068         ENDP

op_b078         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        mov     dx, word ptr[regs+d[ebx]]
        xchg    ah, al
        cwde
        LOAD_W_MEM
        cmp     dx, ax
        MAKE_SR_J
        ret
op_b078         ENDP

op_b079         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        mov     dx, word ptr[regs+d[ebx]]
        bswap   eax
        LOAD_W_MEM
        cmp     dx, ax
        MAKE_SR_J
        ret
op_b079         ENDP

op_b07a         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        mov     ecx, dword ptr[regs+pc]
        add     dword ptr[regs+pc], 2
        mov     dx, word ptr[regs+d[ebx]]
        xchg    ah, al
        cwde
        add     eax, ecx
        LOAD_W_MEM
        cmp     dx, ax
        MAKE_SR_J
        ret
op_b07a         ENDP

op_b07c         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        mov     dx, word ptr[regs+d[ebx]]
        xchg    ah, al
        cmp     dx, ax
        MAKE_SR_J
        ret
op_b07c         ENDP

op_b080         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     edx, dword ptr[regs+d[ebx]]
        mov     eax, dword ptr[regs+d[ecx]]
        cmp     eax, edx
        MAKE_SR_J
        ret
op_b080         ENDP

op_b088         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     edx, dword ptr[regs+a[ebx]]
        mov     eax, dword ptr[regs+d[ecx]]
        cmp     eax, edx
        MAKE_SR_J
        ret
op_b088         ENDP

op_b090         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     eax, dword ptr[regs+a[ebx]]
        mov     edx, dword ptr[regs+d[ecx]]
        LOAD_L_MEM
        cmp     edx, eax
        MAKE_SR_J
        ret
op_b090         ENDP

op_b098         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     eax, dword ptr[regs+a[ebx]]
        mov     edx, dword ptr[regs+d[ecx]]
        add     dword ptr[regs+a[ebx]], 4
        LOAD_L_MEM
        cmp     edx, eax
        MAKE_SR_J
        ret
op_b098          ENDP

op_b0a0         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        sub     dword ptr[regs+a[ebx]], 4
        mov     edx, dword ptr[regs+d[ecx]]
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_L_MEM
        cmp     edx, eax
        MAKE_SR_J
        ret
op_b0a0         ENDP

op_b0a8         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     ebx, dword ptr[regs+a[ebx]]
        mov     ax, word ptr[edi+2]
        mov     edx, dword ptr[regs+d[ecx]]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ebx
        LOAD_L_MEM
        cmp     edx, eax
        MAKE_SR_J
        ret
op_b0a8         ENDP

op_b0b8         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        mov     edx, dword ptr[regs+d[ebx]]
        xchg    ah, al
        cwde
        LOAD_L_MEM
        cmp     edx, eax
        MAKE_SR_J
        ret
op_b0b8         ENDP

op_b0b9         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        mov     edx, dword ptr[regs+d[ebx]]
        bswap   eax
        LOAD_L_MEM
        cmp     edx, eax
        MAKE_SR_J
        ret
op_b0b9         ENDP

op_b0ba         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        mov     ecx, dword ptr[regs+pc]
        add     dword ptr[regs+pc], 2
        mov     edx, dword ptr[regs+d[ebx]]
        xchg    ah, al
        cwde
        add     eax, ecx
        LOAD_L_MEM
        cmp     edx, eax
        MAKE_SR_J
        ret
op_b0ba         ENDP

op_b0bc         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        mov     edx, dword ptr[regs+d[ebx]]
        bswap   eax
        cmp     edx, eax
        MAKE_SR_J
        ret
op_b0bc         ENDP

op_b1fc         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        mov     edx, dword ptr[regs+a[ebx]]
        bswap   eax
        cmp     edx, eax
        MAKE_SR_J
        ret
op_b1fc         ENDP

op_c000         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     dl, byte ptr[regs+d[ebx]]
        mov     dword ptr[regs+v], 0
        and     byte ptr[regs+d[ecx]], dl
        MAKE_SR_ZS
        ret
op_c000         ENDP

op_c010         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        LOAD_B_MEM
        and     byte ptr[regs+d[ecx]], al
        MAKE_SR_ZS
        ret
op_c010         ENDP

op_c018         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        inc     dword ptr[regs+a[ebx]]
        cmp     ebx, 28
        jne     short opc018_noa7
        inc     dword ptr[regs+a[ebx]]
opc018_noa7:
        LOAD_B_MEM
        and     byte ptr[regs+d[ecx]], al
        MAKE_SR_ZS
        ret
op_c018          ENDP

op_c020         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        dec     dword ptr[regs+a[ebx]]
        cmp     ebx, 28
        jne     opc020_noa7
        dec     dword ptr[regs+a[ebx]]
opc020_noa7:
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        LOAD_B_MEM
        and     byte ptr[regs+d[ecx]], al
        MAKE_SR_ZS
        ret
op_c020         ENDP

op_c028         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     ebx, dword ptr[regs+a[ebx]]
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ebx
        mov     dword ptr[regs+v], 0
        LOAD_B_MEM
        and     byte ptr[regs+d[ecx]], al
        MAKE_SR_ZS
        ret
op_c028         ENDP

op_c030         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        mov     eax, dword ptr[regs+a[ebx*4]]
        and     ecx, 1ch
        mov     dword ptr[regs+v], 0
        push    eax
        add     dword ptr[regs+pc], 2
        mov     eax, dword ptr[edi+2]
        xchg    ah, al
        GET_DISP_EA
        LOAD_B_MEM
        and     byte ptr[regs+d[ecx]], al
        MAKE_SR_ZS
        ret
op_c030         ENDP

op_c038         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        mov     dword ptr[regs+v], 0
        LOAD_B_MEM
        and     byte ptr[regs+d[ebx]], al
        MAKE_SR_ZS
        ret
op_c038         ENDP

op_c039         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        bswap   eax
        mov     dword ptr[regs+v], 0
        LOAD_B_MEM
        and     byte ptr[regs+d[ebx]], al
        MAKE_SR_ZS
        ret
op_c039         ENDP

op_c03a         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        mov     ecx, dword ptr[regs+pc]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ecx
        mov     dword ptr[regs+v], 0
        LOAD_B_MEM
        and     byte ptr[regs+d[ebx]], al
        MAKE_SR_ZS
        ret
op_c03a         ENDP

op_c03c         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        mov     dword ptr[regs+v], 0
        and     byte ptr[regs+d[ebx]], ah
        MAKE_SR_ZS
        ret
op_c03c         ENDP

op_c040         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     dx, word ptr[regs+d[ebx]]
        mov     dword ptr[regs+v], 0
        and     word ptr[regs+d[ecx]], dx
        MAKE_SR_ZS
        ret
op_c040         ENDP

op_c050         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        LOAD_W_MEM
        and     word ptr[regs+d[ecx]], ax
        MAKE_SR_ZS
        ret
op_c050         ENDP

op_c058         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+a[ebx]], 2
        LOAD_W_MEM
        and     word ptr[regs+d[ecx]], ax
        MAKE_SR_ZS
        ret
op_c058          ENDP

op_c060         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        sub     dword ptr[regs+a[ebx]], 2
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_W_MEM
        and     word ptr[regs+d[ecx]], ax
        MAKE_SR_ZS
        ret
op_c060         ENDP

op_c068         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     ebx, dword ptr[regs+a[ebx]]
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ebx
        mov     dword ptr[regs+v], 0
        LOAD_W_MEM
        and     word ptr[regs+d[ecx]], ax
        MAKE_SR_ZS
        ret
op_c068         ENDP

op_c078         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        mov     dword ptr[regs+v], 0
        LOAD_W_MEM
        and     word ptr[regs+d[ebx]], ax
        MAKE_SR_ZS
        ret
op_c078         ENDP

op_c079         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        bswap   eax
        mov     dword ptr[regs+v], 0
        LOAD_W_MEM
        and     word ptr[regs+d[ebx]], ax
        MAKE_SR_ZS
        ret
op_c079         ENDP

op_c07a         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        mov     ecx, dword ptr[regs+pc]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ecx
        mov     dword ptr[regs+v], 0
        LOAD_W_MEM
        and     word ptr[regs+d[ebx]], ax
        MAKE_SR_ZS
        ret
op_c07a         ENDP

op_c07c         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        mov     dword ptr[regs+v], 0
        and     word ptr[regs+d[ebx]], ax
        MAKE_SR_ZS
        ret
op_c07c         ENDP

op_c080         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     edx, dword ptr[regs+d[ebx]]
        mov     dword ptr[regs+v], 0
        and     dword ptr[regs+d[ecx]], edx
        MAKE_SR_ZS
        ret
op_c080         ENDP

op_c090         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        LOAD_L_MEM
        and     dword ptr[regs+d[ecx]], eax
        MAKE_SR_ZS
        ret
op_c090         ENDP

op_c098         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dword ptr[regs+v], 0
        add     dword ptr[regs+a[ebx]], 4
        LOAD_L_MEM
        and     dword ptr[regs+d[ecx]], eax
        MAKE_SR_ZS
        ret
op_c098          ENDP

op_c0a0         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        sub     dword ptr[regs+a[ebx]], 4
        mov     dword ptr[regs+v], 0
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_L_MEM
        and     dword ptr[regs+d[ecx]], eax
        MAKE_SR_ZS
        ret
op_c0a0         ENDP

op_c0a8         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     ebx, dword ptr[regs+a[ebx]]
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ebx
        mov     dword ptr[regs+v], 0
        LOAD_L_MEM
        and     dword ptr[regs+d[ecx]], eax
        MAKE_SR_ZS
        ret
op_c0a8         ENDP

op_c0b8         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        mov     dword ptr[regs+v], 0
        LOAD_L_MEM
        and     dword ptr[regs+d[ebx]], eax
        MAKE_SR_ZS
        ret
op_c0b8         ENDP

op_c0b9         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        bswap   eax
        mov     dword ptr[regs+v], 0
        LOAD_L_MEM
        and     dword ptr[regs+d[ebx]], eax
        MAKE_SR_ZS
        ret
op_c0b9         ENDP

op_c0ba         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        mov     ecx, dword ptr[regs+pc]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ecx
        mov     dword ptr[regs+v], 0
        LOAD_L_MEM
        and     dword ptr[regs+d[ebx]], eax
        MAKE_SR_ZS
        ret
op_c0ba         ENDP

op_c0bc         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        bswap   eax
        mov     dword ptr[regs+v], 0
        and     dword ptr[regs+d[ebx]], eax
        MAKE_SR_ZS
        ret
op_c0bc         ENDP

op_d000         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     dl, byte ptr[regs+d[ebx]]
        mov     al, byte ptr[regs+d[ecx]]
        add     al, dl
        MAKE_SR_JX
        mov     byte ptr[regs+d[ecx]], al
        ret
op_d000         ENDP

op_d010         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dl, byte ptr[regs+d[ecx]]
        LOAD_B_MEM
        add     dl, al
        MAKE_SR_JX
        mov     byte ptr[regs+d[ecx]], dl
        ret
op_d010         ENDP

op_d018         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dl, byte ptr[regs+d[ecx]]
        inc     dword ptr[regs+a[ebx]]
        cmp     ebx, 28
        jne     short opd018_noa7
        inc     dword ptr[regs+a[ebx]]
opd018_noa7:
        LOAD_B_MEM
        add     dl, al
        MAKE_SR_JX
        mov     byte ptr[regs+d[ecx]], dl
        ret
op_d018          ENDP

op_d020         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        dec     dword ptr[regs+a[ebx]]
        cmp     ebx, 28
        jne     opd020_noa7
        dec     dword ptr[regs+a[ebx]]
opd020_noa7:
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dl, byte ptr[regs+d[ecx]]
        LOAD_B_MEM
        add     dl, al
        MAKE_SR_JX
        mov     byte ptr[regs+d[ecx]], dl
        ret
op_d020         ENDP

op_d028         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     ebx, dword ptr[regs+a[ebx]]
        mov     ax, word ptr[edi+2]
        mov     dl, byte ptr[regs+d[ecx]]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ebx
        LOAD_B_MEM
        add     dl, al
        MAKE_SR_JX
        mov     byte ptr[regs+d[ecx]], dl
        ret
op_d028         ENDP

op_d038         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        mov     dl, byte ptr[regs+d[ebx]]
        xchg    ah, al
        cwde
        LOAD_B_MEM
        add     dl, al
        MAKE_SR_JX
        mov     byte ptr[regs+d[ebx]], dl
        ret
op_d038         ENDP

op_d039         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        mov     dl, byte ptr[regs+d[ebx]]
        bswap   eax
        LOAD_B_MEM
        add     dl, al
        MAKE_SR_JX
        mov     byte ptr[regs+d[ebx]], dl
        ret
op_d039         ENDP

op_d03a         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        mov     ecx, dword ptr[regs+pc]
        add     dword ptr[regs+pc], 2
        mov     dl, byte ptr[regs+d[ebx]]
        xchg    ah, al
        cwde
        add     eax, ecx
        LOAD_B_MEM
        add     dl, al
        MAKE_SR_JX
        mov     byte ptr[regs+d[ebx]], dl
        ret
op_d03a         ENDP

op_d03c         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        mov     dl, byte ptr[regs+d[ebx]]
        add     dl, ah
        MAKE_SR_JX
        mov     byte ptr[regs+d[ebx]], dl
        ret
op_d03c         ENDP

op_d040         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     dx, word ptr[regs+d[ebx]]
        mov     ax, word ptr[regs+d[ecx]]
        add     ax, dx
        MAKE_SR_JX
        mov     word ptr[regs+d[ecx]], ax
        ret
op_d040         ENDP

op_d048         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     dx, word ptr[regs+a[ebx]]
        mov     ax, word ptr[regs+d[ecx]]
        add     ax, dx
        MAKE_SR_JX
        mov     word ptr[regs+d[ecx]], ax
        ret
op_d048         ENDP

op_d050         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dx, word ptr[regs+d[ecx]]
        LOAD_W_MEM
        add     dx, ax
        MAKE_SR_JX
        mov     word ptr[regs+d[ecx]], dx
        ret
op_d050         ENDP

op_d058         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     eax, dword ptr[regs+a[ebx]]
        mov     dx, word ptr[regs+d[ecx]]
        add     dword ptr[regs+a[ebx]], 2
        LOAD_W_MEM
        add     dx, ax
        MAKE_SR_JX
        mov     word ptr[regs+d[ecx]], dx
        ret
op_d058          ENDP

op_d060         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        sub     dword ptr[regs+a[ebx]], 2
        mov     dx, word ptr[regs+d[ecx]]
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_W_MEM
        add     dx, ax
        MAKE_SR_JX
        mov     word ptr[regs+d[ecx]], dx
        ret
op_d060         ENDP

op_d068         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     ebx, dword ptr[regs+a[ebx]]
        mov     ax, word ptr[edi+2]
        mov     dx, word ptr[regs+d[ecx]]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ebx
        LOAD_W_MEM
        add     dx, ax
        MAKE_SR_JX
        mov     word ptr[regs+d[ecx]], dx
        ret
op_d068         ENDP

op_d078         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        mov     dx, word ptr[regs+d[ebx]]
        xchg    ah, al
        cwde
        LOAD_W_MEM
        add     dx, ax
        MAKE_SR_JX
        mov     word ptr[regs+d[ebx]], dx
        ret
op_d078         ENDP

op_d079         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        mov     dx, word ptr[regs+d[ebx]]
        bswap   eax
        LOAD_W_MEM
        add     dx, ax
        MAKE_SR_JX
        mov     word ptr[regs+d[ebx]], dx
        ret
op_d079         ENDP

op_d07a         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        mov     ecx, dword ptr[regs+pc]
        add     dword ptr[regs+pc], 2
        mov     dx, word ptr[regs+d[ebx]]
        xchg    ah, al
        cwde
        add     eax, ecx
        LOAD_W_MEM
        add     dx, ax
        MAKE_SR_JX
        mov     word ptr[regs+d[ebx]], dx
        ret
op_d07a         ENDP

op_d07c         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        mov     dx, word ptr[regs+d[ebx]]
        xchg    ah, al
        add     dx, ax
        MAKE_SR_JX
        mov     word ptr[regs+d[ebx]], dx
        ret
op_d07c         ENDP

op_d080         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     edx, dword ptr[regs+d[ebx]]
        mov     eax, dword ptr[regs+d[ecx]]
        add     eax, edx
        MAKE_SR_JX
        mov     dword ptr[regs+d[ecx]], eax
        ret
op_d080         ENDP

op_d088         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     edx, dword ptr[regs+a[ebx]]
        mov     eax, dword ptr[regs+d[ecx]]
        add     eax, edx
        MAKE_SR_JX
        mov     dword ptr[regs+d[ecx]], eax
        ret
op_d088         ENDP

op_d090         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     eax, dword ptr[regs+a[ebx]]
        mov     edx, dword ptr[regs+d[ecx]]
        LOAD_L_MEM
        add     edx, eax
        MAKE_SR_JX
        mov     dword ptr[regs+d[ecx]], edx
        ret
op_d090         ENDP

op_d098         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     eax, dword ptr[regs+a[ebx]]
        mov     edx, dword ptr[regs+d[ecx]]
        add     dword ptr[regs+a[ebx]], 4
        LOAD_L_MEM
        add     edx, eax
        MAKE_SR_JX
        mov     dword ptr[regs+d[ecx]], edx
        ret
op_d098          ENDP

op_d0a0         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        sub     dword ptr[regs+a[ebx]], 4
        mov     edx, dword ptr[regs+d[ecx]]
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_L_MEM
        add     edx, eax
        MAKE_SR_JX
        mov     dword ptr[regs+d[ecx]], edx
        ret
op_d0a0         ENDP

op_d0a8         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     ebx, dword ptr[regs+a[ebx]]
        mov     ax, word ptr[edi+2]
        mov     edx, dword ptr[regs+d[ecx]]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, ebx
        LOAD_L_MEM
        add     edx, eax
        MAKE_SR_JX
        mov     dword ptr[regs+d[ecx]], edx
        ret
op_d0a8         ENDP

op_d0b8         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 2
        mov     edx, dword ptr[regs+d[ebx]]
        xchg    ah, al
        cwde
        LOAD_L_MEM
        add     edx, eax
        MAKE_SR_JX
        mov     dword ptr[regs+d[ebx]], edx
        ret
op_d0b8         ENDP

op_d0b9         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        mov     edx, dword ptr[regs+d[ebx]]
        bswap   eax
        LOAD_L_MEM
        add     edx, eax
        MAKE_SR_JX
        mov     dword ptr[regs+d[ebx]], edx
        ret
op_d0b9         ENDP

op_d0ba         PROC
        shr     ebx, 7
        mov     ax, word ptr[edi+2]
        and     ebx, 1ch
        mov     ecx, dword ptr[regs+pc]
        add     dword ptr[regs+pc], 2
        mov     edx, dword ptr[regs+d[ebx]]
        xchg    ah, al
        cwde
        add     eax, ecx
        LOAD_L_MEM
        add     edx, eax
        MAKE_SR_JX
        mov     dword ptr[regs+d[ebx]], edx
        ret
op_d0ba         ENDP

op_d0bc         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        mov     edx, dword ptr[regs+d[ebx]]
        bswap   eax
        add     edx, eax
        MAKE_SR_JX
        mov     dword ptr[regs+d[ebx]], edx
        ret
op_d0bc         ENDP
      
op_d1fc         PROC
        shr     ebx, 7
        mov     eax, dword ptr[edi+2]
        and     ebx, 1ch
        add     dword ptr[regs+pc], 4
        bswap   eax
        add     dword ptr[regs+a[ebx]], eax
        ret
op_d1fc         ENDP

op_e000         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 9
        shl     ebx, 2
        and     ecx, 7
        mov     dl, byte ptr[regs+d[ebx]]
        test    ecx, ecx
        jnz     short ope000_next
        mov     ecx, 8
ope000_next:
        sar     dl, cl
        MAKE_SR_JX
        mov     byte ptr[regs+d[ebx]], dl
        ret
op_e000         ENDP

op_e008         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 9
        shl     ebx, 2
        and     ecx, 7
        mov     dl, byte ptr[regs+d[ebx]]
        test    ecx, ecx
        jnz     short ope008_next
        mov     ecx, 8
ope008_next:
        shr     dl, cl
        MAKE_SR_JX
        mov     byte ptr[regs+d[ebx]], dl
        ret
op_e008         ENDP

op_e018         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 9
        shl     ebx, 2
        and     ecx, 7
        mov     dl, byte ptr[regs+d[ebx]]
        test    ecx, ecx
        jnz     short ope018_next
        mov     ecx, 8
ope018_next:
        ror     dl, cl
        MAKE_SR_J
        mov     byte ptr[regs+d[ebx]], dl
        ret
op_e018         ENDP

op_e020         PROC

        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     dl, byte ptr[regs+d[ebx]]
        mov     cl, byte ptr[regs+d[ecx]]
        sar     dl, cl
        MAKE_SR_JX
        mov     byte ptr[regs+d[ebx]], dl
        ret
op_e020         ENDP

op_e028         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     dl, byte ptr[regs+d[ebx]]
        mov     cl, byte ptr[regs+d[ecx]]
        shr     dl, cl
        MAKE_SR_JX
        mov     byte ptr[regs+d[ebx]], dl
        ret
op_e028         ENDP

op_e038         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     dl, byte ptr[regs+d[ebx]]
        mov     cl, byte ptr[regs+d[ecx]]
        ror     dl, cl
        MAKE_SR_J
        mov     byte ptr[regs+d[ebx]], dl
        ret
op_e038         ENDP

op_e040         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 9
        shl     ebx, 2
        and     ecx, 7
        mov     dx, word ptr[regs+d[ebx]]
        test    ecx, ecx
        jnz     short ope040_next
        mov     ecx, 8
ope040_next:
        sar     dx, cl
        MAKE_SR_JX
        mov     word ptr[regs+d[ebx]], dx
        ret
op_e040         ENDP

op_e048         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 9
        shl     ebx, 2
        and     ecx, 7
        mov     dx, word ptr[regs+d[ebx]]
        test    ecx, ecx
        jnz     short ope048_cont
        mov     ecx, 8
ope048_cont:
        shr     dx, cl
        MAKE_SR_JX
        mov     word ptr[regs+d[ebx]], dx
        ret
op_e048         ENDP

op_e058         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 9
        shl     ebx, 2
        and     ecx, 7
        mov     dx, word ptr[regs+d[ebx]]
        test    ecx, ecx
        jnz     short ope058_cont
        mov     ecx, 8
ope058_cont:
        ror     dx, cl
        MAKE_SR_J
        mov     word ptr[regs+d[ebx]], dx
        ret
op_e058         ENDP

op_e060         PROC

        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     dx, word ptr[regs+d[ebx]]
        mov     cl, byte ptr[regs+d[ecx]]
        sar     dx, cl
        MAKE_SR_JX
        mov     word ptr[regs+d[ebx]], dx
        ret
op_e060         ENDP

op_e068         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     dx, word ptr[regs+d[ebx]]
        mov     cl, byte ptr[regs+d[ecx]]
        shr     dx, cl
        MAKE_SR_JX
        mov     word ptr[regs+d[ebx]], dx
        ret
op_e068         ENDP

op_e078         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     dx, word ptr[regs+d[ebx]]
        mov     cl, byte ptr[regs+d[ecx]]
        ror     dx, cl
        MAKE_SR_J
        mov     word ptr[regs+d[ebx]], dx
        ret
op_e078         ENDP

op_e080         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 9
        shl     ebx, 2
        and     ecx, 7
        mov     edx, dword ptr[regs+d[ebx]]
        test    ecx, ecx
        jnz     short ope080_cont
        mov     ecx, 8
ope080_cont:
        sar     edx, cl
        MAKE_SR_JX
        mov     dword ptr[regs+d[ebx]], edx
        ret
op_e080         ENDP

op_e088         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 9
        shl     ebx, 2
        and     ecx, 7
        mov     edx, dword ptr[regs+d[ebx]]
        test    ecx, ecx
        jnz     short ope088_cont
        mov     ecx, 8
ope088_cont:
        shr     edx, cl
        MAKE_SR_JX
        mov     dword ptr[regs+d[ebx]], edx
        ret
op_e088         ENDP

op_e098         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 9
        shl     ebx, 2
        and     ecx, 7
        mov     edx, dword ptr[regs+d[ebx]]
        test    ecx, ecx
        jnz     short ope098_cont
        mov     ecx, 8
ope098_cont:
        ror     edx, cl
        MAKE_SR_J
        mov     dword ptr[regs+d[ebx]], edx
        ret
op_e098         ENDP

op_e0a0         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     edx, dword ptr[regs+d[ebx]]
        mov     cl, byte ptr[regs+d[ecx]]
        sar     edx, cl
        MAKE_SR_JX
        mov     dword ptr[regs+d[ebx]], edx
        ret
op_e0a0         ENDP

op_e0a8         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     edx, dword ptr[regs+d[ebx]]
        mov     cl, byte ptr[regs+d[ecx]]
        shr     edx, cl
        MAKE_SR_JX
        mov     dword ptr[regs+d[ebx]], edx
        ret
op_e0a8         ENDP

op_e0b8         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     edx, dword ptr[regs+d[ebx]]
        mov     cl, byte ptr[regs+d[ecx]]
        ror     edx, cl
        MAKE_SR_J
        mov     dword ptr[regs+d[ebx]], edx
        ret
op_e0b8         ENDP

op_e0d0         PROC
        and     ebx, 7
        shl     ebx, 2
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_W_MEDI
        sar     ax, 1
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e0d0         ENDP

op_e0d8         PROC
        and     ebx, 7
        shl     ebx, 2
        mov     eax, dword ptr[regs+a[ebx]]
        add     dword ptr[regs+a[ebx]], 2
        LOAD_W_MEDI
        sar     ax, 1
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e0d8         ENDP

op_e0e0         PROC
        and     ebx, 7
        shl     ebx, 2
        sub     dword ptr[regs+a[ebx]], 2
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_W_MEDI
        sar     ax, 1
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e0e0         ENDP

op_e0e8         PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx]]
        LOAD_W_MEDI
        sar     ax, 1
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e0e8         ENDP

op_e0f0         PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        push    dword ptr[regs+a[ebx]]
        xchg    ah, al
        GET_DISP_EA
        LOAD_W_MEDI
        sar     ax, 1
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e0f0         ENDP

op_e0f8         PROC
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        LOAD_W_MEDI
        sar     ax, 1
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e0f8         ENDP

op_e0f9         PROC
        mov     eax, dword ptr[edi+2]
        add     dword ptr[regs+pc], 4
        bswap   eax
        LOAD_W_MEDI
        sar     ax, 1
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e0f9         ENDP

op_e100         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 9
        shl     ebx, 2
        and     ecx, 7
        mov     dl, byte ptr[regs+d[ebx]]
        test    ecx, ecx
        jnz     short ope100_next
        mov     ecx, 8
ope100_next:
        sal     dl, cl
        MAKE_SR_JX
        mov     byte ptr[regs+d[ebx]], dl
        ret
op_e100         ENDP

op_e108         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 9
        shl     ebx, 2
        and     ecx, 7
        mov     dl, byte ptr[regs+d[ebx]]
        test    ecx, ecx
        jnz     short ope108_next
        mov     ecx, 8
ope108_next:
        shl     dl, cl
        MAKE_SR_JX
        mov     byte ptr[regs+d[ebx]], dl
        ret
op_e108         ENDP

op_e118         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 9
        mov     al, byte ptr[regs+d[ebx*4]]
        and     ecx, 7
        jnz     short ope118_next
        mov     ecx, 8
ope118_next:
        rol     al, cl
        MAKE_SR_JR
        mov     byte ptr[regs+d[ebx*4]], al
        ret
op_e118         ENDP

op_e120         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     dl, byte ptr[regs+d[ebx]]
        mov     cl, byte ptr[regs+d[ecx]]
        sal     dl, cl
        MAKE_SR_JX
        mov     byte ptr[regs+d[ebx]], dl
        ret
op_e120         ENDP

op_e128         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     dl, byte ptr[regs+d[ebx]]
        mov     cl, byte ptr[regs+d[ecx]]
        shl     dl, cl
        MAKE_SR_JX
        mov     byte ptr[regs+d[ebx]], dl
        ret
op_e128         ENDP

op_e138         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     dl, byte ptr[regs+d[ebx]]
        mov     cl, byte ptr[regs+d[ecx]]
        rol     dl, cl
        MAKE_SR_J
        mov     byte ptr[regs+d[ebx]], dl
        ret
op_e138         ENDP

op_e140         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 9
        shl     ebx, 2
        and     ecx, 7
        mov     dx, word ptr[regs+d[ebx]]
        test    ecx, ecx
        jnz     short ope140_cont
        mov     ecx, 8
ope140_cont:
        sal     dx, cl
        MAKE_SR_JX
        mov     word ptr[regs+d[ebx]], dx
        ret
op_e140         ENDP

op_e148         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 9
        shl     ebx, 2
        and     ecx, 7
        mov     dx, word ptr[regs+d[ebx]]
        test    ecx, ecx
        jnz     short ope148_cont
        mov     ecx, 8
ope148_cont:
        shl     dx, cl
        MAKE_SR_JX
        mov     word ptr[regs+d[ebx]], dx
        ret
op_e148         ENDP

op_e158         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 9
        shl     ebx, 2
        and     ecx, 7
        mov     dx, word ptr[regs+d[ebx]]
        test    ecx, ecx
        jnz     short ope158_cont
        mov     ecx, 8
ope158_cont:
        rol     dx, cl
        MAKE_SR_J
        mov     word ptr[regs+d[ebx]], dx
        ret
op_e158         ENDP

op_e160         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     dx, word ptr[regs+d[ebx]]
        mov     cl, byte ptr[regs+d[ecx]]
        sal     dx, cl
        MAKE_SR_JX
        mov     word ptr[regs+d[ebx]], dx
        ret
op_e160         ENDP

op_e168         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     dx, word ptr[regs+d[ebx]]
        mov     cl, byte ptr[regs+d[ecx]]
        shl     dx, cl
        MAKE_SR_JX
        mov     word ptr[regs+d[ebx]], dx
        ret
op_e168         ENDP

op_e178         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     dx, word ptr[regs+d[ebx]]
        mov     cl, byte ptr[regs+d[ecx]]
        rol     dx, cl
        MAKE_SR_J
        mov     word ptr[regs+d[ebx]], dx
        ret
op_e178         ENDP

op_e180         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 9
        shl     ebx, 2
        and     ecx, 7
        mov     edx, dword ptr[regs+d[ebx]]
        test    ecx, ecx
        jnz     short ope180_cont
        mov     ecx, 8
ope180_cont:
        sal     edx, cl
        MAKE_SR_JX
        mov     dword ptr[regs+d[ebx]], edx
        ret
op_e180         ENDP

op_e188         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 9
        shl     ebx, 2
        and     ecx, 7
        mov     edx, dword ptr[regs+d[ebx]]
        test    ecx, ecx
        jnz     short ope188_cont
        mov     ecx, 8
ope188_cont:
        shl     edx, cl
        MAKE_SR_JX
        mov     dword ptr[regs+d[ebx]], edx
        ret
op_e188         ENDP

op_e198         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 9
        shl     ebx, 2
        and     ecx, 7
        mov     edx, dword ptr[regs+d[ebx]]
        test    ecx, ecx
        jnz     short ope198_cont
        mov     ecx, 8
ope198_cont:
        rol     edx, cl
        MAKE_SR_J
        mov     dword ptr[regs+d[ebx]], edx
        ret
op_e198         ENDP

op_e1a0         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     edx, dword ptr[regs+d[ebx]]
        mov     cl, byte ptr[regs+d[ecx]]
        sal     edx, cl
        MAKE_SR_JX
        mov     dword ptr[regs+d[ebx]], edx
        ret
op_e1a0         ENDP

op_e1a8         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     edx, dword ptr[regs+d[ebx]]
        mov     cl, byte ptr[regs+d[ecx]]
        shl     edx, cl
        MAKE_SR_JX
        mov     dword ptr[regs+d[ebx]], edx
        ret
op_e1a8         ENDP

op_e1b8         PROC
        mov     ecx, ebx
        and     ebx, 7
        shr     ecx, 7
        shl     ebx, 2
        and     ecx, 1ch
        mov     edx, dword ptr[regs+d[ebx]]
        mov     cl, byte ptr[regs+d[ecx]]
        rol     edx, cl
        MAKE_SR_J
        mov     dword ptr[regs+d[ebx]], edx
        ret
op_e1b8         ENDP

op_e1d0         PROC
        and     ebx, 7
        shl     ebx, 2
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_W_MEDI
        sal     ax, 1
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e1d0         ENDP

op_e1d8         PROC
        and     ebx, 7
        shl     ebx, 2
        mov     eax, dword ptr[regs+a[ebx]]
        add     dword ptr[regs+a[ebx]], 2
        LOAD_W_MEDI
        sal     ax, 1
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e1d8         ENDP

op_e1e0         PROC
        and     ebx, 7
        shl     ebx, 2
        sub     dword ptr[regs+a[ebx]], 2
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_W_MEDI
        sal     ax, 1
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e1e0         ENDP

op_e1e8         PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx]]
        LOAD_W_MEDI
        sal     ax, 1
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e1e8         ENDP

op_e1f0         PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        push    dword ptr[regs+a[ebx]]
        xchg    ah, al
        GET_DISP_EA
        LOAD_W_MEDI
        sal     ax, 1
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e1f0         ENDP

op_e1f8         PROC
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        LOAD_W_MEDI
        sal     ax, 1
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e1f8         ENDP

op_e1f9         PROC
        mov     eax, dword ptr[edi+2]
        add     dword ptr[regs+pc], 4
        bswap   eax
        LOAD_W_MEDI
        sal     ax, 1
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e1f9         ENDP

op_e2d0         PROC
        and     ebx, 7
        shl     ebx, 2
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_W_MEDI
        shr     ax, 1
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e2d0         ENDP

op_e2d8         PROC
        and     ebx, 7
        shl     ebx, 2
        mov     eax, dword ptr[regs+a[ebx]]
        add     dword ptr[regs+a[ebx]], 2
        LOAD_W_MEDI
        shr     ax, 1
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e2d8         ENDP

op_e2e0         PROC
        and     ebx, 7
        shl     ebx, 2
        sub     dword ptr[regs+a[ebx]], 2
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_W_MEDI
        shr     ax, 1
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e2e0         ENDP

op_e2e8         PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx]]
        LOAD_W_MEDI
        shr     ax, 1
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e2e8         ENDP

op_e2f0         PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        push    dword ptr[regs+a[ebx]]
        xchg    ah, al
        GET_DISP_EA
        LOAD_W_MEDI
        shr     ax, 1
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e2f0         ENDP

op_e2f8         PROC    
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        LOAD_W_MEDI
        shr     ax, 1
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e2f8         ENDP

op_e2f9         PROC
        mov     eax, dword ptr[edi+2]
        add     dword ptr[regs+pc], 4
        bswap   eax
        LOAD_W_MEDI
        shr     ax, 1
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e2f9         ENDP

op_e3d0         PROC
        and     ebx, 7
        shl     ebx, 2
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_W_MEDI
        shl     ax, 1
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e3d0         ENDP

op_e3d8         PROC
        and     ebx, 7
        shl     ebx, 2
        mov     eax, dword ptr[regs+a[ebx]]
        add     dword ptr[regs+a[ebx]], 2
        LOAD_W_MEDI
        shl     ax, 1
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e3d8         ENDP

op_e3e0         PROC
        and     ebx, 7
        shl     ebx, 2
        sub     dword ptr[regs+a[ebx]], 2
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_W_MEDI
        shl     ax, 1
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e3e0         ENDP

op_e3e8         PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx]]
        LOAD_W_MEDI
        shl     ax, 1
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e3e8         ENDP

op_e3f0         PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        push    dword ptr[regs+a[ebx]]
        xchg    ah, al
        GET_DISP_EA
        LOAD_W_MEDI
        shl     ax, 1
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e3f0         ENDP

op_e3f8         PROC
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        LOAD_W_MEDI
        shl     ax, 1
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e3f8         ENDP

op_e3f9         PROC
        mov     eax, dword ptr[edi+2]
        add     dword ptr[regs+pc], 4
        bswap   eax
        LOAD_W_MEDI
        shl     ax, 1
        MAKE_SR_JX
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e3f9         ENDP

op_e6d0         PROC
        and     ebx, 7
        shl     ebx, 2
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_W_MEDI
        ror     ax, 1
        MAKE_SR_J
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e6d0         ENDP

op_e6d8         PROC
        and     ebx, 7
        shl     ebx, 2
        mov     eax, dword ptr[regs+a[ebx]]
        add     dword ptr[regs+a[ebx]], 2
        LOAD_W_MEDI
        ror     ax, 1
        MAKE_SR_J
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e6d8         ENDP

op_e6e0         PROC
        and     ebx, 7
        shl     ebx, 2
        sub     dword ptr[regs+a[ebx]], 2
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_W_MEDI
        ror     ax, 1
        MAKE_SR_J
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e6e0         ENDP

op_e6e8         PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx]]
        LOAD_W_MEDI
        ror     ax, 1
        MAKE_SR_J
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e6e8         ENDP

op_e6f0         PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        push    dword ptr[regs+a[ebx]]
        xchg    ah, al
        GET_DISP_EA
        LOAD_W_MEDI
        ror     ax, 1
        MAKE_SR_J
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e6f0         ENDP

op_e6f8         PROC
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        LOAD_W_MEDI
        ror     ax, 1
        MAKE_SR_J
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e6f8         ENDP

op_e6f9         PROC
        mov     eax, dword ptr[edi+2]
        add     dword ptr[regs+pc], 4
        bswap   eax
        LOAD_W_MEDI
        ror     ax, 1
        MAKE_SR_J
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e6f9         ENDP

op_e7d0         PROC
        and     ebx, 7
        shl     ebx, 2
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_W_MEDI
        rol     ax, 1
        MAKE_SR_J
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e7d0         ENDP

op_e7d8         PROC
        and     ebx, 7
        shl     ebx, 2
        mov     eax, dword ptr[regs+a[ebx]]
        add     dword ptr[regs+a[ebx]], 2
        LOAD_W_MEDI
        rol     ax, 1
        MAKE_SR_J
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e7d8         ENDP

op_e7e0         PROC
        and     ebx, 7
        shl     ebx, 2
        sub     dword ptr[regs+a[ebx]], 2
        mov     eax, dword ptr[regs+a[ebx]]
        LOAD_W_MEDI
        rol     ax, 1
        MAKE_SR_J
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e7e0         ENDP

op_e7e8         PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        add     eax, dword ptr[regs+a[ebx]]
        LOAD_W_MEDI
        rol     ax, 1
        MAKE_SR_J
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e7e8         ENDP

op_e7f0         PROC
        and     ebx, 7
        mov     ax, word ptr[edi+2]
        shl     ebx, 2
        add     dword ptr[regs+pc], 2
        push    dword ptr[regs+a[ebx]]
        xchg    ah, al
        GET_DISP_EA
        LOAD_W_MEDI
        rol     ax, 1
        MAKE_SR_J
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e7f0         ENDP

op_e7f8         PROC
        mov     ax, word ptr[edi+2]
        add     dword ptr[regs+pc], 2
        xchg    ah, al
        cwde
        LOAD_W_MEDI
        rol     ax, 1
        MAKE_SR_J
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e7f8         ENDP

op_e7f9         PROC
        mov     eax, dword ptr[edi+2]
        add     dword ptr[regs+pc], 4
        bswap   eax
        LOAD_W_MEDI
        rol     ax, 1
        MAKE_SR_J
        xchg    ah, al
        mov     word ptr[edi], ax
        ret
op_e7f9         ENDP

_TEXT ENDS

   END
